import java.io.*;
import java.util.*;
import sguide.SmartGuideExit;
import sguide.XVariableSet;
import sguide.XVariableInterface;

public class initializeProperties implements SmartGuideExit
{
  public static final String COPYRIGHT = "(C) Copyright IBM Corp. 1998.  All rights reserved.";

  public static final String LONG_COPYRIGHT =
                      "Licensed Materials - Property of IBM" +
                      "\nIBM XML Enabler" +
                      "\n(C) Copyright IBM Corp. 1998.  All rights reserved." +
                      "\n\nUS Government Users Restricted Rights - Use, duplication, or" +
                      "\ndisclosure restricted by GSA ADP Schedule Contract with IBM Corp.";

  public String go(XVariableSet variables,
                   Hashtable objects,
                   String arguments)
  {
    FileInputStream propFile = null;
    Properties prop = null;

    try
    {
      propFile = new FileInputStream("xmlEnabler.txt");
      prop = new Properties(System.getProperties());
      prop.load(propFile);
    }
    catch (java.io.IOException ioe) { }

    XVariableInterface xvi = variables.lookup("default");
    xvi.setValue(prop.getProperty("Default"));
    
    String searchList = prop.getProperty("Order");
    String editlistValue = new String();
    if (searchList != null)
    {
      String nextBrowserType;
      StringTokenizer st = new StringTokenizer(searchList, "/");
      while (st.hasMoreTokens())
      {
        String nextSearchString = "";
        nextBrowserType = st.nextToken();
        nextSearchString = prop.getProperty(nextBrowserType);
        if (nextSearchString != null)
          editlistValue += nextBrowserType + "|" + nextSearchString + "|";
      }
    }

    xvi = variables.lookup("mappings");
    xvi.setValue(editlistValue);

    return "";
  }
}

