package gs.admin;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;
import  dom.DOMWriter;

//XML-end

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.db.xdatabase;
import gs.xml.dbXML2;

import java.util.Enumeration;
import java.util.Hashtable;

/**
 */
public class xGeneric extends HttpServlet {

    /**
     * Service the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */
  String SERVICESTATION;
  public static gSystem  sys=new gSystem();
  public static String XSLHOME =sys.localdir+sys.htdocs;

  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // service: processInOut (this is rarely overriden but we do not need get or post, 
  // and overhead of getlastmodified
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  

  public void service (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out = response.getOutputStream();
    PrintWriter printer = new PrintWriter(response.getWriter());

    String unum    = req.getParameter("unum"); 
    String command = req.getParameter("comm"); 
    String course  = req.getParameter("course");

    System.out.println( SERVICESTATION+":command  ------> {"+command+"}" + "       unum  ------> {"+unum+"}" );

    try {
      if (unum==null) 
	throw new Exception("State lost: Unknown  user!.");
      else if ( course==null ) {
	String coursename  = req.getParameter("coursename");
	if (coursename==null ) 
	  throw new Exception("State lost: Unknown course or user!.");
	String term    = req.getParameter("term");
	String year    = req.getParameter("year");
	course=coursename+term+year;
      }
      if (command==null) command = req.getParameter("dcomm"); 
      if (command!=null) {
	if (command.equals("RETURN")) 
	  returnPage( printer,  unum,course, req.getPathTranslated() );
	else {
	  //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
	  //ASK PERMISSION above does not ask any permission
	  //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
	  sys.accessPermission(unum,course,SERVICESTATION+":"+command);
	  //if (unum.equals("msen") || unum.equals("1"));
	  //else   {printer.println("<h1>Test in progress! Visit later...."); return;}
	  //SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS
	  serveCommand(printer, unum, course,command,req);
	}
      }
    } 
    catch (Exception e) {
      System.out.println( "\n*!*Xx!@~`x--!/\\% Error catched. \n" );
      sys.error(out,e);
      e.printStackTrace();
      e.printStackTrace(printer); // Post our exception back to the web page
    }
    printer.flush();
    out.flush();
    printer.close();
    out.close();
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  //    serveCommand
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  serveCommand(PrintWriter printer,String unum,String course,String command,HttpServletRequest req) throws Exception{}


  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  //   Reads Student fields from the html request form
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  public Hashtable readFields(HttpServletRequest req) throws Exception {
    //System.out.println("READING FIELDS..");
    Hashtable fields = new Hashtable();

    Enumeration values = req.getParameterNames();
    while(values.hasMoreElements()) {
      String name = (String)values.nextElement();
      String value = req.getParameterValues(name)[0];
      value.replace('\'','`');
      fields.put(name,value);
      //System.out.println(name + ": " + value);
    }
    //System.out.println("READ.");
    return fields;
  }

  //--------------------------------------------------------------------//
  //Reads Student fields from the html request form
  //--------------------------------------------------------------------//
  public xdatabase cgi2Obj(HttpServletRequest req,xdatabase q) throws Exception {
    q.fields=readFields(req);
    try 
      { 
	q.setIdentification();
      } 
    catch (Exception e) 
      {
	throw new Exception("Please enter  all the fields in red!");
      }
    return q;
  }



  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  //     returnPage
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  void  returnPage(PrintWriter printer, String unum, String course,String xslfile)
       throws Exception, IOException 
  {
    // System.out.println("<RETURNING A PAGE> "+xslfile);
    Document d=sys.xml.giveMeEmptyDocument(); 
    sys.xml.addMyTextNode(d,sys.xml.makeMeRoot(d,"course"),"coursename",course);
    sys.addGlobalTree(d);
    sys.addUserTree(d,unum);
    System.out.println("--returnPage--------------------------------------------------[ "+xslfile+" ]");
    new dom.DOMWriter("Default",false).print(d);      
    System.out.println("\n----------------------------------------------------[ "+xslfile+" ]");
    Document xsl= sys.p.parseXML(xslfile,0);
    sys.p.process(d, xsl, sys.resultns, printer);   
  }   

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  //     parseXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public static String    resultns = new String("DEBUG");  
  public static Hashtable    xht = new Hashtable();  
  void parseXML (PrintWriter printer, String unum, Document d, String XSL, String function)
       throws Exception,IOException
  {
    //System.out.println("\n * BEGIN:parseXML: "+XSL+":"+function);
    //   sys.initializeXML() ;
    if (XSL==null) XSL= "";  
    sys.addGlobalTree(d);
    sys.addUserTree(d,unum);
    sys.addFunction(d,function);
    System.out.println("------parsexml--------------------------------------------[ "+function+" ]");
    new dom.DOMWriter("Default",false).print(d);      
    System.out.println("\n--------------------------------------------------[ "+function+" ]");
    String xslfile=sys.xml.getXSLFile2(d,XSL);
    Document xsl=(Document) xht.get(xslfile);
    if (xsl==null) {
      xsl= sys.p.parseXML(XSLHOME+xslfile,0);
      xht.put(xslfile,xsl);
    }
    // sys.p.process(d, xsl, sys.resultns, printer);  
    ProcessXSL xmlProcessorLiason = new ProcessXSL(); 
    xmlProcessorLiason.m_use_validation = false;
    XSLProcessor p = new XSLProcessor(xmlProcessorLiason);
    p.process(d, xsl, resultns, printer);  
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  //     parseXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  void returnXML (PrintWriter printer,  String message,String XSL)
       throws Exception,IOException
  {
    //  sys.initializeXML() ;
    Document d=sys.xml.giveMeEmptyDocument(); 
    Element m=sys.xml.makeMeRoot(d,"message"); 
    sys.xml.addMyTextNode(d,m,"text"   ,message);
    String xslfile=dbXML2.getXSLFile(XSL);
    Document xsl= sys.p.parseXML(xslfile,0);
    System.out.println("----returnxml----------------------------------------------[]");
    new dom.DOMWriter("Default",false).print(d);      
    System.out.println("\n--------------------------------------------------[]");

    sys.p.process(d, xsl, sys.resultns, printer);   
  }

} //class close



//   //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//   //     parseXML
//   //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//   public static String    resultns = new String("DEBUG");  
//   public static Hashtable    xht = new Hashtable();  
//   void parseXML (PrintWriter printer, String unum, Document d, String XSL, String function)
//        throws Exception,IOException
//   {
//     //System.out.println("\n * BEGIN:parseXML: "+XSL+":"+function);
//     //   sys.initializeXML() ;
//     if (XSL==null) XSL= "";  
//     sys.addGlobalTree(d);
//     sys.addUserTree(d,unum);
//     sys.addFunction(d,function);
//     // System.out.println("--------------------------------------------------[ "+function+" ]");
//     //new dom.DOMWriter(false).print(d);      
//     //System.out.println("\n--------------------------------------------------[ "+function+" ]");
//     String xslfile=sys.xml.getXSLFile2(d,XSL);
//     Document xsl= xht.get(xslfile);
//     if (xsl==null) {
//       Document xsl= sys.p.parseXML(xslfile,0);
    
//     // sys.p.process(d, xsl, sys.resultns, printer);  
//     ProcessXSL xmlProcessorLiason = new ProcessXSL(); 
//     xmlProcessorLiason.m_use_validation = false;
//     XSLProcessor p = new XSLProcessor(xmlProcessorLiason);
//     p.process(d, xsl, resultns, printer);  
//   }
