package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.dbxml.dbxQuestion;
import gs.dbxml.dbxQB;


/**
 */
public class xQuestionBank extends xGeneric {

  /**
   * Service the request.
   *
   * @exception  ServletException if there is any sort of Exception
   *
   */

  public  xQuestionBank(){SERVICESTATION="XQB";}
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // serveCommand
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  serveCommand(PrintWriter printer,String unum,String course,String command,HttpServletRequest req) throws Exception{
    String quizname=req.getParameter("quizname");

    if(command.equals("QUESTIONBANKLIST")) 
      {
	//dbxQB dxq = new dbxQB();
	parseXML(printer,unum,dbxQB.dbxQB(course,quizname),"qbLIST","listQuestions");
      }
    else if(command.equals("METADATA"))
      {
	dbxQB dxq = new dbxQB(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"qbMETA","browseQuestion");
      }
    else if(command.equals("QUESTION"))
      {
	dbxQB dxq = new dbxQB(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"qbQUESTION","EditQuestion(xQuestionBank)");
      }
    else if(command.equals("PICK")) {
      // dbxQB.copyToQuiz(course,quizname,req.getParameter("qid"));
        parseXML(printer,unum, new dbxQB().copyToQuiz(course,quizname,req.getParameter("qid")),"qbCOPY","qbCOPY"); 
	// printer.println("<html><body bgcolor='white'> <h3> Question # "+req.getParameter("qid")+" copied to quiz "+quizname+".</body></html>");

    }
    else if(command.equals("NEW"))
      parseXML(printer,unum, new dbxQB().newQ(course,quizname),"qbEDIT_META","NewQuestion(xQuestionBank)"); 

    else if(command.equals("CANCEL")) 
      printer.println("<script language=JavaScript> history.go(-2);</script>");

    else if(command.equals("UPDATE")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"qbMETA","updateQuestion"); 

    else if(command.equals("SAVE")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"qbQUESTION","EditQuestion(xQuestionBank)"); 

    else if(command.equals("DELETEANSWER")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"qbQUESTION","EditQuestion(xQuestionBank)"); 
 
   else if(command.equals("ADDANSWER")) 
      parseXML(printer,unum,readQuestionFields(req).update(),"qbQUESTION","EditQuestion(xQuestionBank)"); 

    else if(command.equals("ADD")) 
      parseXML(printer,unum,readQuestionFields(req).add(),"qbMETA","addQuestion");  

    else if(command.equals("EDIT"))
      {
	dbxQB dxq = new dbxQB(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"qbEDIT_META","EditQuestion(xQuestionBank)");
      }
    else if(command.equals("DELETE")) 
      {
	dbxQB.delete(course,quizname,req.getParameter("qid"));
	printer.println("<b>Question information has been succesfully deleted!</b><script language=JavaScript> top.menu.document.location.reload();</script>");
      }
  }


  //--------------------------------------------------------------------//
  //Reads Student fields from the html request form
  //--------------------------------------------------------------------//
  public dbxQB readQuestionFields(HttpServletRequest req) throws Exception {
    dbxQB q=new dbxQB();
    q.fields=readFields(req);
    try 
      { 
	q.setIdentification();
      } 
    catch (Exception e) 
      {
	throw new Exception("Please enter  all the fields in red!");
      }
    return q;
  }

} //CLASS xQuestionBank.java close


