package gs.admin;

import org.w3c.dom.*;

import java.io.PrintWriter;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import gs.dbxml.dbxQuestion;
import gs.dbxml.dbxQB;



/**
 */
public class xQuestions extends xGeneric {

  /**
   * Service the request.
   *
   * @exception  ServletException if there is any sort of Exception
   *
   */
  public  xQuestions(){SERVICESTATION="XQUESTIONS";}
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // serveCommand
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  serveCommand(PrintWriter printer,String unum,String course,String command,HttpServletRequest req) throws Exception{
    String quizname=req.getParameter("quizname");
    if(command.equals("LISTQUESTIONS")) 
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname);
	parseXML(printer,unum,dxq.doc,"questionLIST","listQuestions");
      }
    else if(command.equals("METADATA"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"questionMETA","browseQuestion");
      }
    else if(command.equals("QUESTION"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"question","EditQuestion(xQuestions)");
      }
    else if(command.equals("JUSTQUESTION"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"question","browseQuestion(xQuestions)");
      }
    else if(command.equals("NEW"))
      parseXML(printer,unum,new dbxQuestion().dbxQuestion(course,quizname),"questionEDIT_META","NewQuestion(xQuestions)"); 

    else if(command.equals("CANCEL")) 
      printer.println("<script language=JavaScript> history.go(-2);</script>");

    else if(command.equals("UPDATE")) 
      parseXML(printer,unum,cgi2Obj(req,new dbxQuestion()).update(),"questionMETA","updateQuestion"); 

    else if(command.equals("SAVE")) 
      parseXML(printer,unum,cgi2Obj(req,new dbxQuestion()).update(),"question","EditQuestion(xQuestions)"); 

    else if(command.equals("DELETEANSWER")) 
      parseXML(printer,unum,cgi2Obj(req,new dbxQuestion()).update(),"question","EditQuestion(xQuestions)"); 
 
   else if(command.equals("ADDANSWER")) 
      parseXML(printer,unum,cgi2Obj(req,new dbxQuestion()).update(),"question","EditQuestion(xQuestions)"); 

    else if(command.equals("ADD")) 
      parseXML(printer,unum,cgi2Obj(req,new dbxQuestion()).add(),"questionMETA","addQuestion");  

    else if(command.equals("EDIT"))
      {
	dbxQuestion dxq = new dbxQuestion(course,quizname,req.getParameter("qid"));
	parseXML(printer,unum,dxq.doc,"questionEDIT_META","EditQuestion(xQuestions)");
      }
    else if(command.equals("DELETE")) 
      {
	dbxQuestion.delete(course,quizname,req.getParameter("qid"));
	printer.println("<b>Question information has been succesfully deleted!</b><script language=JavaScript> top.menu.document.location.reload();</script>");
      }
    else if(command.equals("RECYCLE"))
        parseXML(printer,unum, new dbxQB().copyFromQuiz(course,quizname,req.getParameter("qid")),"qbSTORE","qbSTORE"); 
  }

} //CLASS xQuestions close


