package gs.db;

//import gs.object.aUser;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;
import java.util.StringTokenizer;

public class dbSurvey extends database {

  public       String course;          //prim
  public       String surveyname;   //prim
  public       String  qid;             //prim

  static       String tablesurvey="surveys";

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbSurvey() {}
  public dbSurvey(String course) { this.course    =course;}
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbSurvey( String course,String surveyname,String qid)     
       throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE course='"+course+"'surveyname='"+surveyname+"' AND qid ="+ qid ;
  try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbSurvey:queryString:"+queryString);
      if( rs.next() )
	{
	  fields.put("course", null2str(rs.getString("course")));
	  fields.put("surveyname", null2str(rs.getString("surveyname")));
	  fields.put("qid", Integer.toString(rs.getInt("qid")));
	  fields.put("question", null2str(rs.getString("question")));
	  fields.put("category", null2str(rs.getString("category")));

	  setIdentification();
	} else {
	 
	  throw new Exception("dbSurvey:SurveyNotFound: Survey could not be found.(dbSurvey)");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void setIdentification(){

     this.qid     = (String) fields.get("qid");
     this.surveyname     = (String) fields.get("surveyname");
     this.course    = (String) fields.get("course");
 
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void makeSurvey(String course,String surveyname,String list) throws Exception
  {
    try {    removeSurvey(course,surveyname); }
    catch (Exception e){} 
    fields.put("course", course);
    fields.put("surveyname", surveyname);

    StringTokenizer st = new StringTokenizer(list);
    while (st.hasMoreTokens()) {
      qid=st.nextToken();
      dbQuestion q=new dbQuestion(qid);
      fields.put("qid",qid);
      fields.put("question", q.fields.get("question"));
      fields.put("category", q.fields.get("category"));
      add(); 
     }
    //System.out.println("PLEASE IMPLEMENT ME!!!, PLEASAE!!! I am makeSurvey");
    
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void removeSurvey(String course,String surveyname) throws Exception
  {
    String deleteStr="course='"+ course+"' AND surveyname='"+surveyname+"'"  ;
     String sqlcommand=deleteSQL(deleteStr);
    update.updateData(sqlcommand );
    update.updateData( "DELETE FROM answers WHERE "+deleteStr);
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String currentQuestionList(String course,String surveyname) throws Exception
  {
    String lst=" ";
    String fieldNames = getFieldNames();
    String queryProjection = "*";
    ResultSet rs = records(queryProjection,"course='"+course+"' AND surveyname='"+surveyname+"'","category,qid");
    while ( rs.next() )
      {
	lst+=" "+Integer.toString(rs.getInt("qid"));
      }
    return lst;
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public ResultSet  surveyQuestions(String course,String surveyname) throws Exception
  {


    String fieldNames = "qid,question,category";
    String queryProjection = fieldNames;
    ResultSet rs = records(queryProjection,"course='"+course+"' AND surveyname='"+surveyname+"'","category,qid");
    return rs;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  String  surveyQuestionsFields(String course,String surveyname) throws Exception
  {
    return "qid,question,category";
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void saveSurvey(String accesscode,String course,String surveyname,String survey)
       throws Exception
  {
 
    StringTokenizer st = new StringTokenizer(survey);
    while (st.hasMoreTokens()) {
      try {
	String open=st.nextToken();
	int  qid=Integer.parseInt(st.nextToken().substring(1));
	String answer=st.nextToken();
	String close=st.nextToken();
	String sql= "INSERT INTO answers  (course,surveyname,accesscode,qid,answer ) VALUES ('"+course+"','"+surveyname+"','"+accesscode+"',"+qid +",'"+answer+"')";
	update.updateData( sql);
      } catch (Exception e){} 
    }
  }




  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static Hashtable getFields(String course,String surveyname,String qid)  throws Exception
  {
    return new dbSurvey(course,surveyname,qid).getFields(); // super class' method
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("course",	""); 
    result.put("surveyname",	""); 
    result.put("question",	""); 
    result.put("qid",	""); 
    result.put("category",	""); 

    return result;
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String getTableName()
  {
    return tablesurvey;
  }
  
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String getFieldNames()
  {
    return "course,surveyname,qid,question,category";
  }

  // used in SQL INSERT command
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String getFieldValues()
  {
    return                           "'"+ 
      (String)fields.get("course")	+"','"+ 
      (String)fields.get("surveyname")	+"',"+ 
      (String)fields.get("qid")	+",'"+ 
      (String)fields.get("question")	+"','"+ 
      (String)fields.get("category")	
			 +"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "course='"          + (String)fields.get("course")
      +"',surveyname='"              + (String)fields.get("surveyname")
      +"',qid="              + (String)fields.get("qid")
      +",question='"              + (String)fields.get("question")
      +"',category='"              + (String)fields.get("category") 
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \

  //CONSIDER LATER
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String updateSQL()   {
    return updateSQL("course='"+course+"' AND  surveyname='"+surveyname+"' AND qid="+qid );
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void update()throws Exception {
      update.updateData( updateSQL() );
  }

/*  public static void  delete(String _qid) throws Exception{
    String sqlcommand=new dbSurvey().deleteSQL("qid="+ _qid );
    update.updateData(sqlcommand );
  }
  
  public static void  deleteList(String list) throws Exception{
    String sqlcommand=new dbSurvey().deleteSQL(list);
    update.updateData(sqlcommand );
  }
  
  //CONSIDER LATER
  public String deleteSQL() {
    return deleteSQL("qid="+ qid +"");
  }
  */
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void add()throws Exception {
    try {
      update.updateData( insertSQL() );
    } catch (Exception e) {
      //System.out.println("INSERT EDEMEDIM ****************");
	update();
    }
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public   ResultSet listSurveys( boolean allFields) throws Exception
  {
      String queryProjection ="DISTINCT surveyname";
      if(allFields) 	{
	queryProjection = "*";
      }
      return records(queryProjection,"course='"+course+"'","");
  }
  public     String  listSurveysFields(boolean allFields ) throws Exception
  {
    if(allFields) 	
      return getFieldNames();
    return "surveyname";
  }
  

}







