package gs.db;

//import gs.object.aUser;
import gs.db.database;
import gs.db.query;
import gs.db.U;
import java.util.Hashtable;
import java.sql.ResultSet;



public class dbUser extends database {

  public       String gslogin;          // unique key
  public       String gspwd    ;
  public       String idnum;
  static String tablename="users";

  public dbUser() {}
  public dbUser( String login )        throws Exception
  {
    String queryString = "SELECT * from "+ getTableName() +
       " WHERE gslogin ='"+ login +"'";
  try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbUser:queryString:"+queryString);
      if( rs.next() )
	{
	  fields.put("gslogin", null2str(rs.getString("gslogin")));
	  fields.put("gspwd", null2str(rs.getString("gspwd")));
	  fields.put("idnum", null2str(rs.getString("idnum")));
	  fields.put("ACL", null2str(rs.getString("ACL")));
	  fields.put("privilige", null2str(rs.getString("privilige")));
	  fields.put("firstname", null2str(rs.getString("firstname"))); 
	  fields.put("midname", null2str(rs.getString("midname")));
	  fields.put("lastname", null2str(rs.getString("lastname"))); 
	  fields.put("email", null2str(rs.getString("email"))); 
	  fields.put("dept", null2str(rs.getString("dept"))); 
	  fields.put("url", null2str(rs.getString("url"))); 
	  fields.put("picurl", null2str(rs.getString("picurl"))); 
	  fields.put("phone", null2str(rs.getString("phone"))); 
	  fields.put("room", null2str(rs.getString("room"))); 
	  fields.put("systemslogin", null2str(rs.getString("systemslogin"))); 
	  fields.put("comments", null2str(rs.getString("comments"))); 
	  fields.put("reserved", null2str(rs.getString("reserved"))); 
	  setIdentification();
	} else {
	 
	  throw new Exception(":UserNotFound: User is not a valid user in the current DataBase!.");
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }
  
  public void setIdentification(){

     this.gslogin     = (String) fields.get("gslogin");
     this.gspwd     = (String)fields.get("gspwd"); 
     this.idnum     = (String)fields.get("idnum"); 

  }
  public void setidnum(String idn){
    fields.put("idnum", idn);
    this.idnum     = idn;
  }
  public static String checkUserID (String id) throws Exception {
    String queryString = "SELECT gslogin from "+ tablename +
       " WHERE idnum ='"+ id +"'";
    try {
      ResultSet rs = query.queryData( queryString );
      //System.out.println("dbUser:queryString:checkUserID:"+queryString);
      if( rs.next() )
	{
	  return null2str(rs.getString("gslogin"));
	} else {
	  return null;
	}
    } catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
  }

  public static boolean existence(String loginid) throws Exception{
    String queryString = "SELECT gslogin from "+ tablename +      " WHERE gslogin ='"+loginid  +"'";
    ResultSet rs = query.queryData( queryString );
    if( rs.next() )
      return true;
    return false;
  }

  public String postOffice(String course) throws Exception {
    String queryString = "SELECT firstname, midname, lastname,email,url,picurl, privilige from "+ tablename +  " WHERE ACL like '%"+course +"%' ORDER BY lastname,firstname";
    String out="";
    try {
      ResultSet rs = query.queryData( queryString );
      while (rs.next() ) {
	
	int prv = (int)rs.getInt("privilige");
	//if (prv <U.INSTRUCTOR || prv > U.TA)
	if (prv ==U.SUPERVISOR)
	  continue;
	out+="recipient[n++] = new Recipient('"+
	  null2str(rs.getString("firstname"))+" "+
	  null2str(rs.getString("midname"))+" "+ 
	  null2str(rs.getString("lastname"))+"' ";
	
	if (prv==U.TA)
	  out+=",'TAs',"+"'"; 
	else if ( prv!=U.SYSTEM) //if (prv >= U.INSTRUCTOR && prv < U.TA)
	  out+=",'Faculty',"+"'"; 
	out+=null2str(rs.getString("url"))+"','"+ 
	  null2str(rs.getString("picurl"))+"','"+ 
	  null2str(rs.getString("email"))+"');";
      }
    }catch(Exception e) {
      //e.printStackTrace();
      throw e;
    }
    return out;
  }

  //--------------------------------------------------------------------//
  // findRestrictedList
  //--------------------------------------------------------------------//  
  public static String findRestrictedList(String acl)throws Exception{
     String rcl="";
     String queryString = "SELECT title FROM courses ORDER BY title";
     ResultSet rs = query.queryData( queryString );
     while (rs.next() ) {
	 String course=null2str(rs.getString("title"));
	 if ( acl.indexOf(course) <0)
	   rcl+="<OPTION>"+course;
     }
	   
    return rcl;
  }





  public static Hashtable getFields(String login)  throws Exception
  {
    return new dbUser(login).getFields(); // super class' method
  }

  public static Hashtable getEmptyFields()
       throws Exception
  {
    Hashtable result = new Hashtable();
    result.put("gslogin", "");
    result.put("gspwd", "");
    result.put("idnum", "");
    result.put("privilige", "5"); 
    result.put("ACL", ""); 
    result.put("firstname", ""); 
    result.put("midname", "");
    result.put("lastname", ""); 
    result.put("email", ""); 
    result.put("dept", ""); 
    result.put("url", ""); 
    result.put("picurl", ""); 
    result.put("phone", ""); 
    result.put("room", ""); 
    result.put("systemslogin","" ); 
    result.put("comments","" ); 
    result.put("reserved","" ); 

    return result;
  }

  public String getTableName()
  {
    return tablename;
  }
  //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  // used in SQL INSERT command
  public String getFieldNames()
  {
    return "gslogin,gspwd,idnum,"+
      "privilige,ACL,"+
      "firstname,midname,lastname,"+
      "email,dept,url,picurl,phone,room,systemslogin,"+
      "comments,reserved";
  }

  // used in SQL INSERT command
  public String getFieldValues()
  {
    return                           "'"+ 
      (String)fields.get("gslogin")          +"','"+ 
      (String)fields.get("gspwd")            +"','"+ 
      (String)fields.get("idnum")            +"','"+ 
      (String)fields.get("privilige")        +"','"+
      (String)fields.get("ACL")              +"','"+
      (String)fields.get("firstname")        +"','"+
      (String)fields.get("midname")          +"','"+ 
      (String)fields.get("lastname")         +"','"+ 
      (String)fields.get("email")            +"','"+
      (String)fields.get("dept")             + "','"+
      (String)fields.get("url")              +"','"+ 
      (String)fields.get("picurl")           +"','"+
      (String)fields.get("phone")            +"','"+
      (String)fields.get("room")             +"','"+
      (String)fields.get("systemslogin")     +"','"+
      (String)fields.get("comments")         +"','"+
      (String)fields.get("reserved")         +"'";
  }

  //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  // used in SQL UPDATE command
  public String getSetValues()
  {
    return "gslogin='"          + (String)fields.get("gslogin")
      +"',gspwd='"              + (String)fields.get("gspwd") 
      +"',idnum='"              + (String)fields.get("idnum") 
      +"',privilige='"          + (String)fields.get("privilige") 
      +"',ACL='"                + (String)fields.get("ACL") 

      +"',firstname='"          + (String)fields.get("firstname") 
      +"',midname='"            + (String)fields.get("midname") 
      +"',lastname='"           + (String)fields.get("lastname")
      +"',email='"              + (String)fields.get("email") 
      +"',dept='"               + (String)fields.get("dept") 
      +"',url='"                + (String)fields.get("url") 
      +"',picurl='"             + (String)fields.get("picurl") 
      +"',phone='"              + (String)fields.get("phone") 
      +"',room='"               + (String)fields.get("room") 

      +"',systemslogin='"       + (String)fields.get("systemslogin") 
      +"',comments='"           + (String)fields.get("comments")
      +"',reserved='"           + (String)fields.get("reserved") 
      +"'";
  }
  //_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
  //            OPERATIONS
  // \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \

  //CONSIDER LATER
  public String updateSQL()   {
    String oldgslogin=(String)fields.get("oldgslogin");
    return updateSQL("gslogin='"+oldgslogin  +"'");
  }
  public void update()throws Exception {
      update.updateData( updateSQL() );
  }

  public static void  delete(String _login) throws Exception{
    String sqlcommand=new dbUser().deleteSQL("gslogin='"+ _login +"'");
    update.updateData(sqlcommand );
  }
  //CONSIDER LATER
  public String deleteSQL() {
    return deleteSQL("gslogin='"+ gslogin +"'");
  }

  public void add()throws Exception {
      update.updateData( insertSQL() );
  }

}







