package gs.db;
import gs.util.Util ;
//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


import gs.xml.dbXML2;
//XML-end

import gs.db.update;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

public abstract class xdatabase extends database{

  public   String tablename  ;
  public   String allfields ;
  public   String [] all    ;
  public   String [] q     ;
  public   String [] keys  ;
  public   String [] normal ;
  public   String [] critical;
  static public    dbXML2      dbx = new dbXML2();

  public xdatabase() 
  {
    defineObject();
  }
  abstract public void setIdentification()throws Exception;
  abstract public void  defineObject();
  abstract public void  reload()throws Exception;
  abstract public Document  generateDocument()throws Exception ;
  abstract public String updateSQL()  throws Exception ;
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@  fields @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public  String getTableName()
  {
    return tablename;
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public String getFieldNames() //used in SQL INSERT command
  {
    return allfields;
  }

//   // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
//  public String getFieldValues()  // used in SQL INSERT command
//   { 
//     String rstr=" ";
//     if (has(all[0])) 
//       rstr=q[0]+ getS(all[0])+q[0];
//     else rstr="NULL";
//     for (int i=1;i<all.length;i++) 
//       if (has(all[i]))
// 	rstr+=","+q[i]+ hasval +q[i];
//       else rstr+=",NULL";
//     //      rstr+=","+get(all[i],q[i]);
//     //System.out.println("CHECK+++++getFieldValues>>"+rstr);
//    return   rstr;
//   }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
 public String getFieldValues()  // used in SQL INSERT command
  { 
    String rstr=" "+get(all[0],q[0]);
    for (int i=1;i<all.length;i++) 
      rstr+=","+get(all[i],q[i]);
   //System.out.println("CHECK+++++getFieldValues>>"+rstr);
   return   rstr;
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public String getSetValues() //  used in SQL UPDATE command
  {
    String rstr=" ";
    if (has(all[0]))
      rstr=" "+ all[0]+"="+q[0]+ hasval+q[0];

    for (int i=1;i<all.length;i++)
      if (has(all[i]))
	rstr+=","+all[i]+"="+q[i]+ hasval +q[i];
    //System.out.println("CHECK+++++getSetValues>>"+rstr);
    return   rstr;
  }
  public void fillFields (ResultSet rs) throws Exception{
    if ( rs.next() ) 
      {
	for (int i=0;i<all.length;i++) 
	  if (q[i].equals("'"))
	    { try { fields.put(	all[i] ,Util.null2str(rs.getString(all[i])));}
	    catch (Exception e){fields.put(	all[i] ,"");}
	    //System.out.print("---fillFields--***-->"+all[i] +"   "+Util.null2str(rs.getString(all[i])));
	    }
	  else fields.put(all[i] ,Integer.toString(rs.getInt(all[i])));
	for (int i=0;i<critical.length;i++)
	  fields.put(	critical[i] ,Util.null2str(rs.getString(critical[i])));
      } else	{	
	throw new Exception("GS:"+tablename+":NotFound: Record  could not be found!");
      }
  }
  public void addSelectedFields(Document d,Element baba,ResultSet rs, String [] selected,String [] q) throws Exception{
     for (int i=0;i<selected.length;i++)
         if (q[i].equals("'"))
	   dbx.addMyTextNode(d,baba,selected[i]  ,Util.null2str(rs.getString(selected[i])));
	 else dbx.addMyTextNode(d,baba,selected[i]  ,Integer.toString(rs.getInt(selected[i])));
  }
  public void addNormalTextFields(Document d,Element baba,ResultSet rs) throws Exception{
     for (int i=0;i<normal.length;i++)
	dbx.addMyTextNode(d,baba, normal[i]  ,Util.null2str(rs.getString(normal[i])));
  }
  public void 	addSubTree(Document d,Element baba,ResultSet rs) throws Exception{
    for (int i=0;i<critical.length;i++) {
      dbx.addMySubTree(d,baba,Util.null2str(rs.getString(critical[i])));
    }
  }
  public void addNormalTextFields(Document d,Element baba) throws Exception{
     for (int i=0;i<normal.length;i++)
	dbx.addMyTextNode(d,baba, normal[i]  ,getS(normal[i]));
  }
  public void 	addSubTree(Document d,Element baba) throws Exception{
     for (int i=0;i<critical.length;i++)
	dbx.addMySubTree(d,baba,getS(critical[i]));
  }
   public void 	     addLayouts(Document d,Element dad,String course,String layoutstr)throws Exception{
     //GET available  XSL LAYOUTS
     Element layouts=dbx.availableLayouts(d,layoutstr);
     Element currentLayout=dbx.getLayout(d,course,layoutstr);
     layouts.appendChild(currentLayout);
     dad.appendChild(layouts);
   }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@  fields  end @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
 //==============add===========================================================ADD== 
  public Document  add()throws Exception {
    try {
      update.updateData( insertSQL() );
    }
    catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	String key="[ ";
	for (int i=0;i<keys.length;i++)
	  key+=keys[i]+" ";
	key+="]";
	error= new String("<b>ERROR [134]</b>: This record key "+key+" exists in the system. <br> Please try another one.!");
	e= new Exception(error);
      }
      throw e;
    }    
    // generateDocument();
    //put into cache
     return generateDocument(); //doc;
  }
  //=====================================================================UPDATE===
  public void updateDocument2DB()throws Exception {
    update();
    //update  in cache
  }

  //=============update========================================================UPDATE===
  abstract public void sideEffectsUPDATE()throws Exception ;
  public Document update()throws Exception {
    //System.out.println("BEGIN:update"); 
     try {
      update.updateData( updateSQL() );
    }
     catch( Exception e ) {
       String error =e.getMessage();
       if (error.indexOf("unique") >=0) {
	 String key="[ ";
	 for (int i=0;i<keys.length;i++)
	   key+=keys[i]+" ";
	 key+="]";
	 error= new String("<b>ERROR [133]</b>: Another record key"+key+" exists in the system. <br> Please try non-existing  one.!");
       }
       throw new Exception(error);
     }    
     //generateDocument();
     //put into cache
     //System.out.println("END:update"); 
     sideEffectsUPDATE();
     reload();
     return generateDocument();//doc;
  }
  


}
