########################################################################
########################################################################
########################################################################
########################################################################
########################################################################
#-------------------------xquestions-----------------------------------#
########################################################################

CREATE TABLE xquestions (
	course			char(50) NOT NULL,
	quizname		char(50) NOT NULL,
	qid			int NOT NULL,
	category		CHAR(40),
	qset			CHAR(30),
	qtitle			char(200),
	type			CHAR(20),
	points			int,
	qtext		        CHAR(1000),
	detail			CHAR(5000),
	option			CHAR(2000)
	
) \g
CREATE UNIQUE  INDEX index_xquestions ON xquestions (
        course,quizname,qid			    ) \g


#drop table xquestions\g
select * from xquestions\g
delete from xquestions where qid=-1\g

########################################################################
########################################################################
########################################################################
########################################################################
########################################################################
#--------------------------XQUESTIONBANK-------------------------------#
########################################################################

CREATE TABLE xqbank (
	qid 		        int NOT NULL,
	category		CHAR(40)  NOT NULL,
	qset			CHAR(30),
	qtitle			char(200) NOT NULL,
	type			CHAR(20),
	points			int,
	qtext		        CHAR(1000),
	detail			CHAR(5000),
	option			CHAR(2000)
	
) \g
CREATE UNIQUE  INDEX index_xqbank ON xqbank (
        	qid                         ) \g

drop table xqbank \g
########################################################################
########################################################################
########################################################################
########################################################################
#---------------------------QUIZZES------------------------------------#
########################################################################

CREATE TABLE quizzes (
  course    	CHAR(50) NOT NULL,
  quizname  	CHAR(50) NOT NULL,
  starttime	CHAR(21),
  endtime	CHAR(21),
    startyear	CHAR(10),
    startmonth	CHAR(10),
    startday	CHAR(10),
    starthour	CHAR(10),
    startmin	CHAR(10),
    endyear	CHAR(10),
    endmonth	CHAR(10),
    endday	CHAR(10),
    endhour	CHAR(10),
    endmin	CHAR(10),
  duration	CHAR(10),
  points	CHAR(5),
  publish	CHAR(3),
  xslfile	CHAR(200),
  settings	CHAR(2000),
  public	CHAR(2000),
  private	CHAR(2000)

) \g

CREATE UNIQUE  INDEX index_quizzes ON quizzes (
        course,
        quizname
) \g


#drop table quizzes \g
select quizname,course from quizzes \g
delete from quizzes where quizname='popquiz6'\g
delete from quizzes where quizname='popquiz7'\g
delete from quizzes where quizname='popquiz8'\g

########################################################################
########################################################################
########################################################################
########################################################################
--------------------------exam_answers----------------------------6---\g
CREATE TABLE exam_answers	(
	
	course			char(50) NOT NULL,
	quizname		char(50) NOT NULL,
	accesscode		char(20) NOT NULL,
	qid			int NOT NULL,
	answer			char(2000)
)\g
CREATE UNIQUE  INDEX index_exam_answers ON exam_answers (
        course,quizname,accesscode,qid	) \g

#drop table exam_answers  \g
########################################################################
########################################################################
########################################################################
########################################################################
------------------------------exam_g-grades-------------------/------9-\g

CREATE TABLE exam_grades
	(accesscode      	char(20) NOT NULL,
	course			char(50) NOT NULL,
	quizname		char(50) NOT NULL, 
	grade			int,
	points			int
 ) \g
CREATE UNIQUE  INDEX index_exam_grades ON exam_grades (
        accesscode,course,quizname	) \g

#drop table exam_grades  \g














