package gs.dbxml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


//import gs.xml.dbXML;
//XML-end
//import gs.conf.default;
import gs.db.update;
import gs.db.xdatabase;   
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;



public class dbxQB extends xdatabase {
  public   String    course   ; //sill
  public   String    quizname   ; //sill
  public   String    qid         ;// unique key
  
  public   static Document   doc;
  static   String tablename  ="xqbank";
  static   String [] all     ={"qid","category","qset","qtitle","type","points","qtext","detail","option"};
  static   String [] q       ={"","'","'","'","'","","'","'","'"};
  static   String [] keys    ={"qid"};
  static   String [] normal  ={"category","qset","qtitle","type","points","qtext","detail","option"};
  static   String [] critical={"detail","option"};

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void defineObject(){
    super.tablename=tablename;
    super.all=all;
    super.q=q;
    super.keys=keys;
    super.normal=normal;
    super.critical=critical;
    super.allfields=all[0];
    for (int i=1;i<all.length;i++)
      super.allfields+=","+all[i];
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void setIdentification() throws Exception{
     this.qid       = getS("qid"); 
     if(qid.equals("") ) 
       throw new Exception("Key fields are empty!");
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbxQB(){}
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbxQB(String course) throws Exception{

    ResultSet rs = select(" ORDER BY category,qtitle");

    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    Element qb= dbx.addMyNode(d,crs,"questionbank");
    while ( rs.next() ) {
      Element question= dbx.addMyNode(d,qb,"question");
      String qid = Integer.toString(rs.getInt("qid"));
      dbx.addMyTextNode(d,question,"qid",qid);
      addNormalTextFields(d,question,rs);
      addSubTree(d,question,rs);
    }
    addLayouts(d,crs,"all","qb");
    doc= d;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  static Document dbxQB( String course,String quizname ) throws Exception{

    dbxQB o=new dbxQB(course);
    Document d=o.doc;
    Element crs=doc.getDocumentElement();

    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element quiz= dbx.addMyNode(d,crs,"quiz");
    dbx.addMyTextNode(d,quiz,"quizname"   ,quizname);
    //dbx.addMySubTree(d,crs,state);
    return  d;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  dbxQB( String _course,String _quizname,String _qid ) throws Exception
  {
    
    ResultSet rs = select("WHERE   qid="+ _qid);
    
    this.course=_course;
    this.quizname=_quizname;
    this.qid=_qid;

    // if in cache 
    //    doc=cache;
    // return;
    fillFields(rs);
    generateDocument();
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void reload() throws Exception
  {
    ResultSet rs = select("WHERE qid="+qid );
    fillFields(rs);
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String nextQid() throws Exception{
    ResultSet rs = records("qid", "","qid DESC ");
    if ( rs.next() ) 
      return Integer.toString(1+rs.getInt("qid"));
    return "0";
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public Document newQ ( String course,String quizname ) throws Exception{
    this.course=course;
    this.quizname=quizname;
    fields.put("course", course);
    fields.put("quizname",quizname );
    fields.put("points","0" );
    
    qid=nextQid();

    fields.put("qid",qid );
    setIdentification();
    return generateDocument();
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  Document  copyToQuiz( String course,String quizname,String qid ) throws Exception{
//     this.course=course;
//     this.quizname=quizname;
//     this.qid=qid;
    fields.put("course", course);
    fields.put("quizname",quizname );

    ResultSet rs = select("WHERE   qid="+ qid);
    fillFields(rs);
    doc=generateDocument();

    dbxQuestion q=new dbxQuestion();
    q.fields=fields;

    q.fields.put("course", course);
    q.fields.put("quizname",quizname );
    q.fields.put("qid", q.nextQid());
    q.add();

    return doc;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // generateDocument
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document generateDocument() throws Exception {
    //System.out.println("BEGIN:generateDocument");
    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,getS("course"));
    Element quiz= dbx.addMyNode(d,crs,"quiz");
    dbx.addMyTextNode(d,quiz,"quizname"    ,getS("quizname"));
    Element question= dbx.addMyNode(d,quiz,"question");
    dbx.addMyTextNode(d,question,"qid"     ,getS("qid"));
    addNormalTextFields(d,question);
    addSubTree(d,question);
    addLayouts(d,crs,"all","qb");
    doc=d;
    return doc;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2DB
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  convert2DB()throws Exception  {}
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@ operations @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  //====================================================================delete====== 
  public  static void  delete(String _course,String _quizname,String _qid) throws Exception{
    String deleteStr= " qid="+_qid ;
    update.updateData( "DELETE FROM "+tablename+" WHERE "+deleteStr);
  }
  //=====================================================================UPDATE===
  // CONSIDER LATER
  public String updateSQL()  throws Exception {
    String   oldqid  =getS("oldqid",qid);  
    if (!oldqid.equals(qid)) {}
    return updateSQL("  qid="+oldqid );
  }
}





