package gs.dbxml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


//import gs.xml.dbXML;
//XML-end
//import gs.conf.default;
import gs.db.update;
import gs.db.xdatabase;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

import java.util.Calendar;
import java.util.Date;

public class dbxQuiz extends xdatabase {

  public   String     course  ;          // unique key
  public   String     quizname          ;// unique key
  public   Document   doc;
  public   Element   quiz;

  static   String  tablename="quizzes";  

  static   String [] all     ={"course","quizname","starttime","endtime","startyear","startmonth","startday","starthour","startmin","endyear","endmonth","endday","endhour","endmin","duration","points","publish","xslfile","settings","public","private"};

  static   String [] q       ={"'","'","'","'","'","'","'","'","'","'","'","'","'","'","'","'","'","'","'","'","'"};
  static   String [] keys    ={"course","quizname"};
  static   String [] normal  ={"course","quizname","starttime","endtime","startyear","startmonth","startday","starthour","startmin","endyear","endmonth","endday","endhour","endmin","duration","points","publish","xslfile","public","private"};
  static   String [] critical={"settings"};


  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  public void defineObject(){
    super.tablename=tablename;
    super.all=all;
    super.q=q;
    super.keys=keys;
    super.normal=normal;
    super.critical=critical;
    super.allfields=all[0];
    for (int i=1;i<all.length;i++)
      super.allfields+=","+all[i];
  }

  public void setIdentification(){
     this.quizname     = getS("quizname"); 
     this.course     = getS("course"); 
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbxQuiz() {}

  public dbxQuiz(String course) throws Exception{ 
    fields.put("course", course);
    fields.put("quizname","--!NEW!--" );
    setIdentification();
    generateDocument();
  }

  public  dbxQuiz( String _course,String _quizname ) throws Exception
  {
    this.course=_course;
    this.quizname=_quizname;
    // if in cache 
    //    doc=cache;
    // return;

    ResultSet rs = select(" WHERE  course='"+_course+"' AND quizname='"+ _quizname +"'");
    fillFields(rs);
    generateDocument();
  }
  public  void reload() throws Exception
  {
    ResultSet rs = select(" WHERE  course='"+course+"' AND quizname='"+ quizname +"'");
    fillFields(rs);
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // QuizInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document QuizInXML(  )        throws Exception
  {
    //get from  cache 
    if (doc==null) {
      convert2XML(  ) ; //put into cache
    }
    return doc;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // generateDocument
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document generateDocument() throws Exception {
    System.out.println("BEGIN:generateDocument");
      Document d=dbx.giveMeEmptyDocument(); 
      Element crs=dbx.makeMeRoot(d,"course"); 

      dbx.addMyTextNode(d,crs,"coursename"   ,course);
      
      Element quiz= dbx.addMyNode(d,crs,"quiz");
      this.quiz=quiz;
      addNormalTextFields(d,quiz);
      addSubTree(d,quiz);
      addLayouts(d,crs,course,"quiz");
      doc=d;
      System.out.println("END:generateDocument");   
      return doc;
    }



  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2XML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document convert2XML(  )        throws Exception
  {
    course= getS("course");
    quizname=getS("quizname");
    String starttime  = getS("starttime");
    String endtime    = getS("endtime");
    String duration   = getS("duration");
    String points     = getS("points");
    String xslfile   = getS("xslfile"); //luxury
    //String qexslfile   = getS("exslfile"); //luxury
    String settings   = getS("settings");
    String additional = getS("additional");

    Document d=dbx.giveMeEmptyDocument();  
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element quiz= dbx.addMyNode(d,crs,"quiz");
    dbx.addMyTextNode(d,quiz,"quizname"   ,quizname);
    dbx.addMyTextNode(d,quiz,"duration"   ,duration);
    dbx.addMyTextNode(d,quiz,"points"     ,points);
    dbx.addMyTextNode(d,quiz,"xslfile"    ,xslfile);
    dbx.addMySubTree(d,quiz,settings);
    //dbx.addMyTextNode(d,quiz,"settingsI"  ,settingsI);
    dbx.addMyTextNode(d,quiz,"additional" ,additional);
    //GET available  XSL LAYOUTS
    Element layouts=dbx.availableLayouts(d,"quiz");
    Element currentLayout=dbx.getLayout(d,course,"quiz");
    layouts.appendChild(currentLayout);
    crs.appendChild(layouts);
  
    doc=d;
    return doc;
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2DB
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  convert2DB(  )        throws Exception
  {
    Element p=doc.getDocumentElement() ;
    course= dbx.getVal(p,"/course/coursename");
    quizname=dbx.getVal(p,"/course/quiz/quizname");
    String starttime  = dbx.getVal(p,"/course/quiz/starttime");
    String endtime    = dbx.getVal(p,"/course/quiz/endtime");
    String duration   = dbx.getVal(p,"/course/quiz/duration");
    String points     = dbx.getVal(p,"/course/quiz/points");
    String xslfile    = dbx.getVal(p,"/course/quiz/xslfile");
    //  String settings   = p.getTreeVal("/course/quiz/settings");
    String additional = dbx.getVal(p,"/course/quiz/additional");
    String settings ="";
    fields.put("course",course );
    fields.put("quizname",quizname );
    fields.put("starttime",starttime );
    fields.put("endtime",endtime );
    fields.put("duration",duration );
    fields.put("points",points );
    fields.put("xslfile",xslfile );
    fields.put("settings",settings );
    fields.put("additional",additional );



  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // listQuizzesInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document listQuizzesInXML( String course) throws Exception
  {
    ResultSet rs = select( " WHERE course='"+course+"'");
    
    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);


    while ( rs.next() ) {
      Element quiz = dbx.addMyNode(d,crs,"quiz");
      addNormalTextFields(d,quiz,rs);
      addSubTree(d,quiz,rs);
    }
    addLayouts(d,crs,course,"quiz");

    return d;
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // fillQuestions
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document fillQuestions() throws Exception
  {
    dbxQuestion q=new dbxQuestion();
    return  q.dbxQuestions(quiz,course,quizname);
  }  

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // checkAvailability
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Calendar getTime(int Y,int M, int D,int H, int Mn){
    Calendar c= Calendar.getInstance();
    c.set(Y,M,D,H,Mn);
    return c;
  }
  public Calendar getStartTime()
  {
    return getTime(Integer.parseInt(getS("startyear" )),
		   Integer.parseInt(getS("startmonth"))-1,
		   Integer.parseInt(getS("startday"  )),
		   Integer.parseInt(getS("starthour" )),
		   Integer.parseInt(getS("startmin"  )));
  }
  public Calendar getEndTime()
  {
    return getTime(Integer.parseInt(getS("endyear" )),
		   Integer.parseInt(getS("endmonth"))-1,
		   Integer.parseInt(getS("endday"  )),
		   Integer.parseInt(getS("endhour" )),
		   Integer.parseInt(getS("endmin"  )));
  }


  public boolean checkAvailability() throws Exception
  {
    // String ST=getS("startyear")+getS("startmonth")+getS("startday")+getS("starthour")+getS("startmin");
    // String ET=getS("endyear")+getS("endmonth")+getS("endday")+getS("endhour")+getS("endmin");

    Calendar now=Calendar.getInstance();
    Calendar sc= getStartTime(); sc.add(Calendar.SECOND,-30);
    Calendar ec= getEndTime();   ec.add(Calendar.SECOND,+60);
    if (now.after(sc) && now.before(ec))
      return  true;
    return  false;
  }  


  public boolean available()throws Exception{
   if ( checkAvailability() )
     return true;
   else {
     String now=Calendar.getInstance().getTime().toString();
     String start=getStartTime().getTime().toString();
     String end=getEndTime().getTime().toString();
     throw new Exception("This exam is closed for grading. You are late to submit it. Please cunsult your instructor for further assistance. <small><p><i>Exam should be submitted between the time<br><font color=yellow> "+start+"</font> and <br> <font color=yellow>"+ end+"</font> with respect to my clock. <p> The  clock  was <font color='#cc0000'><br> "+now+"</font> when the server get your submission.</i></small>");
   }
  }
  public boolean published(){
    if (getS("publish").equals("YES"))
	return true;
    return false;
  }


  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // makeExam
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public static Document  makeExam( String _course,String _quizname ) throws Exception
  {
    dbxQuiz dxq = new dbxQuiz(_course,_quizname);
     Document d=null;
    if (dxq.checkAvailability() )
       d=dxq.fillQuestions();
    else {
     String now=Calendar.getInstance().getTime().toString();
     String start=dxq.getStartTime().getTime().toString();
     String end=dxq.getEndTime().getTime().toString();
     throw new Exception("Exam is not available at this time.! <small><p><i>Exam should be taken between the time<font color=yellow><br> "+start+"</font> and <br> <font color=yellow>"+ end+"</font> with respect to my local clock. <p> The  current clock  is <br><font color=white> "+now+"</font>.</i></small>");

    }
    return  d;
  }  
  public static Document  makeExam( dbxQuiz dxq) throws Exception
  {
    dxq.checkAvailability();
    Document d=dxq.fillQuestions();
    return  d;
  }  
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@ operations @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //=====================================================================UPDATE===
  public void updateDocument2DB()throws Exception {
    update();
    //update  in cache
  }
  //=====================================================================UPDATE===
  // CONSIDER LATER
  public String updateSQL()  throws Exception {

    String   oldquizname  =getS("oldquizname",quizname);  
  
    if (!oldquizname.equals(quizname)) {
      //       String updatestr=" SET accesscode='"+accesscode+"' WHERE accesscode ='"
      //                                            +oldaccesscode+"' AND course='"+course+"'";
      //       update.updateData( "UPDATE answers "+updatestr);
      //       update.updateData( "UPDATE grades "+updatestr);
      //       update.updateData( "UPDATE performances "+updatestr);
    }
    return updateSQL("quizname='"+oldquizname  +"' AND course='"+course+"'");
  }



  //====================================================================delete====== 
  public static void  delete(String _course,String _quizname) throws Exception{
    String deleteStr= "quizname='"+ _quizname +"' AND course='"+_course+"'";
    update.updateData( "DELETE FROM quizzes WHERE "+deleteStr);
    
    //  update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    //  update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    //update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }


}





