package gs.dbxml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


//import gs.xml.dbXML;
//XML-end
//import gs.conf.default;
import gs.db.update;
import gs.db.xdatabase;   
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;



public class dbxAssignment extends xdatabase {

  public   String     course  ;          // unique key
  public   String     quizname          ;// unique key
  public   String     qid          ;// unique key
  public   Document   doc;
  static   String tablename  ="xassignments";
  static   String [] all     ={"course","quizname","qid","qtitle","category","type","points","qtext","detail","option"};
  static   String [] q       ={ "'"    ,"'"       ,""   ,"'"     ,"'"       ,"'"   ,""      ,"'"    ,"'"     ,"'"};
  static   String [] keys    ={"course","quizname","qid"};
  static   String [] normal  ={"qtitle","category","type","points","qtext"};
  static   String [] critical={"detail","option"};
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void defineObject(){
    super.tablename=tablename;
    super.all=all;
    super.q=q;
    super.keys=keys;
    super.normal=normal;
    super.critical=critical;
    super.allfields=all[0];
    for (int i=1;i<all.length;i++)
      super.allfields+=","+all[i];
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void setIdentification() throws Exception{
     this.quizname     = getS("quizname"); 
     this.course       = getS("course"); 
     this.qid          = getS("qid"); 
     if(quizname.equals("") || course.equals("") || qid.equals("")) 
       throw new Exception("Key fields are empty!");
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbxAssignment() {}
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbxAssignment(Hashtable ht) throws Exception{
    fields=ht;
    setIdentification();
    generateDocument();
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public   Document dbxAssignment( String _course,String _quizname ) throws Exception{
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("qid","-1" );
    fields.put("points","0" );
    setIdentification();
    return generateDocument();
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  dbxAssignment( String _course,String _quizname ) throws Exception{
    ResultSet rs = select("WHERE course='"+_course+"' AND quizname='"+ _quizname +"'");

    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("qid","-1" );
    setIdentification();

    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element quiz= dbx.addMyNode(d,crs,"quiz");
    dbx.addMyTextNode(d,quiz,"quizname"   ,quizname);

    while ( rs.next() ) {
      Element assignment= dbx.addMyNode(d,quiz,"assignment");
      String qid = Integer.toString(rs.getInt("qid"));
      dbx.addMyTextNode(d,assignment,"qid",qid);
      addNormalTextFields(d,assignment,rs);
      addSubTree(d,assignment,rs);
    }
    addLayouts(d,crs,course,"assignment");

    doc= d;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public   Document dbxAssignments( Element dadquiz, String _course,String _quizname ) throws Exception{
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    ResultSet rs = select("WHERE course='"+_course+"' AND quizname='"+ _quizname +"' ORDER BY qid");
    Document d=dadquiz.getOwnerDocument();
    while ( rs.next() ) {
      Element assignment= dbx.addMyNode(d,dadquiz,"assignment");
      String qid = Integer.toString(rs.getInt("qid"));
      dbx.addMyTextNode(d,assignment,"qid",qid);
      addNormalTextFields(d,assignment,rs);
      addSubTree(d,assignment,rs);
    }

    return d;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  dbxAssignment( String _course,String _quizname,String _qid ) throws Exception
  {
    ResultSet rs = select("WHERE  course='"+_course+"' AND quizname='"+ _quizname +"' AND qid="+ _qid);
    
    this.course=_course;
    this.quizname=_quizname;
    this.qid=_qid;

    // if in cache 
    //    doc=cache;
    // return;
    fillFields(rs);
    generateDocument();
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void reload() throws Exception
  {
    ResultSet rs = select("WHERE  course='"+course+"' AND quizname='"+ quizname +"' AND qid="+ qid);
    fillFields(rs);
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public String nextQid() throws Exception{
    String where= "course='"+getS("course")+"' AND quizname='"+getS("quizname")+"'";
    ResultSet rs = records("qid", where,"qid DESC ");
    if ( rs.next() ) 
      return Integer.toString(1+rs.getInt("qid"));
    return "0";
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // generateDocument
   //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document generateDocument() throws Exception {
    //get from  cache 
      Document d=dbx.giveMeEmptyDocument(); 
      Element crs=dbx.makeMeRoot(d,"course"); 

      dbx.addMyTextNode(d,crs,"coursename"   ,course);

      Element quiz= dbx.addMyNode(d,crs,"quiz");
      dbx.addMyTextNode(d,quiz,"quizname"    ,quizname);
      Element assignment= dbx.addMyNode(d,quiz,"assignment");
      dbx.addMyTextNode(d,assignment,"qid"         ,getS("qid"));
      addNormalTextFields(d,assignment);
      addSubTree(d,assignment);
      addLayouts(d,crs,course,"assignment");
      doc=d;
    return doc;
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2DB
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  convert2DB(  )        throws Exception
  {
    Element p=doc.getDocumentElement() ;
    course= dbx.getVal(p,"/course/coursename");
    fields.put("course",course );
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@ operations @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //====================================================================delete====== 
  public  static void  delete(String _course,String _quizname,String _qid) throws Exception{
    String deleteStr= " course='"+_course+"' AND quizname='"+_quizname+"' AND qid="+_qid ;
    update.updateData( "DELETE FROM "+tablename+" WHERE "+deleteStr);
    update.updateData( "DELETE FROM exam_answers WHERE "+deleteStr);
    //  update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    //update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }
  //=====================================================================UPDATE===
  // CONSIDER LATER
  public String updateSQL()  throws Exception {
    String   oldqid  =getS("oldqid",qid);  
    return updateSQL(" course='"+course+"' AND quizname='"+quizname+"' AND qid="+oldqid );
  }
  public void  sideEffectsUPDATE()throws Exception {
    String   oldqid  =getS("oldqid",qid);  
    if (!oldqid.equals(qid)) {
      String updatestr=" SET qid="+qid+" WHERE course='"+course+"' AND quizname='"+quizname+"' AND qid="+oldqid ;
      update.updateData( "UPDATE  exam_answers "+updatestr);
    }    
  }
}





