package gs.html;

public interface RecordParsable {

  // This method is called for each record by the main parser
  // to handle <record> tag in the HTML teplates.
  //
  // Child classes should override this method.

  abstract public 
  boolean handleRecord
  (
   java.util.Hashtable fields
   ) 
       throws java.io.IOException, java.sql.SQLException;
}
