<?xml version="1.0"?> 

<!--xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
   xmlns="http://www.w3.org/TR/REC-html40" 
   xmlns:lxslt="http://xsl.lotus.com/"
result-ns="">


   
   
   <xsl:template match="/">
      <HTML>
	 <head>
	    
	    <SCRIPT LANGUAGE="JavaScript">
	       var list="";
	       var quizname="<xsl:value-of select="course/quiz/quizname"/>";
	       //alert(quizname);
	       var upsrc="<xsl:value-of select="course/global/images"/>"+"/up.gif";
	      // alert(upsrc);
	       //...
	       <![CDATA[
		  function switchQuestions(){}
		  function flag(qid){
		  eval("top.menu.document.images['f"+qid+"'].src='"+upsrc+"'");
		  var ind=list.indexOf(qid);
		  
		  if (ind >= 0){
		  list=list.substring(0,ind)+list.substring(ind+qid.length+1);
		  }
		  //alert(list);
		  }
		  function checkFlag(){}

	    ]]>   </SCRIPT>
	  
		
	 </head>
	 <BODY bgcolor="yellow">
	    <center>
	    <xsl:apply-templates select="course/layouts"/>
	    <xsl:apply-templates select="course/function"/>
	    <xsl:variable name="page" expr="course/function"/>
	    <xsl:call-template name="header"/>
	    <TABLE WIDTH="100%" ALIGN="center" BORDER="1">
	       <TR>
		  <TH colspan="3" bgcolor="LemonChiffon"><font color="brown"> <xsl:value-of select="course/coursename"/> <s/><font color="blue">
		     <xsl:value-of select="course/quiz/quizname"/></font> <br/>Question List </font> </TH> 
	       </TR>
	       <xsl:choose>
		  <xsl:when test="$page='listQuestions'">
		     <xsl:apply-templates select="course/quiz/question" mode="list">
			<xsl:sort select="qid"/>
		     </xsl:apply-templates>
		  </xsl:when>
		  <xsl:when test="$page='listGradedQuestions'">
		     <xsl:apply-templates select="course/quiz/question" mode="listGraded"/>
		  </xsl:when>
		  <xsl:otherwise>
		     <xsl:apply-templates select="course/quiz/question" mode="default"/>
		  </xsl:otherwise>
	       </xsl:choose>
	    </TABLE>
	    <xsl:if test="$page='listQuestions'">
	       <form>
		  <font color="black" size="+1" FACE="Arial,Helvetica" ><b>
		     <input type="button" name="acomm" value=" SUBMIT EXAM " onClick="top.info.submitExam(list)"/>
		  </b></font>
	       </form>
	    </xsl:if>
	 </center>
	 </BODY>
      </HTML>
   </xsl:template>


   
<!-- ============================================================ -->
   <xsl:template match="question" mode="list">
      <xsl:sort select="qid"/>
      <SCRIPT> list+="<xsl:value-of select="qid"/>,"; </SCRIPT>
      <xsl:variable name="down"><xsl:value-of select="/course/global/images"/>/down.gif</xsl:variable>
      <tr>
	 <td align="center">
	   <xsl:value-of select="qid"/>. 
	   </td>
	 <td bgcolor="LemonChiffon">
	      <A href="JavaScript:top.info.go('{qtitle}')" target="info"><xsl:value-of select="qtitle"/></A>
	 </td>
	 <td align="center">
	    <A href="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuestions/?quizname={/course/quiz/quizname}&amp;course={/course/coursename}&amp;comm=QUESTION&amp;unum={/course/user/unum}&amp;qid={qid}" onClick="switchQuestions()" target="info"></A> <img border="0" name="f{qid}" src="{$down}"/><b></b>
	 </td>
      </tr>
   </xsl:template>
   
<!-- ============================================================ -->
   <xsl:template match="question" mode="listGraded">
      <xsl:sort select="qid"/>
      <tr>
	 <td align="center">
	   <xsl:value-of select="qid"/>. 
	   </td>
	 <td bgcolor="LemonChiffon">
	      <A href="JavaScript:top.info.go('{qtitle}')" target="info"><xsl:value-of select="qtitle"/></A>
	 </td>
	 <td align="center">
	    	<font color="red"> <xsl:value-of select="std-score"/></font>/<xsl:value-of select="points"/>
	 </td>
      </tr>
   </xsl:template>
<!-- ============================================================ -->
   <xsl:template match="question" mode="default">
      <xsl:sort select="qid"/>
      <tr>
	 <td align="center">
	   <xsl:value-of select="qid"/>. 
	   </td>
	 <td bgcolor="LemonChiffon"><xsl:value-of select="qtitle"/>
	 </td>
	 <td align="center" bgcolor="red"><font color="white" size="-1" face="helvetica">No Grade</font>
	 </td>
      </tr>
   </xsl:template>
   

<!-- *============================================================ -->
   <xsl:template match="course/layouts" >
      
      <table width="100%">
	 <tr>
	    <th bgcolor="#ccffff">
	       <xsl:value-of select="current/questionLIST/@xname"/>
	       <br>
	       </br> 
	       <xsl:apply-templates select="questionLIST">
		  <xsl:sort select="@xname" />
	       </xsl:apply-templates>
	    </th>
	 </tr>
      </table>

   </xsl:template>

<!-- *============================================================ -->   
   <xsl:template match="questionLIST" >
      
      [<A href="http://{./@xfile}"> <xsl:value-of select="./@xname"/>  </A>]
      
   </xsl:template>
   
<!-- *============================================================ -->   
 
<!-- *============================================================ -->   
   <xsl:template name="header" >
      <table width="100%">
	 <tr><td bgcolor="blue" align="center"><font face="helvetica" size="+1" color="white"> <b>Questions </b></font></td></tr>
	    <form>
	 <tr><td bgcolor="white" align="center">
	       <font color="blue">
		  <b>
		     <samp><input type="button" value="ADD" onClick="add()"/>
		     <a href="{/course/global/help}/question.html" target="help">
			<img src="{/course/global/images}/mans.gif" border="0" align="ABSCENTER"/>
		     </a>
		     <input type="button" value="BACK" onClick=" self.history.go(-1); "/></samp> 
		  </b>
	       </font>
	 </td></tr>
	    </form>
      </table>
   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template match="course/function" >

      <xsl:variable name="page"><xsl:value-of select="course/function"/></xsl:variable>
   </xsl:template>
      
<!-- *============================================================ -->   
  
  
 
</xsl:stylesheet>

