<?xml version="1.0"?> 

<!--xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
   xmlns="http://www.w3.org/TR/REC-html40" 
   xmlns:lxslt="http://xsl.lotus.com/"
>


   
   
   <xsl:template match="/">
      <HTML>
	 <BODY bgcolor="yellow" > 
	    <xsl:variable name="barimg"><xsl:value-of select="course/global/images"/>/bluebar.gif</xsl:variable>
	    <xsl:variable name="images"><xsl:value-of select="course/global/images"/></xsl:variable>
	    <xsl:variable name="norm"><xsl:value-of select="course/quiz/question/normalize"/></xsl:variable>
	    <xsl:apply-templates select="course/layouts"/>
	       <center>
    
		  <TABLE WIDTH="100%" ALIGN="center" BORDER="1">
	       <TR>
		  <TH colspan="3" bgcolor="LemonChiffon"> <xsl:value-of select="course/coursename"/> <s/>
		     <xsl:value-of select="course/quiz/quizname"/> 
		     <s/>
			<font color="blue"> <xsl:value-of select="course/quiz/question/qtitle"/>
		     </font> 
		     Results 
		  </TH> 
	       </TR>
	    </TABLE>
	    <xsl:choose>
	       <xsl:when test="course/quiz/question/type='mc'">
		  <xsl:apply-templates select="course/quiz/question" mode="mc"/>
	       </xsl:when>
	    </xsl:choose>
 
			     
	    
	    <form name="current">
	       <input type="text"  name="set"  value="Please point mouse to bars"/>
	    </form>
	    
	    <TABLE BORDER="0">
	       <tr>
		  <td valign="top">100</td>
		  <td height="200" width="1" bgcolor="red"><IMG SRC="{/course/global/images}/line.gif"/></td>
		  <td bgcolor="white" ALIGN="LEFT" VALIGN="bottom" >
		     
			   <xsl:for-each select="course/quiz/question/std-answers/std-answer" ><xsl:sort select="grade" data-type="number"/><xsl:variable name="image"><xsl:value-of select="$images"/>/gbar3.gif</xsl:variable><a href="" onMouseOver="top.info.document.current.set.value={grade}"><IMG SRC="{$image}"  height="{grade*2}" width="5" border="0" /></a></xsl:for-each>
			
		  </td>
	       </tr>
	       <tr>
		  <td height="1" ></td>
		  <td height="1"></td>
		  <td bgcolor="red" height="1" width="500"><IMG SRC="{$images}/line.gif"/></td>
	       </tr>
	       
	       <tr>
		  <td height="1" colspan="2">0</td>
		  
		  <td><center><i>S  T U D E N T S</i></center></td>
	       </tr>
	    </TABLE> 
	       <xsl:if test="course/quiz/question/type='prg'">
		  <xsl:apply-templates select="course/quiz/question" mode="prg"/>
	       </xsl:if>

	       
	       </center>
       
	 </BODY>
      </HTML>
   </xsl:template>
<!-- ============================================================ -->
   <xsl:template match="question" mode="prg">
      <TABLE BORDER="0">
	 <xsl:for-each select="/course/quiz/question/std-answers/std-answer" >
	    <tr>
	       <td >
		  Grade : <xsl:value-of select="grade"/>
	       </td>
	    </tr>
	    <tr>
	       <td bgcolor="LemonChiffon"> 
		  Answer: <xsl:value-of select="std-response"/>
	       </td>
	    </tr>
	 </xsl:for-each>
      </TABLE> 
   </xsl:template>

<!-- ============================================================ -->
    <xsl:template match="question" mode="mc">
       <p> </p>
		<table>
		   <tr>
		      <td bgcolor="cyan"><b>Distribution</b></td>
		      <td bgcolor="cyan"><b># </b> </td> 
		      <td  bgcolor="cyan"><b>Options</b></td>
		   </tr>
		   <xsl:for-each select="detail/mcanswers/answer" >
		      <xsl:variable name="image"><xsl:value-of select="$images"/>/bluebar<xsl:number name="mycounter" level="single" count="answer" format="1."/>gif</xsl:variable>
		      <tr>
			 <td ><img src="{$image}" width="{count*10}" height="15"/></td>
			 <td bgcolor="red"><b><font color="white"><xsl:value-of select="count"/></font></b></td> 
			 <td ><b><xsl:value-of select="text"/></b></td>
		      </tr>
		   </xsl:for-each>
		</table>
		
		
		<TABLE BORDER="0">
		   <tr>
		      <td valign="top">#<xsl:value-of select="$norm)"/></td>
		      <td height="200" width="1" bgcolor="red"><IMG SRC="{/course/global/images}/line.gif"/></td>
		      <td ALIGN="LEFT" VALIGN="bottom">
			 <xsl:variable name="sp">.</xsl:variable>
			 <xsl:variable name="fact" expr="200 div $norm"></xsl:variable>
			 <xsl:for-each select="detail/mcanswers/answer" >
			    <xsl:variable name="image"><xsl:value-of select="$images"/>/bar<xsl:number name="mycounter" level="single" count="answer" format="1."/>gif</xsl:variable>
			    <a href="" onMouseOver="top.info.document.current.set.value={count}"><IMG SRC="{$image}"  height="{count*$fact}" border="0"/></a><xsl:value-of select="$sp"/>
			    
			 </xsl:for-each>
			 
		      </td>
		   </tr>
	       <tr>
		  <td height="1" ></td>
		  <td height="1"></td>
		  <td bgcolor="red" height="1" width="500"><IMG SRC="{$images}/line.gif"/></td>
	       </tr>
		  
		   
		   <tr>
		      <td height="1" colspan="2">0</td>
		      
		      <td><center><i>Options</i></center></td>
		   </tr>
		</TABLE>
    </xsl:template>

<!-- ============================================================ -->
    <xsl:template match="detail/mcanswers/answer" mode="mc">
       

	  <tr>
	     <td ><img src="{$barimg}" width="{count*10}" height="15"/></td>
	     <td bgcolor="red"><b><font color="white"><xsl:value-of select="count"/></font></b></td> 
	     <td ><b><xsl:value-of select="text"/></b></td>
	  </tr>
</xsl:template>
<!-- ============================================================ -->
    <xsl:template match="detail/mcanswers/answer" mode="mc2">
<a href="" onMouseOver="top.info.document.current.set.value='{count}--{$myc++}'"><IMG SRC="{$images}/gbar{$myc++}.gif"  height="{count*10}" border="0"/></a>	
</xsl:template>


<!-- ============================================================ -->
    <xsl:template name="studentmcanswers">
        ??<b><xsl:value-of select="$ht"/></b>??
 <xsl:value-of select="count(/course/quiz/question/answers/answer[text()]='{text}')"/> <br/>
 <xsl:variable name="ht"><xsl:value-of select="text"/></xsl:variable><xsl:value-of select="$ht"/>
</xsl:template>
<!-- ============================================================ -->
    <xsl:template match="text">"<xsl:value-of select="."/>",</xsl:template>


<!-- ============================================================ -->
   <xsl:template match="agrade" mode="again" >
      <xsl:variable name="ht"><xsl:value-of select=".*2"/></xsl:variable>
      <a href="" onMouseOver="top.info.document.current.set.value={.}"><IMG SRC="{/course/global/images}/gbar.gif" onMouseOver="top.info.document.current.set.value={.}" height="{$ht}" border="0"/></a>

   </xsl:template>

<!-- ============================================================ -->
   <xsl:template match="agrade" mode="first">
      <xsl:variable name="ht"><xsl:value-of select=".*2"/></xsl:variable>
      <a href="" onMouseOver="top.info.document.current.set.value={.}"><IMG SRC="{/course/global/images}/gbar3.gif" onMouseOver="top.info.document.current.set.value={.}" height="{$ht}" width="5" border="0"/></a>

   </xsl:template>
   
   
<!-- ============================================================ -->
   <xsl:template match="question" >
      <tr>
	 <td align="center"><font color="red" size="-1"><xsl:value-of select="category"/></font></td>
	 <td bgcolor="LemonChiffon"><font color="red" size="-1">
	     <xsl:value-of select="qid"/>.  <A href="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuestions/?quizname={/course/quiz/quizname}&amp;course={/course/coursename}&amp;comm=METADATA&amp;unum={/course/user/unum}&amp;qid={qid}" target="info"><xsl:value-of select="qtitle"/></A></font>
	 </td>
	 <td align="center" bgcolor="brown">
	    <A href="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuestions/?quizname={/course/quiz/quizname}&amp;course={/course/coursename}&amp;comm=QUESTION&amp;unum={/course/user/unum}&amp;qid={qid}"  target="info"><font color="yellow"><b>Q</b></font></A>
	 </td>
      </tr>
   </xsl:template>
   

<!-- *============================================================ -->
   <xsl:template match="course/layouts" >
      
      <table width="100%">
	 <tr>
	    <th bgcolor="#ccffff">
	       <xsl:value-of select="current/quizRESULT/@xname"/>
	       <br>
	       </br> 
	       <xsl:apply-templates select="quizRESULT">
		  <xsl:sort select="@xname" />
	       </xsl:apply-templates>
	    </th>
	 </tr>
      </table>

   </xsl:template>

<!-- *============================================================ -->   
   <xsl:template match="quizRESULT" >

      [<A href="http://{./@xfile}"> <xsl:value-of select="./@xname"/>  </A>]

   </xsl:template>

<!-- *============================================================ -->   

   
</xsl:stylesheet>

