<?xml version="1.0"?> 

<!--xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
   xmlns="http://www.w3.org/TR/REC-html40" 
   xmlns:lxslt="http://xsl.lotus.com/"
   result-ns=""
   >
   
   <xsl:template match="/">
      <HTML>
	 <head><SCRIPT LANGUAGE="JavaScript"><![CDATA[
	       function confirmation(){
	       if (confirm("\n\nYour confirmation is required. \nDeleting quiz will lost all the stored information related with the quiz.\n\nDo you really want to delete the quiz '"+this.document.quiz.quizname.value+"' ?") ) {
	       if (confirm("\n\nAre you sure to remove all the records of "+this.document.quiz.quizname.value+"?") ) {
	       
	       this.document.quiz.dcomm.value="DELETE";
	       this.document.quiz.submit();
	       return;
	       }
}  alert("not deleting");
	       
	       }
	    
	    ]]></SCRIPT>
	 </head>
	 <BODY bgcolor="Yellowgreen">
	    <xsl:apply-templates select="course/layouts"/>
	    <xsl:apply-templates select="course/function"/>
	    <form name="quiz" action="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuizzes"
	       method="POST">
	       <input type="hidden" name="unum"  value="{/course/user/unum}"/>
	       <input type="hidden" name="course" value="{/course/coursename}"/>
	       <input type="hidden" name="quizname" value="{/course/quiz/quizname}"/>
	       <b>
		  <font color="black" size="+1" FACE="Arial,Helvetica" >
		     <input type="submit" name="comm" value="NEW" />
		     <font color="red" >
			<input type="button" name="delete" value="DELETE" onClick="confirmation()"/>
			<input type="hidden" name="dcomm" value="no"/>
		     </font>
		     <input type="submit" name="comm" value="EDIT" />
		     <input type="button" name="comm" value="SKIP" onClick="history.go(-1);" />
		  </font>
	       </b>
	    </form>
	    <xsl:apply-templates select="course/quiz"/>
	 </BODY>
      </HTML>
   </xsl:template>


   
<!-- ============================================================ -->
   <xsl:template match="quiz" >
      <xsl:sort select="quizname"/>
      <xsl:variable name="sp" > </xsl:variable>
      <table bgcolor="cyan" ><th>
	 <table bgcolor="yellow" cellpadding="6" border="5" >
	    <tr>
	       <TH colspan="2" bgcolor="LemonChiffon" >Quizz Information</TH>
	    </tr>
	    <tr><td width="200"><b>Quiz Name   </b></td><td><xsl:value-of select="quizname"/> </td></tr>
	    <tr><td width="200"><b>Start Time  </b></td><td><b><xsl:value-of select="startmonth"/>/<xsl:value-of select="startday"/>/<xsl:value-of select="startyear"/> @ <xsl:value-of select="starthour"/>:<xsl:value-of select="startmin"/></b></td></tr>
	    <tr><td><b>   End Time             </b></td><td><b><xsl:value-of select="endmonth"/>/<xsl:value-of select="endday"/>/<xsl:value-of select="endyear"/> @ <xsl:value-of select="endhour"/>:<xsl:value-of select="endmin"/></b></td></tr>
	    <tr><td><b>    Duration            </b></td><td> <xsl:value-of select="duration"/>  </td></tr>
	    <tr><td><b>     Points             </b></td><td> <xsl:value-of select="points"/>  </td></tr>
	    <tr><td><b>     Published             </b></td><td> <xsl:value-of select="publish"/>  </td></tr>
	    <tr><td><b>     Layout             </b></td><td> <xsl:value-of select="xslfile"/>  </td></tr>
	    <xsl:apply-templates select="settings/option"/>
	    <xsl:apply-templates select="additional"/>
	    <tr><td><b>     Public Comments             </b></td><td> <xsl:value-of select="public"/>  </td></tr>
	    <tr><td><b>     Private Comments             </b></td><td> <xsl:value-of select="private"/>  </td></tr>
	 </table>
      </th>
   </table>
   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template match="settings/option" >
      <tr><td><b><xsl:value-of select="name"/></b></td>
      <td> <xsl:value-of select="value"/></td></tr>
   </xsl:template>
   

<!-- *============================================================ -->
   <xsl:template match="course/layouts" >
      
      <table width="100%">
	 <tr>
	    <th bgcolor="#ccffff">
	       <xsl:value-of select="current/quiz/@xname"/>
	       <br>
	       </br> 
	       <xsl:for-each select="quiz" >
		  <xsl:sort select="@xname" />
		  <xsl:call-template name="XSL LAYOUT"/>
	       </xsl:for-each>
	    </th>
	 </tr>
      </table>

   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template name="XSL LAYOUT" >

      [<A href="http://{./@xfile}"> <xsl:value-of select="./@xname"/>  </A>]

   </xsl:template>
   
<!-- *============================================================ -->   
   <xsl:template match="additional" >

   <tr><td><b>     Points   additional          </b></td><td> additional                                 </td></tr>
   </xsl:template>

<!-- *============================================================ -->   
   <xsl:template match="course/function" >
      <SCRIPT LANGUAGE="JavaScript">
	 var func='<xsl:value-of select="/course/function"/>';
	 if ('addQuiz'==func || 'updateQuiz'==func )
	      top.menu.document.location.reload();
      </SCRIPT>
  </xsl:template>
</xsl:stylesheet>

