#!/bin/ksh
#  PRC, Inc. 
#  Bill Sparkman
#  Thu May 13 13:18:15 EDT 1999
#
#  Verify Arg(s)
#
if [[ $# = 0 ]]
  then echo Usage: $0 fn 
       echo Where fn is any valid filename set [ fn.dtd, fn.xml, fn.xsl ]
       echo "Do not include .[dtd|xml|xsl]"
       exit 1
fi

#
# Change classpath to match locations on your system
# Created on a Solaris 2.6 box with jdk1.1.7 installed in /usr/java
# so we only need location of xml4j and lotusxsl.
#
export CLASSPATH=$PRCDEVEL/DBMAP/cots/xsl/lotusxsl_0_16_5/xml4j.jar:$PRCDEVEL/DBMAP/cots/xsl/lotusxsl_0_16_5/lotusxsl.jar
#
# Run it
#
jre com.lotus.xsl.xml4j.ProcessXSL -in $1.xml -xsl $1.xsl -out $1.html -CR -LF -NV
