<?xml version="1.0"?> 

<!-- stylesheet for list types -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="list[@type='bulleted']">
    <UL><xsl:apply-templates/></UL>
  </xsl:template>

  <xsl:template match="list[@type='simple']">
    <UL TYPE="i"><xsl:apply-templates/></UL>
  </xsl:template>

  <xsl:template match="list[@type='gloss']">
    <DL><xsl:apply-templates/></DL>
  </xsl:template>

  <xsl:template match="list[@type='gloss']/label">
    <DT><xsl:apply-templates/></DT>
  </xsl:template>

  <xsl:template match="list[@type='gloss']/item">
    <DD><xsl:apply-templates/></DD>
  </xsl:template>

  <xsl:template match="list[@type='ordered']">
    <OL><xsl:apply-templates/></OL>
  </xsl:template>

  <xsl:template match="list/item">
    <LI><xsl:apply-templates/></LI>
  </xsl:template>
  
</xsl:stylesheet>