<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="/">
      <H1>Test for 'from-children' Axis Identifier.</H1>
      <HR/>
      <xsl:for-each select="//center">
        <P>Should say "near-south-east near-south near-south-west":</P>
        <P><xsl:apply-templates select="from-children(*)"/></P>
        <HR/>
        <P>Should say "near-south":</P>
        <P><xsl:apply-templates select="from-children(*[2])"/></P>
        <HR/>
        <P>Should say "near-south-west":</P>
        <P><xsl:apply-templates select="from-children(near-south-west)"/></P>
        <HR/>
      </xsl:for-each>
  </xsl:template>
  
  <xsl:template match="*">
   <xsl:value-of select="qname(.)"/><xsl:text> </xsl:text>
  </xsl:template>
 
</xsl:stylesheet>
