<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="/">
      <H1>Test for 'from-descendants-or-self' Axis Identifier.</H1>
      <HR/>
      <xsl:for-each select="//center">
        <P>Should say "center near-south-east near-south south far-south near-south-west":</P>
        <P><xsl:apply-templates select="from-descendants-or-self(*)"/></P>
        <HR/>
        <P>Should say "near-south":</P>
        <P><xsl:apply-templates select="from-descendants-or-self(*[3])"/></P>
        <HR/>
        <P>Should say "far-south":</P>
        <P><xsl:apply-templates select="from-descendants-or-self(far-south)"/></P>
        <HR/>
        <P>Should say "center":</P>
        <P><xsl:apply-templates select="from-descendants-or-self(center)"/></P>
        <HR/>
      </xsl:for-each>
  </xsl:template>
  
  <xsl:template match="*">
   <xsl:value-of select="qname(.)"/><xsl:text> </xsl:text>
  </xsl:template>
 
</xsl:stylesheet>
