<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="/">
      <H1>Test for 'from-parent' Axis Identifier.</H1>
      <HR/>
      <xsl:for-each select="//center">
        <P>Should say "near-north":</P>
        <P><xsl:apply-templates select="from-parent(*)"/></P>
        <HR/>
        <P>Should say "near-north":</P>
        <P><xsl:apply-templates select="from-parent(near-north)"/></P>
        <HR/>
        <P>Should say "near-north":</P>
        <P><xsl:apply-templates select="from-parent(*[1])"/></P>
        <HR/>
        <P>Should be blank:</P>
        <P><xsl:apply-templates select="from-parent(foo)"/></P>
        <HR/>
        <P>Should say "near-north":</P>
        <P><xsl:apply-templates select=".."/></P>
        <HR/>
      </xsl:for-each>
  </xsl:template>
  
  <xsl:template match="*">
   <xsl:value-of select="qname(.)"/><xsl:text> </xsl:text>
  </xsl:template>
 
</xsl:stylesheet>
