<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="/">
      <H1>Test for 'from-self' Axis Identifier.</H1>
      <HR/>
      <xsl:for-each select="//center">
        <P>Should say "center":</P>
        <P><xsl:apply-templates select="from-self(*)"/></P>
        <HR/>
        <P>Should say "center":</P>
        <P><xsl:apply-templates select="from-self(center)"/></P>
        <HR/>
        <P>Should say "center":</P>
        <P><xsl:apply-templates select="from-self(*[1])"/></P>
        <HR/>
        <P>Should be blank:</P>
        <P><xsl:apply-templates select="from-self(foo)"/></P>
        <HR/>
        <P>Should say "center":</P>
        <P><xsl:apply-templates select="."/></P>
        <HR/>
      </xsl:for-each>
  </xsl:template>
  
  <xsl:template match="*">
   <xsl:value-of select="qname(.)"/><xsl:text> </xsl:text>
  </xsl:template>
 
</xsl:stylesheet>
