<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="doc">
      <H1>Test for conflict Resolution - 2 non-simples (predicate and '/'). </H1>
      <P>1 conflict warning should be seen.</P>
      <HR/>
      <P>Should say "Match of non-simple '/'":</P>
      <P><xsl:apply-templates select="foo"/></P>
  </xsl:template>
  
  <xsl:template match="foo[@test]">
    Match of non-simple '[...]'.
  </xsl:template>

  <xsl:template match="doc/foo">
    Match of non-simple '/'.
  </xsl:template>

  <xsl:template match="foo">
    Match of qualified name.
  </xsl:template>

  <xsl:template match="*">
    Match of wildcard.
  </xsl:template>

  <xsl:template match="node()">
    Match of node type.
  </xsl:template>

</xsl:stylesheet>
