<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="/">
    <HTML>
      <H1>Test for boolean().</H1>
      <P>Warning about not-a-reference variable is normal.</P>
      <HR/>
      <P>Should say "true" (node-set to boolean): <xsl:value-of select="boolean(doc)"/></P>
      <P>Should say "false" (empty node-set to boolean): <xsl:value-of select="boolean(foo)"/></P>
      <P>Should say "false" (number to boolean): <xsl:value-of select="boolean(0)"/></P>
      <P>Should say "true" (zero to boolean): <xsl:value-of select="boolean(2)"/></P>
      <P>Should say "true"  (string to boolean): <xsl:value-of select="boolean('false')"/></P>
      <P>Should say "false" (empty string to boolean): <xsl:value-of select="boolean('')"/></P>
      <xsl:variable name="ResultTreeFragTest">
        <xsl:value-of select="doc"/>
      </xsl:variable>
      <xsl:variable name="emptyResultTreeFragTest">
        <xsl:value-of select="foo"/>
      </xsl:variable>
      <P>Should say "true" (result-tree-fragment to boolean): 
        <xsl:value-of select="boolean($ResultTreeFragTest)"/></P>
      <P>Should say "false" (empty result-tree-fragment to boolean): 
        <xsl:value-of select="boolean($emptyResultTreeFragTest)"/></P>
      <P>Should say "false" (non-existent variable to boolean): 
        <xsl:value-of select="boolean($not-a-reference)"/></P>
    </HTML>
  </xsl:template>
 
</xsl:stylesheet>
