<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:param-variable name="pvar2" expr="'stylesheet-var'"/>

  <xsl:template name="ntmp1">
    <xsl:param-variable name="pvar1">def-text-1</xsl:param-variable>
    <xsl:param-variable name="pvar2">def-text-2</xsl:param-variable>
    <xsl:value-of select="$pvar1"/>, 
    <xsl:value-of select="$pvar2"/>,
    <xsl:apply-templates select="*">
      <xsl:param name="pvar1" expr="$pvar1"/>
    </xsl:apply-templates>
  </xsl:template>

  <xsl:template match="*">
    <xsl:param-variable name="pvar1">def-text-1</xsl:param-variable>
    <xsl:call-template name="ntmp1">
      <xsl:param name="pvar1" expr="$pvar1"/>
      <xsl:param name="pvar2" expr="qname(.)"/>
    </xsl:call-template>
  </xsl:template>
  
  <xsl:template match="/doc">
    <HTML>
      <H1>Test for recursion with xsl:call-template.</H1>
      <HR/>
      <xsl:variable name="ResultTreeFragTest" expr="qname(.)"/>
      <P>Should say "doc, def-text-2, doc, a, doc, b, doc, c, doc, d, ":</P>
      <P>
      <xsl:call-template name="ntmp1">
        <xsl:param name="pvar1" expr="$ResultTreeFragTest"/>
      </xsl:call-template>
      </P>
    </HTML>
  </xsl:template>
 
</xsl:stylesheet>