<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:key name="k" match="a" use="@test"/>
  <xsl:key name="k2" match="a" use="num"/>

  <xsl:template match="doc">
      <H1>Test for position() used with key().</H1>
      <HR/>
      <P>Should say "4, 3, 1, 2":</P>
      <P><xsl:value-of select="key('k', 'true')[position()=4]/num"/>,
         <xsl:value-of select="key('k', 'true')[position()=3]/num"/>,
         <xsl:value-of select="key('k', 'true')[position()=1]/num"/>,
         <xsl:value-of select="key('k', 'true')[position()=2]/num"/></P>
      <HR/>
      <P>Should say "4, 3, 1, 2":</P>
      <P><xsl:value-of select="key('k', 'true')[4]/num"/>,
         <xsl:value-of select="key('k', 'true')[3]/num"/>,
         <xsl:value-of select="key('k', 'true')[1]/num"/>,
         <xsl:value-of select="key('k', 'true')[2]/num"/></P>
      <HR/>
      <P>Should say "4, 3, 1, 2" (in bold):</P>
      <P><xsl:apply-templates select="key('k', 'true')[4]/num"/>,
         <xsl:apply-templates select="key('k', 'true')[3]/num"/>,
         <xsl:apply-templates select="key('k', 'true')[1]/num"/>,
         <xsl:apply-templates select="key('k', 'true')[2]/num"/></P>
  </xsl:template>
 
  <xsl:template match="num">
    <B><xsl:value-of select="."/></B>
  </xsl:template>
 
</xsl:stylesheet>
