<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">
  
  <xsl:template match="doc">
      <H1>Test for xsl:param and xsl:param-variable.</H1>
      <HR/>
      <xsl:variable name="ResultTreeFragTest">
        <B>Data from doc/a: <xsl:value-of select="a"/></B>
      </xsl:variable>
      <P>Should say "Data from doc/a: test, Default text in pvar2" (no text should be bold):</P>
      <P>
      <xsl:apply-templates select="a">
        <xsl:param name="pvar1" expr="$ResultTreeFragTest"/>
      </xsl:apply-templates>
      </P>
  </xsl:template>

  <xsl:template match="a">
    <xsl:param-variable name="pvar1">Default text in pvar1</xsl:param-variable>
    <xsl:param-variable name="pvar2">Default text in pvar2</xsl:param-variable>
    <xsl:value-of select="$pvar1"/>, 
    <xsl:value-of select="$pvar2"/>
  </xsl:template>
  
</xsl:stylesheet>