import java.io.*;
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;


public class XSLTest
{
  public static void main(String[] argv)
  {
    ByteArrayOutputStream byteStream = new ByteArrayOutputStream();
    PrintWriter xmlWriter = new PrintWriter(byteStream);
    Reader xmlReader = new java.io.InputStreamReader(new
                                                     ByteArrayInputStream(byteStream.toByteArray()));

    TXDocument doc = new TXDocument ();
    ProcessingInstruction  pri1 
      = doc.createProcessingInstruction("xml",
                                        "version=\"1.0\" encoding=\"ISO-8859-1\"");
    doc.appendChild(pri1);
    ProcessingInstruction  pri2 
      = doc.createProcessingInstruction("xml-stylesheet",
                                        "href=\"test.xsl\" type=\"text/xsl\" ");
    doc.appendChild(pri2);
    Element root =  doc.createElement ("sym");
    doc.appendChild (root);

    // dump DOM
    Writer out = new OutputStreamWriter (System.out);
    try 
    {
      doc.printWithFormat (out); 
    } catch (Exception e) {}

    try 
    {
      PrintWriter pw = new PrintWriter(System.out);
      XMLParserLiaison liaison = new com.lotus.xsl.xml4j.ProcessXSL();
      XSLProcessor xslprocessor = new XSLProcessor(liaison);
      
      TXDocument html = (TXDocument)xslprocessor.process(doc);
      html.printWithFormat (out); 
    }
    catch(Exception e) { e.printStackTrace(); }

  }

}