#Revision: %M% %I% %W% %Q%

SAXFILES=org/xml/sax
FRAMEWORKFILES=com/ibm/xml/framework
DOMFILES=org/w3c/dom
DOMIMPLFILES="com/ibm/xml/dom $DOMFILES"
TXFILES="com/ibm/xml/parser com/ibm/xml/xpointer $DOMFILES"
VALIDATIONFILE=com/ibm/xml/internal/DefaultValidationHandler.class

INTERNALFILES="com/ibm/xml/internal/CMBinOp.class com/ibm/xml/internal/CMException.class com/ibm/xml/internal/CMLeaf.class com/ibm/xml/internal/CMNode.class com/ibm/xml/internal/CMStateexport.class com/ibm/xml/internal/CMUniOp.class com/ibm/xml/internal/CharReader\$CharDataChunk.class com/ibm/xml/internal/CharReader.class com/ibm/xml/internal/DFAContentModel.class com/ibm/xml/internal/DefaultAttrPool.class com/ibm/xml/internal/DefaultCatalog.class com/ibm/xml/internal/DefaultElementDeclPool.class com/ibm/xml/internal/DefaultEntityHandler.class com/ibm/xml/internal/DefaultEntityPool.class com/ibm/xml/internal/DefaultScanner\$StopException.class com/ibm/xml/internal/DefaultScanner.class com/ibm/xml/internal/DefaultStringPool.class com/ibm/xml/internal/EBCDICRecognizer.class com/ibm/xml/internal/ErrorCode.class com/ibm/xml/internal/InvalidEncodingException.class com/ibm/xml/internal/MIME2Java.class com/ibm/xml/internal/MixedContentModel.class com/ibm/xml/internal/SimpleContentModel.class com/ibm/xml/internal/StringHasher.class com/ibm/xml/internal/StringReader.class  com/ibm/xml/internal/UCSReader.class com/ibm/xml/internal/UCSRecognizer.class com/ibm/xml/internal/UTF8CharReader\$UTF8CharDataChunk.class com/ibm/xml/internal/UTF8CharReader.class com/ibm/xml/internal/UTF8Reader\$UTF8DataChunk.class com/ibm/xml/internal/UTF8Reader.class com/ibm/xml/internal/UTF8Recognizer.class com/ibm/xml/internal/XMLDeclReader.class com/ibm/xml/internal/msg/Message.class" 

BASEFILES="$SAXFILES $FRAMEWORKFILES $INTERNALFILES"

NVSAXFILES="$BASEFILES com/ibm/xml/parsers/SAXParser.class"

VSAXFILES="$NVSAXFILES $VALIDATIONFILE com/ibm/xml/parsers/ValidatingSAXParser.class"

NVDOMFILES="$BASEFILES $DOMIMPLFILES com/ibm/xml/parsers/NonValidatingDOMParser.class"

VDOMFILES="$NVDOMFILES $VALIDATIONFILE com/ibm/xml/parsers/DOMParser.class"

NVTXDOMFILES="$BASEFILES $TXFILES com/ibm/xml/parsers/NonValidatingTXDOMParser.class"

VTXDOMFILES="$NVTXDOMFILES $VALIDATIONFILE com/ibm/xml/parsers/TXDOMParser.class"

if test "$1" = "SAX"
 then
	FILES=$NVSAXFILES
 fi

if test "$1" = "VSAX"
 then
	FILES=$VSAXFILES
 fi

if test "$1" = "DOM" 
then
	FILES=$VDOMFILES
 fi

if test "$1" = "NVDOM"
 then
	FILES=$NVDOMFILES
 fi

if test "$1" = "TXDOM"
 then
	FILES=$VTXDOMFILES
 fi

if test "$1" = "NVTXDOM"
 then
	FILES=$NVTXDOMFILES
 fi

if test "$2" = "TXCATALOG"
 then
	FILES="$FILES com/ibm/xml/internal/TXCatalog.class"
 fi

if test "$2" = "XCATALOG" 
 then
	FILES="$FILES com/ibm/xml/internal/XCatalog\$Parser\$Resolver.class com/ibm/xml/internal/XCatalog\$Parser.class com/ibm/xml/internal/XCatalog.class" 
 fi

jar cvf custom.jar $FILES
