/*
 * (C) Copyright IBM Corp. 1998,1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.framework;

/**
 * Parameter object for the EntityPool.addEntityDecl() method
 *
 * @version Revision: 44 1.5 src/com/ibm/xml/framework/EntityDecl.java, parser, xml4j2, xml4j2_0_13 
 */
public final class EntityDecl {
    public int entityName;          // entity name
    public int entityValue;         // literal entity value
    public int publicId;            // public ID of entity
    public int systemId;            // system ID of entity
    public int notationName;        // notation for entity
};
