#
# Revision: 37 1.2 src/com/ibm/xml/parser/util/makeit.ksh, parser, xml4j2, xml4j2_0_13 
#

#
# Make script for com/ibm/xml/parser/util directory.
# This directory contains files which require $SWINGJAR.
#


. setupEnvVars.ksh


THISDIR=com/ibm/xml/parser/util
THISCLASSDIR=$XML4JCLASSFILESDIR/$THISDIR
SRCDIR=.

SRCFILES="
                HTMLPrintVisitor.java
                RecursivePreorderTreeTraversal.java
                TreeFactory.java"

case $# in
    0)  target=all;;
    *)  target=$1;;
esac

case $target in 
    all)          javac $JAVACFLAGS $SRCFILES;
                  mesg="Finished compiling all files in $THISDIR.";;
    veryclean)    rm -f $THISCLASSDIR/*.class;
                  mesg="Finished cleanup in $THISDIR.";;
    *)            echo "Target '$target' not recognized.";
                  mesg="Finished processing '$target' in $THISDIR.";;
esac

echo $mesg
exit
