package gs.admin;
import java.util.StringTokenizer;
import java.sql.ResultSet;
import java.util.Vector;
import java.util.Enumeration ;
import java.util.Hashtable;
import gs.util.Util;

import java.io.IOException;

import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.ServletContext;
import javax.servlet.ServletConfig;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpUtils;

import java.io.BufferedReader;


import gs.db.update;
import gs.db.dbStudent;
import gs.db.dbCourse;
import gs.db.dbGrade;
import gs.db.dbSurvey;
import gs.db.dbAssignment;
import gs.db.dbUser;
import gs.db.U;

import gs.admin.gCourses;


import gs.html.Html;
import gs.html.Parser;
import gs.html.RecordParser;


/**
 */
public class gGrading extends HttpServlet {

    /**
     * Grading the request.
     *
     * @exception  ServletException if there is any sort of Exception
     *
     */
  public gSystem  sys=new gSystem();




  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // doPost  doGet
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  
  public void doPost  (HttpServletRequest req,HttpServletResponse response) 
       throws IOException, ServletException 
  {
    processInOut( req,response);
  }

  public void doGet(HttpServletRequest req, HttpServletResponse response)
       throws IOException, ServletException
  {
    processInOut( req,response);
  }




  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//
  // processInOut
  //||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||//  

  public void processInOut (HttpServletRequest req,HttpServletResponse response)
       throws IOException, ServletException
  {
    response.setStatus(HttpServletResponse.SC_OK); 
    response.setContentType("text/html");
    
    ServletOutputStream out  = response.getOutputStream();
    String templatePath      = req.getPathTranslated();
    String unum              = req.getParameter("unum"); 
    String command           = req.getParameter("comm"); 
    String course            = req.getParameter("course"); 


    //System.out.println( "*** Grading ***");
    if (command==null) {
      return;
    }

    //System.out.println( "unum - - - > ["+unum+"]" );
    //System.out.println( "comm - - - > ["+command+"]" );

    try {
      if ( course==null || unum==null) {
	String coursename  = req.getParameter("coursename");

	if (coursename==null ||unum==null ) 
	  throw new Exception("State lost: Unknown course or user!.");
	String term    = req.getParameter("term");
	String year    = req.getParameter("year");
	course=coursename+term+year;
      }
      sys.accessPermission(unum,course,"GRADING_RECORDS:"+command);
       
      if (command.equals("GRMENU"))
	returnHTMLPage(out, unum, course, templatePath);

      else if(command.indexOf("Assignments listed")>=0)
	returnHTMLPage(out, unum, course, templatePath+"assignments.html");

      else if(command.indexOf("Students listed")>=0)
	returnHTMLPage(out, unum, course, templatePath+"students.html");

      else if(command.equals("INFO"))
	infoPage(out, unum, course, templatePath);
      
      else if(command.equals("LISTASSIGNMENTS")) 
	 listAssignments(out, unum, course, templatePath);
   
      else if(command.equals("LISTSTUDENTS")) 
	 listStudents(out, unum, course, templatePath);

      else if(command.equals("GRADEASSIGNMENT"))
	gradeAssignment(out, unum, course,req.getParameter("assignid"), templatePath);

      else if(command.equals("GRADESTUDENT"))
	gradeStudent(out, unum, course,req.getParameter("accesscode"), templatePath);
      else if(command.equals("UPDATE_A_GRADE"))
	updateAssignmentGrade(out, unum, course,templatePath,readGradingFields(req));

      else if(command.equals("UPDATE_A_STUDENT"))
	updateStudentGrades(out, unum, course,templatePath,req);

      else if(command.indexOf("Statistics")>=0) 
	returnHTMLPage(out, unum, course, templatePath+"statistics.html");


      else if(command.equals("AVERAGE_ST"))
	 prepareGradeSts(out, unum, course, templatePath,"average");

      else if(command.equals("GRADE_ST"))
	 prepareGradeSts(out, unum, course, templatePath,req.getParameter("assignid"));

      else if(command.equals("RANKS"))
	 ranks(out, unum, course, templatePath);


      else if(command.equals("RECALCULATE_AVG"))
	 recalculate(out, unum, course, templatePath);

      else if(command.indexOf("Survey")>=0) 
	returnHTMLPage(out, unum, course, templatePath+"surveys.html");


      else if(command.equals("LISTSURVEYS"))
	listSurveys(out, unum, course, templatePath);

      else if(command.equals("SHOWSURVEY"))
	showSurveyResults(out, unum, course, templatePath,req.getParameter("surveyname"));

      else if(command.indexOf("Set Options")>=0)
	returnHTMLPage(out, unum, course, templatePath+"options.html");

      else if(command.indexOf("SETOPTIONS")>=0)
	currentOptions(out, unum, course, templatePath);

      else if(command.indexOf("SETOPTION")>=0)
	setOption(out, unum, course, templatePath,command,req.getParameter("prefer"));



      else if(command.equals("SHOWSTUDENTSTDVIEWGRADES"))
	showGrades(out,unum,course,req.getParameter("accesscode"),templatePath,"","STUDENT");

      else if(command.equals("SHOWSTUDENTINSVIEWGRADES"))
	showGrades(out,unum,course,req.getParameter("accesscode"),templatePath,"","INS");



       else if(command.equals("LISTALL"))
	 listGradings(out, unum, course, req.getPathTranslated(), true,"");

       else if(command.equals("NEW"))
	 newGrading(out, unum, course, req.getPathTranslated());

       else if(command.equals("ADD")) 
	 addGrading(out, unum, course, readGradingFields(req) , req.getPathTranslated());
       else if(command.equals("SHOW"))
	 browseGrading(out, unum,  req.getParameter("assignid"), course, req.getPathTranslated(),"don't reload");



       else if(command.equals("SKIP"))
	 skip(out, unum, course, req.getPathTranslated());


       else if(command.equals("CANCEL")) 
	 out.println("<script language=JavaScript> history.go(-2);</script>");
       else if(command.equals("EDIT"))
	 editGradingRecord(out, unum,  req.getParameter("assignid"),  course, req.getPathTranslated());


	 else if(command.equals("DELETE"))
	   deleteGrading(out, unum,  req.getParameter("assignid"), course, req.getPathTranslated(), (String)(req.getParameter("answer")));

	 else if(command.equals("UPDATE")) 
	   updateGrading(out, unum, course, readGradingFields(req), req.getPathTranslated());
	 else if(command.equals("PUBLISH"))
	   publish(out, unum, req.getParameter("assignid") ,course, req.getParameter("publish") , req.getPathTranslated());


   
     } catch (Exception e) {
       //System.out.println( "Error catched. " );
       //if (e.getMessage()!=null)
	 //System.out.println( e.getMessage());
       //System.out.println( "ERROR CATCHED. " );
       
       e.printStackTrace(); 
       sys.error(out,e);
       sys.error(out,e.getMessage());
     }
     
     //    out.println( Html.footer() );
     out.close();
  
  }
  void updateStudentGrades(ServletOutputStream out, String unum, String course, String templateFile,HttpServletRequest req)throws Exception  {

    dbUser u=sys.usr_cache.get(unum);
    int  PRIVILIGE=Integer.parseInt((String) u.fields.get("privilige"));
    boolean ins=false;
    if (PRIVILIGE<U.TA) ins=true;

    StringTokenizer  assignids   = new StringTokenizer(req.getParameter("ids"),",");
    String accesscode =req.getParameter("accesscode");
    dbGrade g=new dbGrade();
    while ( assignids.hasMoreElements() ) {
            String next=assignids.nextToken();
	    //String  next=
      //System.out.println("assignids{"+next);
      String assignid   = next; //req.getParameter("assignid"); 
      //System.out.println("assignid --------->" + assignid);
      
      g.fields.put("assignid"     , assignid);    
      g.fields.put("accesscode"     ,accesscode);
      g.fields.put("course"     , course);
      g.fields.put("grade"     , req.getParameter("grade"+next));
      g.fields.put("egrade"     , req.getParameter("egrade"+next));
      g.fields.put("partials"       , req.getParameter("partials"+next).replace('\'','`'));  
      g.fields.put("comment"     , req.getParameter("comment"+next).replace('\'','`'));
      g.fields.put("tacomment"     , req.getParameter("tacomment"+next).replace('\'','`'));
      if (ins) 
	g.fields.put("secretcomment"     ,req.getParameter("secretcomment"+next).replace('\'','`'));

      g.fields.put("grbase" , req.getParameter("grbase"+next));
      g.fields.put("weight" ,req.getParameter("weight"+next));
     dbAssignment dba=sys.asgn_cache.get(assignid,course) ;   
     dba.fields.put("oldassignid" ,assignid );
     dba.fields.put("grbase" , req.getParameter("grbase"+next));
     dba.fields.put("weight" ,req.getParameter("weight"+next));
     sys.asgn_cache.update(dba);

     g.setIdentification();
     g.update(ins);
    }
    g.fields.put("remark"     , req.getParameter("remark").replace('\'','`'));
    g.fields.put("taremark"     , req.getParameter("taremark").replace('\'','`'));
    if (ins) 
      g.fields.put("secretremark"     ,req.getParameter("secretremark").replace('\'','`'));
    g.fields.put("finalgrade"     , req.getParameter("finalgrade"));
    g.fields.put("average"     , req.getParameter("average"));
    g.updatePerformance(ins);
    

     showGrades(out,unum,course,accesscode,templateFile,"WRITEAVERAGE","INS");


  }


  //--------------------------------------------------------------------//
  //Reads Grading fields from the html request form
  //--------------------------------------------------------------------//
  public dbGrade readGradingFields(HttpServletRequest req) throws Exception {

    dbGrade u=new dbGrade();
    String assignid   = req.getParameter("assignid"); 
    String  course    = req.getParameter("course");
    String accesscode =req.getParameter("accesscode");
    if(assignid.equals("") ) 
      throw new Exception("Please enter grading id!");
    else {
      u.fields.put("assignid"     , assignid);    
      u.fields.put("accesscode"     ,accesscode);
      u.fields.put("course"     , course);
      u.fields.put("grade"     , req.getParameter("grade"));
      u.fields.put("egrade"     , req.getParameter("egrade"));
      u.fields.put("partials"       , req.getParameter("partials").replace('\'','`'));  
      u.fields.put("comment"     , req.getParameter("comment").replace('\'','`'));
      u.fields.put("tacomment"     , req.getParameter("tacomment").replace('\'','`'));
      String sc=req.getParameter("secretcomment");
      if (sc!=null) {
	u.fields.put("secretcomment"     , sc.replace('\'','`'));
      } else { 
	//System.out.println("accesscode"+accesscode+"  assignid"+ assignid+"course "+course);
	u.fields.put("secretcomment"     ,u.getSecretComment(accesscode,assignid,course));
      }


      u.fields.put("grbase" , req.getParameter("grbase"));
     u.fields.put("weight" ,req.getParameter("weight"));
     dbAssignment dba=sys.asgn_cache.get(assignid,course) ;   
     dba.fields.put("oldassignid" ,assignid );
     dba.fields.put("grbase" , req.getParameter("grbase"));
     dba.fields.put("weight" ,req.getParameter("weight"));
     sys.asgn_cache.update(dba);

    }
    u.setIdentification();
    return u;

  }
 


  //--------------------------------------------------------------------//
  //returnMainPage(
  //--------------------------------------------------------------------//  
  void returnHTMLPage(ServletOutputStream out, String unum,String course, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      Parser.parseHtml(templateFile,ht , out);
  }
  //--------------------------------------------------------------------//
  // List ALL gradings 
  //--------------------------------------------------------------------//  
  void listAssignments(ServletOutputStream out, String unum, String course, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      dbAssignment dba = new dbAssignment(course);
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(dba.listAssignments(false), dba.listAssignmentsFields(false)));
   }
   //--------------------------------------------------------------------//
  // List ALL gradings 
  //--------------------------------------------------------------------//  
  void listStudents(ServletOutputStream out, String unum, String course, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      dbStudent dba = new dbStudent(course);
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(dba.listStudents(false), dba.listStudentsFields(false)));
   }
 


  void gradeAssignment(ServletOutputStream out, String unum, String course, String assignid, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
    dbGrade dbg = new dbGrade(course,assignid);
    dbUser u=sys.usr_cache.get(unum);
    int  PRIVILIGE=Integer.parseInt((String) u.fields.get("privilige"));
    String secret="";
    if (PRIVILIGE<U.TA)
     {  secret="NONE";
     ht.put("hiddenta","text");  ht.put("sc","secretcomment"); 
     }
    else if (PRIVILIGE>=U.TA)
     { secret="TA";
     ht.put("hiddenta","hidden"); ht.put("sc",""); 
     }
    else { secret="STUDENT";
     ht.put("hiddenta","hidden");ht.put("sc",""); 
    }
    //System.out.println("PRIVILIGE U.TA "+PRIVILIGE+"<"+U.TA  );

    //------------
    BufferedReader lines = Parser.parseHtmlOpen (templateFile );
    String record=Parser.parseHtmlUntilRecord (ht, out, lines );

    
    // ResultSet rs =dbg.openAssignmentGrades(secret,record,ht, out);
    RecordParser rp=new RecordParser(dbg.openAssignmentGrades(), dbg.assignmentGradesFields());   
    String gstr="";
  
    dbCourse dbc=sys.crs_cache.get(course);
    boolean grdtypeCst=false;
    if ( ((String)dbc.fields.get("grdtype")).equals("customized")) {
      grdtypeCst=true;
      gstr=dbg.courseCustomizedGradesHtml ();
    }

    while( rp.handleRecord(ht) ) {
      dbg.getStudentGrade(secret,ht);
      if (grdtypeCst) {
	ht.put("gradehtml","<select name=grade><option>"+(String)ht.get("grade")+gstr);
	ht.put("egradehtml","<select name=egrade><option>"+(String)ht.get("egrade")+gstr);
	ht.put("grbasehtml","<select name=grbase onChange=selectAllGB(this.form.GB.options.selectedIndex) ><option>"+(String)ht.get("grbase")+gstr);
      }else {
	ht.put("gradehtml","<input name=grade size=3 value="+(String)ht.get("grade")+" >");
	ht.put("egradehtml","<input name=egrade size=3 value="+(String)ht.get("egrade")+" >");
	ht.put("grbasehtml","<input name=grbase size=3 value=\""+(String)ht.get("grbase")+"\" onChange=setAllGB(this.form.grbase.value)>");
      }
      Parser.parseLine(ht, record, out); 
    }   

   dbg.closeAssignmentGrades();

    Parser.parseHtmlAfterRecord ( ht, out, lines );

    //------------


    

  
  }

  void updateAssignmentGrade(ServletOutputStream out, String unum, String course, String templateFile,dbGrade g)throws Exception  {
    g.update(true);
    showGrades(out,unum,course,g.accesscode,templateFile,"WRITEAVERAGE","");


  }
  public  void showGrades(ServletOutputStream out, String unum, String course, String accesscode , String templateFile, String dbcase,String WHO)throws Exception  {


    Hashtable sht=sys.std_cache.get(accesscode,course).getFields();
    Hashtable ht=new Hashtable();
    ht.put("firstname",sht.get("firstname"));
    ht.put("midname",sht.get("midname"));
    ht.put("lastname",sht.get("lastname"));
    ht.put("dept",sht.get("dept"));
    ht.put("class",sht.get("class"));
    ht.put("url",sht.get("url"));
    ht.put("email",sht.get("email"));
    ht.put("accesscode",accesscode);

    sys.globalValues(ht,unum);
    ht.put("course",course);
    dbGrade dbg = new dbGrade(course);
    // dbg.studentPerformanceReadSet(accesscode,ht,dbcase);
    String secret="";
    ht.put("tacomment","");
    ht.put("secretcomment","");
    if (WHO.equals("STUDENT")) {
      dbCourse dbc=sys.crs_cache.get(course);
      ht.put("publishAVG",dbc.fields.get("publishavg"));
      ht.put("publishFGR",dbc.fields.get("publishfgrd"));
      secret="STUDENT";
      ht.put("hiddenta","true");  
      ht.put("hiddenins","true"); 
   } else {
      ht.put("studentview","YES");
      dbUser u=sys.usr_cache.get(unum);
      int  PRIVILIGE=Integer.parseInt((String) u.fields.get("privilige"));
      if (PRIVILIGE<U.TA)      {  
	secret="NONE";
	ht.put("hiddenta","false");  
	ht.put("hiddenins","false"); 
      }
      else if (PRIVILIGE>=U.TA)     { 
	secret="TA";
	ht.put("hiddenta","false");  
	ht.put("hiddenins","true"); 
      }
      else { return;
      }
      ht.put("publishECR","YES");
      ht.put("publishAVG","YES");
      ht.put("publishFGR","YES");

    }
    //    Parser.parseHtml(templateFile, ht, out,  new RecordParser(dbg.studentGrades(accesscode,  secret), dbg.studentGradesFields(secret)));




   //------------
    BufferedReader lines = Parser.parseHtmlOpen (templateFile );
    String record=Parser.parseHtmlUntilRecord (ht, out, lines );
    
    //   RecordParser rp=new RecordParser(dbg.studentGrades(accesscode,  secret), dbg.studentGradesFields(secret));
    RecordParser rp=new RecordParser(dbg.assignments(), dbg.assignmentsFields());

    ht.put("accesscode",accesscode);
    String [] gstr= new String[1];
    String ids="";
    //    boolean grdtypeCst=  dbg.courseCustomizedGradesHtml (gstr);
    ResultSet rs =dbg.getStudentGrades(secret,ht);
    boolean hasrecord=rs.next();
    while( rp.handleRecord(ht) ) {
      dbg.assignid=(String)ht.get("assignid");
      if (WHO.equals("STUDENT")) {
	if (sys.asgn_cache.get(dbg.assignid,course).fields.get("publish").equals("NO"))
	  continue;
      }
      
      hasrecord=dbg.fetchStudentGrade(rs,secret,ht,dbg.assignid,hasrecord);
      Parser.parseLine(ht, record, out); 
    }   
    dbg.studentPerformanceReadSet(accesscode,ht,"WRITEAVERAGE");

   dbg.closeDB();
   if (secret.equals("TA")) ht.remove("secretremark");
   if (secret.equals("STUDENT")) {ht.remove("secretremark");ht.remove("taremark"); }
   
   Parser.parseHtmlAfterRecord ( ht, out, lines );

    //------------
  




    
  }



  ////////////////////////
  void gradeStudent(ServletOutputStream out, String unum, String course, String accesscode, String templateFile)
       throws Exception, IOException 
  {
    Hashtable sht=sys.std_cache.get(accesscode,course).getFields();
    Hashtable ht=new Hashtable();
    ht.put("firstname",sht.get("firstname"));
    ht.put("midname",sht.get("midname"));
    ht.put("lastname",sht.get("lastname"));
    ht.put("dept",sht.get("dept"));
    ht.put("class",sht.get("class"));
    ht.put("email",sht.get("email"));
    ht.put("accesscode",sht.get("accesscode"));
    sys.globalValues(ht,unum);
    ht.put("course",course);

    dbGrade dbg = new dbGrade(course);
    dbg.openDB();
    dbUser u=sys.usr_cache.get(unum);
    int  PRIVILIGE=Integer.parseInt((String) u.fields.get("privilige"));
    String secret="";
    if (PRIVILIGE<U.TA)
     {  secret="NONE";
     ht.put("hiddenta","text");  ht.put("sc","secretcomment"); 
     ht.put("sr","secretremark"); 
     }
    else if (PRIVILIGE>=U.TA)
     { secret="TA";
     ht.put("hiddenta","hidden"); ht.put("sc",""); 
     }
    //System.out.println("PRIVILIGE U.TA "+PRIVILIGE+"<"+U.TA  );

   //------------
    //------------
    BufferedReader lines = Parser.parseHtmlOpen (templateFile );
    String record=Parser.parseHtmlUntilRecord (ht, out, lines );
    
    //   RecordParser rp=new RecordParser(dbg.studentGrades(accesscode,  secret), dbg.studentGradesFields(secret));
    RecordParser rp=new RecordParser(dbg.assignments(), dbg.assignmentsFields());

    ht.put("accesscode",accesscode);
    String gstr="";
    String ids="";
    dbCourse dbc=sys.crs_cache.get(course);
    boolean grdtypeCst=false;
    if ( ((String)dbc.fields.get("grdtype")).equals("customized")) {
      grdtypeCst=true;
      gstr=dbg.courseCustomizedGradesHtml ();
    }
    ResultSet rs =dbg.getStudentGrades(secret,ht);
    boolean  hasRecord=rs.next();
    while( rp.handleRecord(ht) ) {
      dbg.assignid=(String)ht.get("assignid");
      String n=dbg.assignid;
      ids+=","+dbg.assignid;
      //   dbg.getStudentGrade(secret,ht);
      hasRecord=dbg.fetchStudentGrade(rs,secret,ht,dbg.assignid,hasRecord);

      if (grdtypeCst) {
	ht.put("gradehtml","<select name=grade"+n+"><option>"+(String)ht.get("grade")+gstr);
	ht.put("egradehtml","<select name=egrade"+n+"><option>"+(String)ht.get("egrade")+gstr);
	ht.put("grbasehtml","<select name=grbase"+n+"  ><option>"+(String)ht.get("grbase")+gstr);
      }else {
	ht.put("gradehtml","<input name=grade"+n+" size=3 value="+(String)ht.get("grade")+" >");
	ht.put("egradehtml","<input name=egrade"+n+" size=3 value="+(String)ht.get("egrade")+" >");
	ht.put("grbasehtml","<input name=grbase"+n+" size=3 value="+(String)ht.get("grbase")+">");
	
      }
      ht.put("n",dbg.assignid);
      Parser.parseLine(ht, record, out); 
    }   
    dbg.studentPerformanceReadSet(accesscode,ht,"JUSTREAD");

   dbg.closeDB();
   if (ids.length() >0)
     ids=ids.substring(1);
   ht.put("ids",ids);
   if (PRIVILIGE>=U.TA) ht.remove("secretremark");
   Parser.parseHtmlAfterRecord ( ht, out, lines );

    //------------
  
  }













  //--------------------------------------------------------------------//
  // List ALL gradings 
  //--------------------------------------------------------------------//  
  void listGradings(ServletOutputStream out, String unum, String course, String templateFile, boolean allFields,String reload)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      ht.put("reload",reload);
      dbGrade dba = new dbGrade(course);
      //      Parser.parseHtml(templateFile, ht, out,  new RecordParser(dba.listGradings(allFields), dba.listGradingsFields(allFields)));
   }
  //--------------------------------------------------------------------//
  // info page
  //--------------------------------------------------------------------//  
  void infoPage(ServletOutputStream out, String unum,String course ,String templateFile) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      ht.put("course",course);
      sys.globalValues(ht,unum);
      Parser.parseHtml(templateFile,ht,out);
  }

  //--------------------------------------------------------------------//
  // Browse a grading
  //--------------------------------------------------------------------//  
  void browseGrading (ServletOutputStream out, String unum,String assignid ,String course, String templateDir,String reload) 
       throws Exception, IOException
  {
    //    if(assignid.length() >= gGradings.MIN_LOGIN_NAME_LENGTH) {
      try {
	//Hashtable ht=dbGrade.getFields( assignid );
	Hashtable ht=sys.asgn_cache.get(assignid,course).getFields();
	sys.globalValues(ht,unum);
	ht.put("course",course);
	ht.put("assignid",assignid);
	ht.put("reload",reload);
	if (ht.get("type").equals("A"))
	  ht.put("type_html","Grading");
	else ht.put("type_html",ht.get("type"));
	Parser.parseHtml(templateDir+"browse.html",ht , out);
      
      } catch(Exception e) {
	throw new Exception("<h2>ERROR at browsing grading "+assignid+": "+e.getMessage()+"</h2>");
      }
      // } else {
      // throw new Exception("<h2>ERROR:Illegal grading login name '"+assignid+"'.</h2>");
      // }
  }

  //--------------------------------------------------------------------//
  // open new grading page 
  //--------------------------------------------------------------------//  
  void newGrading  (ServletOutputStream out, String unum,String course, String templateDir)
       throws  Exception, IOException
  {
     dbGrade dba=new dbGrade(course);
     String next= Integer.toString(dba.findMaxAI()+1);
     String grbase="";
     String optionstr="";
     dbCourse dbc=sys.crs_cache.get(course);
     String grtype=dbc.gradingType();
     //System.out.println("gradingTyadaBASEpe ===++>"+grbase);

     if (grtype.equals("customized")) {
       optionstr="Customized grades";
       grbase= "<select name=grbase><option>"+dbc.customizedGradesHtml()+"</select>";
     } else {
       optionstr="Numeric option selected";
       grbase= "<input name=grbase size=5 value=>";
     }
      Hashtable ht= new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      ht.put("optionstr",optionstr);
      ht.put("next",next);
      ht.put("grbase",grbase);
      Parser.parseHtml(templateDir+"new.html", ht, out);
  }


   //--------------------------------------------------------------------//
  //  editGradingRecord page
  //--------------------------------------------------------------------//  
  void editGradingRecord (ServletOutputStream out, String unum, String assignid,String course, String templateDir)        
       throws  Exception, IOException
  {
    /*    dbGrade dba=sys.asgn_cache.get(assignid,course);
    //Hashtable ht=dbGrade.getFields(assignid);
    Hashtable ht=dba.getFields();
    sys.globalValues(ht,unum);
    if (dba.fields.get("type").equals("A"))
      ht.put("type_html","Grading");
    else ht.put("type_html",dba.fields.get("type"));
     String grbase=dba.gradingBase();
     String optionstr="";
     dbCourse dbc=sys.crs_cache.get(course);
     String grtype=dbc.gradingType();
     System.out.println("gradingTyadaBASEpe ===++>"+grbase);
     System.out.println("gradin+++-------------------"+dba.gradingBase());

     if (grtype.equals("customized")) {
       optionstr="Customized grades";
       grbase= "<select name=grbase><option>"+grbase+dbc.customizedGradesHtml()+"</select>";
     } else {
       optionstr="Numeric option selected";
       grbase= "<input name=grbase size=5 value="+grbase+">";
     }
    System.out.println("gradin++++++++++++++++++++++++>"+grbase);
    System.out.println("gradin++++++++++++++++++++++++>"+dba.gradingBase());
     String publish="<option>YES<option>NO";
     if (dba.fields.get("publish").equals("NO"))
       publish="<option>NO<option>YES";

     ht.put("publish_html",publish);
      ht.put("grbase_html",grbase);
      ht.put("optionstr",optionstr);
    ht.put("course",course);
    ht.put("oldassignid", assignid);
    Parser.parseHtml(templateDir+"edit.html", ht, out);
    */
  }

  //--------------------------------------------------------------------//
  // DELETE a grading
  //--------------------------------------------------------------------//  
  void deleteGrading (ServletOutputStream out, String unum, String assignid,String course,String templateDir, String answer) 
       throws Exception, IOException
  {
    String templateFile=templateDir;;
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      if(answer == null) {

	templateFile+="confirm.html";
	ht.put("message", "<br>Do you really want to delete the grading <i>"+assignid+"</i>?");
	ht.put("actionurl", "updatemessage.html");
	ht.put("comm","DELETE");	
	ht.put("assignid",assignid);
      } 
      else if(answer.equals("YES")) {
	//dbGrade.delete(assignid);
	sys.asgn_cache.delete(assignid,course);
	ht.put("message", "Grading information has been succesfully deleted!");
      }
      else if(answer.equals("NO")) {
	out.println("<script language=JavaScript> history.go(-2);</script>");
      }
      Parser.parseHtml(templateFile, ht, out);
      
  }

  //--------------------------------------------------------------------//
  // add new Grading
  //--------------------------------------------------------------------//  
  void addGrading(ServletOutputStream out, String unum,String course, dbGrade dbu, String templateFile )
       throws Exception,IOException
  {
    try {
      //dbu.add();
      //      sys.asgn_cache.add(dbu);
      browseGrading(out, unum,dbu.assignid,course,templateFile,"reload");
	
    } catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("This grading login id exists in the system. <br> Please try another one.");
	}
      throw new Exception(error);
    }    
  }
  //--------------------------------------------------------------------//
  // update grading record 
  //--------------------------------------------------------------------//  

  void updateGrading(ServletOutputStream out, String unum,String course, dbGrade dbu,String templateDir)
       throws Exception,IOException
    {
      try {
	Hashtable ht = new Hashtable();
	sys.globalValues(ht,unum);
	//	dbu.update();
	//	sys.asgn_cache.update(dbu);
      browseGrading(out, unum,dbu.assignid,course,templateDir,"reload");
	
      } catch( Exception e ) {
	out.println( Html.header("Grading Records") );
	String error =e.getMessage();
	if (error.indexOf("unique") >=0) {
	  error= new String("This grading login id exists in the system. <br> Please try another one.");
	}
	throw new Exception(error);
      }   
    }
  //--------------------------------------------------------------------//
  // 
  //--------------------------------------------------------------------//  
  void skip(ServletOutputStream out, String unum,String course,String templateDir) 
       throws Exception,IOException
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
	ht.put("course",course);
      Parser.parseHtml(templateDir+"info.html",ht,out);
  }



  //--------------------------------------------------------------------//
  // GRADING: 
  //--------------------------------------------------------------------//  
 
  void publish (ServletOutputStream out, String unum, String assignid,String course,String publish, String templateFile)        
       throws  Exception, IOException
  {
    /*    dbGrade dba=sys.asgn_cache.get(assignid,course);
    if (publish.equals("NO")) publish="YES";
    else publish="NO";
    dba.fields.put("publish",publish);
    dba.fields.put("oldassignid",assignid);    
    sys.asgn_cache.update(dba);  
    listGradings(out, unum, course, templateFile, false,"INFOreload");
    out.println("<script language=JavaScript> history.go(-2); ");
    */
  }
  //*************************************************************************
  //*************************************************************************

  //*************************************************************************

  //*************************************************************************

  //*************************************************************************

  //*************************************************************************

  //*************************************************************************/


  void sort(double a[]) throws Exception {
        for (int i = a.length; --i>=0; ) {
            boolean swapped = false;
            for (int j = 0; j<i; j++) {
                if (a[j] > a[j+1]) {
                    double T = a[j];
                    a[j] = a[j+1];
                    a[j+1] = T;
                    swapped = true;
                }

            }
            if (!swapped)
                return;
        }
  }
 

  void prepareGradeSts(ServletOutputStream out, String unum, String course, String templateDir,String Assignment)
       throws Exception, IOException 
  {

    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    dbGrade dbg = new dbGrade(course);
    dbg.openDB();
    boolean customized=dbg.checkGradeCustomization();
      ResultSet rs=null;
      String value="";
      if (Assignment.equals("average")) {
	value="average";
	rs=dbg.allAverages();  ht.put("type","Average");
	ht.put("explain","");
      }else {
	value="grade";
	rs=dbg.allGrades(Assignment); 
	ht.put("type","Individual Assignment (#"+Assignment+")");
	ht.put("explain","Please note that extra grades are not included here.");
      }


    if (customized) {
      
      while (rs.next() ) {
	String gr=Util.null2str(rs.getString(value));
	Integer I=(Integer)ht.get(gr);
	if (I==null) I=new Integer(1); else I=new Integer( 1+I.intValue());
	ht.put(gr,I);
      }
      BufferedReader lines = Parser.parseHtmlOpen (templateDir+"displayStatisticsCustomized.html" );
      String record=Parser.parseHtmlUntilRecord (ht, out, lines );
      rs=dbg.getCustomizedGrades();      
      while (rs.next() ) {
	String gr=Util.null2str(rs.getString("grade"));
	//System.out.println("gr*************** "+ gr);
	Integer I=(Integer)ht.get(gr); 
	String cstr="0";  
	if (I!=null) cstr=I.toString(); 
	ht.put("value",gr);
	ht.put("valueHeight",cstr);
	Parser.parseLine(ht, record, out); 
      }      
       Parser.parseHtmlAfterRecord ( ht, out, lines );
    }
    else {
      Vector v=new Vector();
      int i=0,last=0;
      while (rs.next() ) {
	try {v.addElement(new Double(rs.getDouble(value))); last++; }
	catch (Exception e){}
      } 
      double [] d=new double[last];
      for (Enumeration e = v.elements() ; e.hasMoreElements() ; i++) {
	 d[i]= ((Double)e.nextElement()).doubleValue();
      }
      sort (d);    
      BufferedReader lines = Parser.parseHtmlOpen (templateDir+"displayStatisticsNumeric.html" );
      String record=Parser.parseHtmlUntilRecord (ht, out, lines );
      for (i=0;i<last;i++){
	ht.put("value",Integer.toString((int)d[i]));
	ht.put("valueHeight",  Integer.toString(1+(int)(d[i]*2)));
	// communicator has problem to show 0 hegiht
	Parser.parseLine(ht, record, out); 
       }
      Parser.parseHtmlAfterRecord ( ht, out, lines );
    }

  }

  void ranks(ServletOutputStream out, String unum, String course, String templateFile)
       throws Exception, IOException 
  {

    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    dbGrade dbg = new dbGrade(course);
    boolean customized=dbg.checkGradeCustomization();

    Hashtable gr = new Hashtable();
    Hashtable grR = new Hashtable();

    if (customized) {
      dbg.getCustomizedGradePairs(course,gr);
    }
    // else 
      {
      ResultSet rs=dbg.ranks();
      Vector v=new Vector();
      Hashtable names=new Hashtable();
      int i=0,last=0;
      while (rs.next() ) {
	try {
	  Double D=null;
	  if (customized) {
	    D=(Double)gr.get(Util.null2str(rs.getString("average")));
	    grR.put(D,Util.null2str(rs.getString("average")));
	  }
	  else
	    D=new Double(rs.getDouble("average"));
	  String name=Util.null2str(rs.getString("firstname"))+" "+Util.null2str(rs.getString("midname"))+" "+Util.null2str(rs.getString("lastname"));
	  name=Util.null2str(rs.getString("accesscode"))+" > <b> " + name;
	  Vector vh=(Vector)names.get(D);
	  if ( vh==null) vh=new Vector();
	  vh.addElement(name);
	  names.put(D,vh);
	  v.addElement(D); last++; 
	}catch (Exception e){}
      } 
      double [] d=new double[last];
      for (Enumeration e = v.elements() ; e.hasMoreElements() ; i++) {
	 d[i]= ((Double)e.nextElement()).doubleValue();
      }
      sort (d);    
      BufferedReader lines = Parser.parseHtmlOpen (templateFile);
      String record=Parser.parseHtmlUntilRecord (ht, out, lines );
      if (customized) 
	for (i=last-1;i>=0;){
	  Double D=new Double(d[i]);
	  ht.put("value", grR.get(D) ); //+"<i> "+d[i]+"</i>"
	  Vector vh=(Vector)names.get( D );
	  for (Enumeration e = vh.elements() ; e.hasMoreElements() ; ) {
	    ht.put("accesscodename", e.nextElement());
	    Parser.parseLine(ht, record, out); 
	    i--;
	  }
	}
      else
	for (i=last-1;i>=0;){
	  ht.put("value",Integer.toString((int)d[i]));
	  Vector vh=(Vector)names.get(  new Double(d[i]) );
	  for (Enumeration e = vh.elements() ; e.hasMoreElements() ; ) {
	    ht.put("accesscodename",  e.nextElement());
	    Parser.parseLine(ht, record, out); 
	    i--;
	  }
	}
      Parser.parseHtmlAfterRecord ( ht, out, lines );
    }
  }
  void recalculate(ServletOutputStream out, String unum, String course, String templateFile)
       throws Exception, IOException 
  {
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    dbGrade dbg = new dbGrade(course);
    int counter=dbg.calculateAllaverages();
    ht.put("numofstd",Integer.toString(counter));
    Parser.parseHtml(templateFile,ht,out);
   
  }


  //--------------------------------------------------------------------//
  // SURVEY:
  //--------------------------------------------------------------------//  
  //--------------------------------------------------------------------//
  // List ALL gradings 
  //--------------------------------------------------------------------//  
  void listSurveys(ServletOutputStream out, String unum, String course, String templateFile)
       throws Exception, IOException 
  {
      Hashtable ht = new Hashtable();
      sys.globalValues(ht,unum);
      ht.put("course",course);
      dbSurvey dbs=new dbSurvey(course);
      Parser.parseHtml(templateFile, ht, out,  new RecordParser(dbs.listSurveys(false), dbs.listSurveysFields(false)));
   }

  void showSurveyResults(ServletOutputStream out, String unum, String course, String templateFile,String surveyname)
       throws Exception, IOException 
  {

    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("surveyname",surveyname);
    ht.put("course",course);




   //------------
    BufferedReader lines = Parser.parseHtmlOpen (templateFile );
    String record=Parser.parseHtmlUntilRecord (ht, out, lines );

    dbSurvey s=new dbSurvey();
    RecordParser rp= new RecordParser(s.surveyQuestions(course,surveyname),s.surveyQuestionsFields(course,surveyname)  );
    dbGrade dbg=new dbGrade(course);
    // Hashtable ans=new Hashtable();
    dbg.surveyAnswers(ht,course,surveyname);
    String ctg="";
    ht.put("","");
    while( rp.handleRecord(ht) ) {
      String dbctg=(String)ht.get("category");
      if ( !ctg.equals(dbctg)) {
	ctg=dbctg;
	ht.put("categoryhtml","</TABLE><h2>"+ctg+"</h2><TABLE bgcolor=pink><tr><td width=300></td><td width=15><b>0</td><td width=15><b>1</td><td width=15 ><b> 2</td><td width=15 ><b> 3</b></td><td width=15><b>4</td></tr>");
      } else 
	ht.put("categoryhtml","");
      ht.put("start",ht.get("qid"));
      //System.out.println("qid " + (String)ht.get("qid") +"");
      Parser.parseLine(ht, record, out); 
    }   
    Parser.parseHtmlAfterRecord ( ht, out, lines );

    //------------
  
  }
    /*  void browseSurvey(ServletOutputStream out, String unum, String templateDir,String course,String surveyname)
       throws Exception, IOException 
  {
    if (surveyname==null) 
      throw new Exception("Please select the survey name first!");
    Hashtable ht = new Hashtable();
    sys.globalValues(ht,unum);
    ht.put("surveyname",surveyname);
    ht.put("course",course);


    dbSurvey s=new dbSurvey();
    Parser.parseHtml(templateDir+"browse.html", ht, out,  new RecordParser(s.surveyQuestions(course,surveyname),s.surveyQuestionsFields(course,surveyname)    ));
  }
  */


  void currentOptions(ServletOutputStream out, String unum, String course, String templateFile)
       throws Exception, IOException 
  {

    Hashtable ht=sys.crs_cache.get(course).getFields();
    sys.globalValues(ht,unum);
    ht.put("course",course);
    if ( ((String)ht.get("extracredits")).equals("YES")) {
      ht.put("toYESNOextra","NO");
      ht.put("redgreenextra_light","green_light");
      ht.put("grayredextra","gray");
      ht.put("graygreenextra","#09e009");
    } else {
      ht.put("toYESNOextra","YES");
      ht.put("redgreenextra_light","red_light");
      ht.put("grayredextra","red");
      ht.put("graygreenextra","gray");
    }
    if ( ((String)ht.get("publishavg")).equals("YES")) {
      ht.put("toYESNOpavg","NO");
      ht.put("redgreenpavg_light","green_light");
      ht.put("grayredpavg","gray");
      ht.put("graygreenpavg","#09e009");
    } else {
      ht.put("toYESNOpavg","YES");
      ht.put("redgreenpavg_light","red_light");
      ht.put("grayredpavg","red");
      ht.put("graygreenpavg","gray");
    }
    if ( ((String)ht.get("publishfgrd")).equals("YES")) {
      ht.put("toYESNOpfg","NO");
      ht.put("redgreenpfg_light","green_light");
      ht.put("grayredpfg","gray");
      ht.put("graygreenpfg","#09e009");
    } else {
      ht.put("toYESNOpfg","YES");
      ht.put("redgreenpfg_light","red_light");
      ht.put("grayredpfg","red");
      ht.put("graygreenpfg","gray");
    }
    Parser.parseHtml(templateFile,ht , out);
  }
 void setOption(ServletOutputStream out, String unum, String course, String templatePath,String option,String preference)
       throws Exception, IOException 
  {
    dbCourse dbc=sys.crs_cache.get(course);
    if(option.indexOf("EXTRACR")>=0)
      dbc.fields.put("extracredits",preference);
    else     if(option.indexOf("PUBLISHAVG")>=0)
      dbc.fields.put("publishavg",preference);
    else     if(option.indexOf("PUBLISHFGR")>=0)
      dbc.fields.put("publishfgrd",preference);
    sys.crs_cache.update(dbc);
    currentOptions(out, unum, course, templatePath);

  }

 


} //class close




