
---------------------------LAYOUS-----------------------------------5--
CREATE TABLE layouts (

	course 		CHAR(50) NOT NULL,
	page  		CHAR(50) NOT NULL,
	layoutname 	CHAR(50) NOT NULL,
	file	 	CHAR(200)

) \g

CREATE UNIQUE  INDEX index_layouts ON layouts (
        course,
	page,
	layoutname
	
) \g
######################################################
#delete from layouts \g
#drop table layouts \g
delete from layouts where page like '%question'\g
delete from layouts where page like 'quizEXAMLIST'\g

select * from layouts \g
select * from layouts where page like 'quiz%' \g
select * from layouts where page like 'question%' \g


######################################################
insert into layouts values ('CPS714Spring99'    ,'quizNEW'      ,'newq2','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizedit.xsl')\g
insert into layouts values ('ECSSpring99'       ,'quizLIST'     ,'second','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizlist1.xsl')\g

insert into layouts values ('CPS616Spring99'    ,'quiz'         ,'show','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizshow.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizEDIT'     ,'edit','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizedit.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizLIST'     ,'first','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizlist.xsl')\g
insert into layouts values (''                  ,'quizLIST'     ,'fourth','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizlist3.xsl')\g
insert into layouts values (''                  ,'quizLIST'     ,'third','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizlist4.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizNEW'      ,'newq1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/quizzes/quizedit.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizEXAMLIST' ,'EXAMLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/quizlist.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizEXAMTIME' ,'EXAMLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/exam.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizQUESTIONS' ,'QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/questionlist.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizEXAMGRADED' ,'QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/grade.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizQUESTIONSCORES','QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/questionlist.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'quizNOT' ,'results','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/not.xsl')\g

insert into layouts values ('CPS616Spring99'    ,'question'     ,'browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/show.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'questionEDIT_META','edit','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/edit.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'questionGRADE','grading','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/grade.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'questionLIST' ,'newq1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/list.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'questionMETA' ,'browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/showmeta.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'questionNEW'  ,'new1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/new.xsl')\g
insert into layouts values (''                  ,'questionNEW'  ,'new2','/npac/home/msen7/TESTSVR/HtdocsGrdSys/questions/new.xsl')\g
insert into layouts values ('CPS616Spring99'    ,'questionEXAMLIST' ,'QUESTIONLIST','/npac/home/msen7/TESTSVR/HtdocsGrdSys/exam/questionlist.xsl')\g

insert into layouts values ('all'    ,'qbLIST' ,'newq1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/list.xsl')\g
insert into layouts values ('all'    ,'qbQUESTION'     ,'browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/show.xsl')\g
insert into layouts values ('all'    ,'qbEDIT_META','edit','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/edit.xsl')\g
insert into layouts values ('all'    ,'qbGRADE','grading','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/grade.xsl')\g
insert into layouts values ('all'    ,'qbLIST' ,'newq1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/list.xsl')\g
insert into layouts values ('all'    ,'qbMETA' ,'browse','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/showmeta.xsl')\g
insert into layouts values ('all'    ,'qbNEW'  ,'new1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/new.xsl')\g
insert into layouts values ('all'    ,'qbCOPY'  ,'new1','/npac/home/msen7/TESTSVR/HtdocsGrdSys/qb/copy.xsl')\g


---------------------------LAYOUS-----------------------------------5--

