package gs.dbxml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


//import gs.xml.dbXML;
//XML-end
//import gs.conf.default;
import gs.db.update;
import gs.db.xdatabase;   
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;



public class dbxQuestion extends xdatabase {

  public   String     course  ;          // unique key
  public   String     quizname          ;// unique key
  public   String     qid          ;// unique key
  
  public   Document   doc;
  static   String tablename  ="xquestions";
  static   String [] all     ={"course","quizname","qid","qtitle","category","type","points","qtext","detail","option"};
  static   String [] q       ={ "'"    ,"'"       ,""   ,"'"     ,"'"       ,"'"   ,""      ,"'"    ,"'"     ,"'"};
  static   String [] keys    ={"course","quizname","qid"};
  static   String [] normal  ={"qtitle","category","type","points","qtext"};
  static   String [] critical={"detail","option"};
  // static   String [] tags    ={"type",null};

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  public void defineObject(){
    super.tablename=tablename;
    super.all=all;
    super.q=q;
    super.keys=keys;
    super.normal=normal;
    super.critical=critical;
    super.allfields=all[0];
    for (int i=1;i<all.length;i++)
      super.allfields+=","+all[i];
  }
  public void setIdentification() throws Exception{
     this.quizname     = getS("quizname"); 
     this.course       = getS("course"); 
     this.qid          = getS("qid"); 
     if(quizname.equals("") || course.equals("") || qid.equals("")) 
       throw new Exception("Key fields are empty!");
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbxQuestion() {}

  public dbxQuestion(Hashtable ht) throws Exception{
    fields=ht;
    setIdentification();
    generateDocument();
  }
  public   Document dbxQuestion( String _course,String _quizname ) throws Exception{
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("qid","-1" );
    fields.put("points","0" );
    setIdentification();
    return generateDocument();
  }
  public  dbxQuestion( String _course,String _quizname ) throws Exception{
    ResultSet rs = select("WHERE course='"+_course+"' AND quizname='"+ _quizname +"'");

    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("qid","-1" );
    setIdentification();

    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element quiz= dbx.addMyNode(d,crs,"quiz");
    dbx.addMyTextNode(d,quiz,"quizname"   ,quizname);

    while ( rs.next() ) {
      Element question= dbx.addMyNode(d,quiz,"question");
      String qid = Integer.toString(rs.getInt("qid"));
      dbx.addMyTextNode(d,question,"qid",qid);
      addNormalTextFields(d,question,rs);
      addSubTree(d,question,rs);
    }
    addLayouts(d,crs,course,"question");

    doc= d;
  }
  public   Document dbxQuestions( Element dadquiz, String _course,String _quizname ) throws Exception{
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    ResultSet rs = select("WHERE course='"+_course+"' AND quizname='"+ _quizname +"' ORDER BY qid");
    Document d=dadquiz.getOwnerDocument();
    while ( rs.next() ) {
      Element question= dbx.addMyNode(d,dadquiz,"question");
      String qid = Integer.toString(rs.getInt("qid"));
      dbx.addMyTextNode(d,question,"qid",qid);
      addNormalTextFields(d,question,rs);
      addSubTree(d,question,rs);
    }

    return d;
  }

  public  dbxQuestion( String _course,String _quizname,String _qid ) throws Exception
  {
    
    ResultSet rs = select("WHERE  course='"+_course+"' AND quizname='"+ _quizname +"' AND qid="+ _qid);
    
    this.course=_course;
    this.quizname=_quizname;
    this.qid=_qid;

    // if in cache 
    //    doc=cache;
    // return;
    fillFields(rs);
    generateDocument();
  }
  public  void reload() throws Exception
  {
    ResultSet rs = select("WHERE  course='"+course+"' AND quizname='"+ quizname +"' AND qid="+ qid);
    fillFields(rs);
  }
  public String nextQid() throws Exception{
    String where= "course='"+getS("course")+"' AND quizname='"+getS("quizname")+"'";
    ResultSet rs = records("qid", where,"qid DESC ");
    if ( rs.next() ) 
      return Integer.toString(1+rs.getInt("qid"));
    return "0";
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // generateDocument
   //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document generateDocument() throws Exception {
    System.out.println("BEGIN:generateDocument");
      Document d=dbx.giveMeEmptyDocument(); 
      Element crs=dbx.makeMeRoot(d,"course"); 

      dbx.addMyTextNode(d,crs,"coursename"   ,course);

      Element quiz= dbx.addMyNode(d,crs,"quiz");
      dbx.addMyTextNode(d,quiz,"quizname"    ,quizname);
      Element question= dbx.addMyNode(d,quiz,"question");
      dbx.addMyTextNode(d,question,"qid"         ,getS("qid"));
      addNormalTextFields(d,question);
      addSubTree(d,question);
      addLayouts(d,crs,course,"question");
      doc=d;
    System.out.println("END:generateDocument");   
    return doc;
  }


  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // QuestionInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document QuestionInXML(  )        throws Exception
  {
    //get from  cache 
    if (doc==null) {
      convert2XML(  ) ; //put into cache
    }
    return doc;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2XML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document convert2XML(  )        throws Exception
  {
    course= getS("course");
    quizname=getS("quizname");
    String starttime  = getS("starttime");
    String endtime    = getS("endtime");
    String duration   = getS("duration");
    String points     = getS("points");
    String xslfile   = getS("xslfile"); //luxury
    //String qexslfile   = getS("exslfile"); //luxury
    String settings   = getS("settings");
    String additional = getS("additional");

    Document d=dbx.giveMeEmptyDocument();  
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element question= dbx.addMyNode(d,crs,"question");
    dbx.addMyTextNode(d,question,"quizname"   ,quizname);
    dbx.addMyTextNode(d,question,"duration"   ,duration);
    dbx.addMyTextNode(d,question,"points"     ,points);
    dbx.addMyTextNode(d,question,"xslfile"    ,xslfile);
    dbx.addMySubTree(d,question,settings);
    //dbx.addMyTextNode(d,question,"settingsI"  ,settingsI);
    dbx.addMyTextNode(d,question,"additional" ,additional);
    //GET available  XSL LAYOUTS
    Element layouts=dbx.availableLayouts(d,"question");
    Element currentLayout=dbx.getLayout(d,course,"question");
    layouts.appendChild(currentLayout);
    crs.appendChild(layouts);
  
    doc=d;
    return doc;
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2DB
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  convert2DB(  )        throws Exception
  {
    Element p=doc.getDocumentElement() ;
    course= dbx.getVal(p,"/course/coursename");
    quizname=dbx.getVal(p,"/course/question/quizname");
    String starttime  = dbx.getVal(p,"/course/question/starttime");
    String endtime    = dbx.getVal(p,"/course/question/endtime");
    String duration   = dbx.getVal(p,"/course/question/duration");
    String points     = dbx.getVal(p,"/course/question/points");
    String xslfile    = dbx.getVal(p,"/course/question/xslfile");
    //  String settings   = p.getTreeVal("/course/question/settings");
    String additional = dbx.getVal(p,"/course/question/additional");
    String settings ="";
    fields.put("course",course );
    fields.put("quizname",quizname );
    fields.put("starttime",starttime );
    fields.put("endtime",endtime );
    fields.put("duration",duration );
    fields.put("points",points );
    fields.put("xslfile",xslfile );
    fields.put("settings",settings );
    fields.put("additional",additional );



  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // listQuestionsInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document listQuestionsInXML( String course) throws Exception
  {
    String queryString =   "SELECT * from "+ getTableName() 
      + " WHERE course='"+course+"'";
    
    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("\nlistQuestionsInXML:QueryString:"+queryString);

      while ( rs.next() ) {
	String quizname   = Util.null2str(rs.getString("quizname")); //luxury
	String starttime  = Util.null2str(rs.getString("starttime"));
	String endtime    = Util.null2str(rs.getString("endtime"));
	String duration   = Util.null2str(rs.getString("duration"));
	String points     = Util.null2str(rs.getString("points"));
	String xslfile    = Util.null2str(rs.getString("xslfile")); //luxury
	String settings   = Util.null2str(rs.getString("settings"));
	String additional = Util.null2str(rs.getString("additional"));

	Element question= dbx.addMyNode(d,crs,"question");
	dbx.addMyTextNode(d,question,"quizname"   ,quizname);
	dbx.addMyTextNode(d,question,"duration"   ,duration);
	dbx.addMyTextNode(d,question,"points"     ,points);
	dbx.addMyTextNode(d,question,"xslfile"    ,xslfile);
	dbx.addMySubTree(d,question,settings);
	dbx.addMyTextNode(d,question,"additional" ,additional);
      }
      //GET available  XSL LAYOUTS
      Element layouts=dbx.availableLayouts(d,"questionlist");
      Element currentLayout=dbx.getLayout(d,course,"questionlist");
      layouts.appendChild(currentLayout);
      crs.appendChild(layouts);
    } catch(Exception e) { 
      System.out.println("\n\n [ Exception ] 786: listQuestionsInXML\n\n");
      e.printStackTrace();
      throw e;
    }
    return d;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@ operations @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  //====================================================================delete====== 
  public  static void  delete(String _course,String _quizname,String _qid) throws Exception{
    String deleteStr= " course='"+_course+"' AND quizname='"+_quizname+"' AND qid="+_qid ;
    update.updateData( "DELETE FROM "+tablename+" WHERE "+deleteStr);
    
    //  update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    //  update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    //update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }
  //=====================================================================UPDATE===
  // CONSIDER LATER
  public String updateSQL()  throws Exception {

    String   oldqid  =getS("oldqid",qid);  
    
    if (!oldqid.equals(qid)) {
      //       String updatestr=" SET accesscode='"+accesscode+"' WHERE accesscode ='"
      //                                            +oldaccesscode+"' AND course='"+course+"'";
      //       update.updateData( "UPDATE answers "+updatestr);
      //       update.updateData( "UPDATE grades "+updatestr);
      //       update.updateData( "UPDATE performances "+updatestr);
      System.out.println("****oldqid.equals(qid)**************************************************************************************************");
    }
    
    return updateSQL(" course='"+course+"' AND quizname='"+quizname+"' AND qid="+oldqid );
  }



}





