package gs.dbxml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


import gs.xml.dbXML;
//XML-end
//import gs.conf.default;
import gs.db.update;
import gs.db.database;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;



public class dbxQuestion extends database {

  public   String     course  ;          // unique key
  public   String     quizname          ;// unique key
  public   String     qid          ;// unique key
  
  public   Document   doc;
  static   dbXML      dbx = new dbXML();
  static   String  tablename="xquestions";
  static   String allfields ="course,quizname,qid,qtitle,category,format,image,feedback,feedbackformat,type,points";
  static   String [] all ={"course","quizname","qid","qtitle","category","format","image","feedback","feedbackformat","type","points"};
  static   String [] q ={"'","'","","'","'","'","'","'","'","'","'"};
  static   String [] keys={"course","quizname","qid"};
  static   String [] normal={"qtitle","category","format","image","feedback","feedbackformat","type","points"};
  //  static   String[] critical={"",""};

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@  fields @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public  String getTableName()
  {
    return tablename;
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public String getFieldNames() //used in SQL INSERT command
  {
    return allfields;
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
 public String getFieldValues()  // used in SQL INSERT command
  { 
    String rstr=q[0]+ getS(all[0])+q[0];

    for (int i=1;i<all.length;i++)
      rstr+=","+q[i]+ getS(all[i])+q[i];
    System.out.println("CHECK+++++>>"+rstr);
   return   rstr;

  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public static Hashtable getEmptyFields()
       throws Exception
  {
    
    Hashtable result = new Hashtable();
    result.put("course"    , "");
    result.put("quizname"  , "");
    result.put("starttime" , "");
    result.put("endtime"   , ""); 
    result.put("duration"  , ""); 
    result.put("points"    , ""); 
    result.put("xslfile"   , "");
    result.put("settings"  , ""); 
    result.put("additional", ""); 
    return result;
  }

  // @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @ @
  public String getSetValues() //  used in SQL UPDATE command
  {
    String rstr= all[0]+"="+q[0]+ getS(all[0])+q[0];

    for (int i=1;i<all.length;i++)
      rstr+=all[0]+"="+q[0]+ getS(all[0])+q[0];
    System.out.println("CHECK+++++>>"+rstr);
    return   rstr;
  }

  public void addNormalTextFields(Document d,Element question,ResultSet rs) throws Exception{
     for (int i=0;i<normal.length;i++)
	dbx.addMyTextNode(d,question, normal[i]  ,Util.null2str(rs.getString(normal[i])));
  }

};

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@  fields  end @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  public dbxQuestion() {}

  public dbxQuestion(Hashtable ht) throws Exception{
    fields=ht;
    setIdentification();
    generateDocument();
  }

  public  dbxQuestion( String _course,String _quizname ) throws Exception{
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("qid","-1" );
    setIdentification();

    String queryString =   "SELECT * from "+ getTableName() 
      + " WHERE course='"+course+"' AND quizname='"+ _quizname +"'";
    
    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element quiz= dbx.addMyNode(d,crs,"quiz");
    dbx.addMyTextNode(d,quiz,"quizname"   ,quizname);
    
    try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("\nlistQuestionsInXML:QueryString:"+queryString);

      while ( rs.next() ) {
	String qid = Integer.toString(rs.getInt("qid"));
	//String   = Util.null2str(rs.getString(""));
	String qtitle  = Util.null2str(rs.getString("qtitle"));

	Element question= dbx.addMyNode(d,quiz,"question");

	addNormalTextFields(d,question,rs);
	dbx.addMyTextNode(d,question,"qid"                                     ,qid);
	dbx.addMyTextNode(d,question,"qtitle"                               ,qtitle);
	dbx.addMyTextNode(d,question,"category"   ,Util.null2str(rs.getString("category")));
	dbx.addMyTextNode(d,question,"format"   ,Util.null2str(rs.getString("format")));
	dbx.addMyTextNode(d,question,"image"   ,Util.null2str(rs.getString("image")));
	dbx.addMyTextNode(d,question,"feedback"   ,Util.null2str(rs.getString("feedback")));
	dbx.addMyTextNode(d,question,"feedbackformat"   ,Util.null2str(rs.getString("feedbackformat")));
	dbx.addMyTextNode(d,question,"type"   ,Util.null2str(rs.getString("type")));
	dbx.addMyTextNode(d,question,"points"   ,Util.null2str(rs.getString("points")));
	dbx.addMyTextNode(d,question,""   ,Util.null2str(rs.getString("")));
	//	dbx.addMySubTree(d,question,settings);
	//dbx.addMyTextNode(d,question,"additional" ,additional);
      }
      //GET available  XSL LAYOUTS
      Element layouts=dbx.availableLayouts(d,"questionlist");
      Element currentLayout=dbx.getLayout(d,course,"questionlist");
      layouts.appendChild(currentLayout);
      crs.appendChild(layouts);
    } catch(Exception e) { 
      System.out.println("\n\n [ Exception ] 886: listQuestionsInXML\n\n");
      e.printStackTrace();
      throw e;
    }
    doc= d;

  }

  public  dbxQuestion( String _course,String _quizname,String _qid ) throws Exception
  {
    this.course=_course;
    this.quizname=_quizname;
    this.qid=_qid;

    // if in cache 
    //    doc=cache;
    // return;
    String queryString = "SELECT * from "+ getTableName() +
      " WHERE  course='"+_course+"' AND quizname='"+ _quizname +"' AND qid="+ _qid +"";
    ResultSet rs = query.queryData( queryString );
    System.out.println("\ndbxQuestion:queryString:"+queryString);
    
    if ( rs.next() )	  {
      fields.put("course" 	 ,			course);
      fields.put("quizname"	 ,			quizname);
      fields.put("qid"	         ,			qid);
      fields.put("qtitle"	 ,Util.null2str(rs.getString("qtitle")));
    } else{
      throw new Exception("GS:dbxQuestion:QuestionNotFound: Question  could not be found!");
    }
    generateDocument();
  }

  public void setIdentification() throws Exception{
     this.quizname     = getS("quizname"); 
     this.course     = getS("course"); 
     this.qid     = getS("qid"); 
    if(quizname.equals("") || course.equals("") || qid.equals("")) 
      throw new Exception("Key fields are empty!");
  }

  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // QuestionInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document QuestionInXML(  )        throws Exception
  {
    //get from  cache 
    if (doc==null) {
      convert2XML(  ) ; //put into cache
    }
    return doc;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // generateDocument
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document generateDocument() throws Exception {
    System.out.println("BEGIN:generateDocument");
    try {
      Document d=dbx.giveMeEmptyDocument(); 
      Element crs=dbx.makeMeRoot(d,"course"); 

      dbx.addMyTextNode(d,crs,"coursename"   ,course);

      Element quiz= dbx.addMyNode(d,crs,"quiz");
      dbx.addMyTextNode(d,quiz,"quizname"    ,quizname);
      Element question= dbx.addMyNode(d,quiz,"question");
      dbx.addMyTextNode(d,question,"qid"         ,getS("qid"));
      dbx.addMyTextNode(d,question,"qtitle"         ,getS("qtitle"));
      //      System.out.println("!---------"+getS("settings")+"---------");
      //dbx.addMySubTree (d,question,getS("settings"));

      //                          GET available  XSL LAYOUTS
      Element layouts       = dbx.availableLayouts(d,"question");
      Element currentLayout = dbx.getLayout(d,course,"question");
      layouts.appendChild(currentLayout);
      crs.appendChild(layouts);

      doc=d;

    } catch(Exception e) { 
      System.out.println("\n\n Exception  885: Question !  \n\n");
      e.printStackTrace();
      throw e;
    }
     System.out.println("END:generateDocument");   
    return doc;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2XML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document convert2XML(  )        throws Exception
  {
    course= getS("course");
    quizname=getS("quizname");
    String starttime  = getS("starttime");
    String endtime    = getS("endtime");
    String duration   = getS("duration");
    String points     = getS("points");
    String xslfile   = getS("xslfile"); //luxury
    //String qexslfile   = getS("exslfile"); //luxury
    String settings   = getS("settings");
    String additional = getS("additional");

    Document d=dbx.giveMeEmptyDocument();  
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    Element question= dbx.addMyNode(d,crs,"question");
    dbx.addMyTextNode(d,question,"quizname"   ,quizname);
    dbx.addMyTextNode(d,question,"duration"   ,duration);
    dbx.addMyTextNode(d,question,"points"     ,points);
    dbx.addMyTextNode(d,question,"xslfile"    ,xslfile);
    dbx.addMySubTree(d,question,settings);
    //dbx.addMyTextNode(d,question,"settingsI"  ,settingsI);
    dbx.addMyTextNode(d,question,"additional" ,additional);
    //GET available  XSL LAYOUTS
    Element layouts=dbx.availableLayouts(d,"question");
    Element currentLayout=dbx.getLayout(d,course,"question");
    layouts.appendChild(currentLayout);
    crs.appendChild(layouts);
  
    doc=d;
    return doc;
  }
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // convert2DB
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public void  convert2DB(  )        throws Exception
  {
    Element p=doc.getDocumentElement() ;
    course= dbx.getVal(p,"/course/coursename");
    quizname=dbx.getVal(p,"/course/question/quizname");
    String starttime  = dbx.getVal(p,"/course/question/starttime");
    String endtime    = dbx.getVal(p,"/course/question/endtime");
    String duration   = dbx.getVal(p,"/course/question/duration");
    String points     = dbx.getVal(p,"/course/question/points");
    String xslfile    = dbx.getVal(p,"/course/question/xslfile");
    //  String settings   = p.getTreeVal("/course/question/settings");
    String additional = dbx.getVal(p,"/course/question/additional");
    String settings ="";
    fields.put("course",course );
    fields.put("quizname",quizname );
    fields.put("starttime",starttime );
    fields.put("endtime",endtime );
    fields.put("duration",duration );
    fields.put("points",points );
    fields.put("xslfile",xslfile );
    fields.put("settings",settings );
    fields.put("additional",additional );



  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // listQuestionsInXML
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Document listQuestionsInXML( String course) throws Exception
  {
    String queryString =   "SELECT * from "+ getTableName() 
      + " WHERE course='"+course+"'";
    
    Document d=dbx.giveMeEmptyDocument(); 
    Element crs=dbx.makeMeRoot(d,"course"); 
    dbx.addMyTextNode(d,crs,"coursename"   ,course);
    try {
      ResultSet rs = query.queryData( queryString );
      System.out.println("\nlistQuestionsInXML:QueryString:"+queryString);

      while ( rs.next() ) {
	String quizname   = Util.null2str(rs.getString("quizname")); //luxury
	String starttime  = Util.null2str(rs.getString("starttime"));
	String endtime    = Util.null2str(rs.getString("endtime"));
	String duration   = Util.null2str(rs.getString("duration"));
	String points     = Util.null2str(rs.getString("points"));
	String xslfile    = Util.null2str(rs.getString("xslfile")); //luxury
	String settings   = Util.null2str(rs.getString("settings"));
	String additional = Util.null2str(rs.getString("additional"));

	Element question= dbx.addMyNode(d,crs,"question");
	dbx.addMyTextNode(d,question,"quizname"   ,quizname);
	dbx.addMyTextNode(d,question,"duration"   ,duration);
	dbx.addMyTextNode(d,question,"points"     ,points);
	dbx.addMyTextNode(d,question,"xslfile"    ,xslfile);
	dbx.addMySubTree(d,question,settings);
	dbx.addMyTextNode(d,question,"additional" ,additional);
      }
      //GET available  XSL LAYOUTS
      Element layouts=dbx.availableLayouts(d,"questionlist");
      Element currentLayout=dbx.getLayout(d,course,"questionlist");
      layouts.appendChild(currentLayout);
      crs.appendChild(layouts);
    } catch(Exception e) { 
      System.out.println("\n\n [ Exception ] 786: listQuestionsInXML\n\n");
      e.printStackTrace();
      throw e;
    }
    return d;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@ operations @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //=====================================================================UPDATE===
  public void updateDocument2DB()throws Exception {
    update();
    //update  in cache
  }
  //=====================================================================UPDATE===
  // CONSIDER LATER
  public String updateSQL()  throws Exception {

    String   oldquizname  =getS("oldquizname");  
  
    if (!oldquizname.equals(quizname)) {
      //       String updatestr=" SET accesscode='"+accesscode+"' WHERE accesscode ='"
      //                                            +oldaccesscode+"' AND course='"+course+"'";
      //       update.updateData( "UPDATE answers "+updatestr);
      //       update.updateData( "UPDATE grades "+updatestr);
      //       update.updateData( "UPDATE performances "+updatestr);
    }
    return updateSQL("quizname='"+oldquizname  +"' AND course='"+course+"'");
  }


  //=============update========================================================UPDATE===
  public Document update()throws Exception {
     System.out.println("BEGIN:update"); 
     try {
      update.updateData( updateSQL() );
    }
    catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("<b>ERROR [123]</b>: This quizname exists in the system. <br> Please try another one.!");
      }
      throw new Exception(error);
    }    
    generateDocument();
    //put into cache
     System.out.println("END:update"); 
    return doc;
  }

 //==============add===========================================================ADD== 
  public Document  add()throws Exception {
    System.out.println("BEGIN:add"); 
    try {
      update.updateData( insertSQL() );
    }
    catch( Exception e ) {
      String error =e.getMessage();
      if (error.indexOf("unique") >=0) {
	error= new String("<b>ERROR [124]</b>: This quizname exists in the system. <br> Please try another one.!");
      }
      throw new Exception(error);
    }    
    generateDocument();
    //put into cache
     System.out.println("END:add"); 
    return doc;
  }


  //====================================================================delete====== 
  public  static void  delete(String _course,String _quizname) throws Exception{
    String deleteStr= "quizname='"+ _quizname +"' AND course='"+_course+"'";
    update.updateData( "DELETE FROM"+tablename+"WHERE "+deleteStr);
    
    //  update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    //  update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    //update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }


}





