package gs.dbxml;
import gs.util.Util;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;


//import gs.xml.dbXML;
//XML-end
//import gs.conf.default;
import gs.db.update;
import gs.db.xdatabase;
import gs.db.query;
import java.util.Hashtable;
import java.sql.ResultSet;

import java.util.StringTokenizer;


public class dbxAnswers extends xdatabase {

  public   String     accesscode  ;          // unique key
  public   String     course  ;          // unique key
  public   String     quizname          ;// unique key
  public   String     qid          ;// unique key
  public   Document   doc;

  static   String  tablename="exam_answers";  
  static   String [] all     ={"course","quizname","accesscode","qid","grade","answer"};
  static   String [] q       ={"'","'","'","","","'"};
  static   String [] keys    ={"course","quizname","acesscode"};
  static   String [] normal  ={"course","quizname","acesscode","qid","grade","answer"};
  static   String [] critical={};


  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void defineObject(){
    super.tablename=tablename;
    super.all=all;
    super.q=q;
    super.keys=keys;
    super.normal=normal;
    super.critical=critical;
    super.allfields=all[0];
    for (int i=1;i<all.length;i++)
      super.allfields+=","+all[i];
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void setIdentification(){
     this.quizname     = getS("quizname"); 
     this.course     = getS("course"); 
     this.accesscode     = getS("accesscode"); 
     //this.qid     = getS("qid"); 

  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public void reload(){}  
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public Document generateDocument() {return null;}
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public dbxAnswers() {}
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  dbxAnswers( String _course,String _quizname ) throws Exception
  {
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("accesscode","all" );
    setIdentification();
    // ht= new Hashtable();
    // if in cache 
    //    doc=cache;
    // return;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  dbxAnswers( String _accesscode,String _course,String _quizname ) throws Exception
  {
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("accesscode",_accesscode );
    setIdentification();
    // ht= new Hashtable();
    // if in cache 
    //    doc=cache;
    // return;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  Hashtable getAnswers(String _accesscode,String _course,String _quizname ) throws Exception
  {
    Hashtable ht= new Hashtable();
    fields.put("course", _course);
    fields.put("quizname",_quizname );
    fields.put("accesscode",_accesscode );
    setIdentification();
    ResultSet rs = select( " WHERE course='"+_course+"'  AND quizname='"+_quizname+"'  AND accesscode='"+_accesscode+"'");

    while ( rs.next() ) {
	  String qid=Util.null2str(rs.getString("qid"));
	  String answer=Util.null2str(rs.getString("answer"));
	  String  grade= Integer.toString(rs.getInt("grade"));
	  if (rs.wasNull()) grade="NaN";
	  StringTokenizer st= new StringTokenizer(answer,"<|>",false);
	  Hashtable qht= new Hashtable();
	  while (st.hasMoreTokens() ) {
	    String ans=st.nextToken() ;
	    qht.put(ans,grade);
	  }
	  ht.put(qid,qht);
    }
    return ht;
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void storeAnswers(String answer, String qid) throws Exception
  {
    this.qid     = qid;
    fields.put("qid", qid);
    fields.put("answer",answer );
    //fields.put("grade","0" );
    try                {add();}
    catch (Exception e){update();}
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void storeAnswersGrade(String grade, String qid) throws Exception
  {
    this.qid     = qid;
    fields.put("qid", qid);
    fields.put("grade",grade );
    update();
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void countQuestionAnswers(Document d,Element question,ResultSet rs) throws Exception
  {
    Hashtable ht=new Hashtable();
    int i=0;
    Element _answers= dbx.addMyNode(d,question,"std-answers");
    Element _answer=null;
    while ( rs.next() ) {	
      _answer=dbx.addMyNode(d,_answers, "std-answer" );
      dbx.addMyTextNode(d,_answer, "grade"  ,Integer.toString(rs.getInt("grade")));
      i++;
      StringTokenizer st= new StringTokenizer(Util.null2str(rs.getString("answer")),"<|>",false);
      while (st.hasMoreTokens() ) {
	String ans=st.nextToken() ;
	String s=(String)ht.get(ans);
	if (s==null) s="|"; else s+="|";
	ht.put(ans, s);
      }
    }
    NodeList answers = question.getElementsByTagName("answer");
    int ansCount = answers.getLength();
    for (int a = 0; a < ansCount; a++) {
      Element answer = (Element)answers.item(a);
      String text=dbx.getTxt(answer,"text");
      String c=(String)ht.get(text);
      if (c!=null) 
	dbx.addMyTextNode(d,answer, "count"  ,Integer.toString(c.length()) );
      else dbx.addMyTextNode(d,answer, "count"  ,"0");
    }
    dbx.addMyTextNode(d,question, "normalize"  ,Integer.toString(i));
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void getQuestionAnswers(Document d,String qid) throws Exception
  {
    Element question= dbx.getFirst(d,"/course/quiz/question");
    Element type= dbx.getFirst(d,"/course/quiz/question/type");
    ResultSet rs = select( " WHERE course='"+course+"'  AND quizname='"+quizname+"'  AND qid="+qid+" AND  accesscode NOT like '{i}-%'");
    
    if (type.getFirstChild().getNodeValue().equals("mc")){
      countQuestionAnswers(d,question,rs);
      return;
    }
    Element answers= dbx.addMyNode(d,question,"std-answers");
    while ( rs.next() ) {	
       Element answer= dbx.addMyNode(d,answers,"std-answer");   
       StringTokenizer st= new StringTokenizer(Util.null2str(rs.getString("answer")),"<|>",false);
       if (st.hasMoreTokens() ) 
	 dbx.addMyTextNode(d,answer, "std-response"  ,st.nextToken());
       else dbx.addMyTextNode(d,answer, "std-response"  ,"");
      dbx.addMyTextNode(d,answer, "grade"  ,Integer.toString(rs.getInt("grade")));
    }
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void storeGrade(int grade) throws Exception
  {

    if (0== update.updateData( "UPDATE exam_grades  SET  grade=" +grade +
			       " WHERE accesscode='" +accesscode+"' AND course='"+course+"' AND quizname='"+quizname+"'") 
	 )
      update.updateData( "INSERT INTO  exam_grades  (accesscode,course, quizname,grade ) "+
			 "VALUES (   '"+accesscode+"','"+course+"','"+quizname+"',"+grade+"   )"  )  ; 
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void getGrades(Document d) throws Exception
  {
    Element quiz= dbx.getFirst(d,"/course/quiz");
    Element results= dbx.addMyNode(d,quiz,"results");
    ResultSet rs = query.queryData( "SELECT grade FROM exam_grades WHERE course='"+course+"'  AND quizname='"+quizname+"' ORDER BY grade");
    while ( rs.next() ) {
      	dbx.addMyTextNode(d,results, "agrade"  ,Util.null2str(rs.getString("grade")));
       }
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void getGradesNames(Document d) throws Exception
  {
    Element quiz= dbx.getFirst(d,"/course/quiz");
    Element results= dbx.addMyNode(d,quiz,"results");
    Element student=null;
    Element name=null;
    ResultSet rs = query.queryData( "SELECT s.accesscode,s.firstname,s.midname,s.lastname,g.grade FROM students s,exam_grades g WHERE g.course='"+course+"'  AND g.quizname='"+quizname+"' AND s.course=g.course AND g.accesscode=s.accesscode  ORDER BY s.lastname");
    while ( rs.next() ) {
      student= dbx.addMyNode(d,results,"student");
      name= dbx.addMyNode(d,student,"name");
      name.setAttribute("firstname",Util.null2str(rs.getString("firstname")));
      name.setAttribute("midname",  Util.null2str(rs.getString("midname")));
      name.setAttribute("lastname", Util.null2str(rs.getString("lastname")));
      dbx.addMyTextNode(d,student, "grade"  ,Util.null2str(rs.getString("grade")));
      dbx.addMyTextNode(d,student, "accesscode"  ,Util.null2str(rs.getString("accesscode")));
    }
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@ operations @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  //=====================================================================UPDATE===
  //=====================================================================UPDATE===
  // CONSIDER LATER
  public String updateSQL()  throws Exception {
    return updateSQL(" course='"+course+"'  AND quizname='"+quizname+"'  AND accesscode='"+accesscode+"' AND qid="+qid);
  }
  public void  sideEffectsUPDATE()throws Exception {}

  //====================================================================delete====== 
  public static void  delete(String _course,String _quizname) throws Exception{
    String deleteStr= "quizname='"+ _quizname +"' AND course='"+_course+"'";
    //update.updateData( "DELETE FROM  WHERE "+deleteStr);
    
    //  update.updateData( "DELETE FROM answers WHERE "+deleteStr);
    //  update.updateData( "DELETE FROM grades WHERE "+deleteStr);
    //update.updateData( "DELETE FROM performances WHERE "+deleteStr);
  }
  //@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@//
  public  void clear() throws Exception
  {
    String deleteStr= " course='"+course+"'  AND quizname='"+quizname+"'  AND accesscode='"+accesscode+"'";
    update.updateData( "DELETE FROM "+tablename+"  WHERE "+deleteStr);

  }
  

}





