package gs.xml;

//XML
import com.ibm.xml.parser.*;
import org.w3c.dom.*;
import com.lotus.xsl.*;
import com.lotus.xsl.xml4j.*;
import com.ibm.xml.parsers.*;

//XML-end
import java.sql.ResultSet;
import gs.db.query;


public class dbXML  extends xXML {


  public dbXML(){}

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // FIND LAYOUT
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Element findLayout(Element layout,String course, String page) throws Exception
  {
    String queryString = "SELECT * from layouts "+ 
      " WHERE course='"+course+"' AND page='"+page+"'";


    //System.out.println  ("\tfindLayout:queryString:"+queryString);
    ResultSet rs = query.queryData( queryString );
    String xslfile ,xsllayout;
    if ( rs.next() ) {
      xslfile   = Util.null2str(rs.getString("file")); //luxury
      xsllayout   = Util.null2str(rs.getString("layoutname")); //luxury
      //System.out.println("\t\tAdding  layout "+xsllayout+"-->"+xslfile);
    } else {
      xslfile   = "/npac/home/msen7/xml/XSL/quiz.xsl";
      xsllayout   = "default"; 
    } //default;
    layout.setAttribute("xname",xsllayout);
    layout.setAttribute("xfile",xslfile);
    return layout;
  }


  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // getLayout
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Element getLayout(Document d, String course,String page) throws Exception
  {
    Element layout= d.createElement("current"); 
    findLayout(layout,course,page);

    Element edit= d.createElement("editmode"); 
    layout.appendChild(edit);
    findLayout(edit,course,"EDIT"+page);
    
    Element newo= d.createElement("newmode"); 
    layout.appendChild(newo);
    findLayout(newo,course,"NEW"+page);

    return layout; 
  }


  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // LAYOUT SELECTOR
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Element layoutSelector(Document d, Element layouts,String page) throws Exception
  {
    String queryString = "SELECT DISTINCT * from layouts "+" WHERE page='"+page+"'";
    //System.out.println  ("\tlayoutSelector:queryString:"+queryString);
    ResultSet rs = query.queryData( queryString );
    while ( rs.next() )
      {
	String xsllayout  = Util.null2str(rs.getString("layoutname")); //luxury
	String xslfile   = Util.null2str(rs.getString("file")); //luxury
	//System.out.println("\t\tAdding  layout "+xsllayout+"-->"+xslfile);

	Element layout= d.createElement("xsllayout"); 
	layout.setAttribute("xname",xsllayout);
	layout.setAttribute("xfile",xslfile);
	layouts.appendChild(layout);
      }
    return layouts;
  }

  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  // availableLayouts
  //%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  public Element availableLayouts(Document d,  String page) throws Exception
  {
    Element layouts= d.createElement("layouts");  // /layouts
    layoutSelector(d,layouts,page);
    
    Element edit= d.createElement("editmode");    //  /layouts/editmode
    layoutSelector(d,edit,"EDIT"+page);
    layouts.appendChild(edit);

    Element newo= d.createElement("newmode");    //  /layouts/editmode
    layoutSelector(d,newo,"NEW"+page);
    layouts.appendChild(newo);
     
    
      return layouts; 
  }






}//class
