<?xml version="1.0"?> 

<!--xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
   xmlns="http://www.w3.org/TR/REC-html40" 
   xmlns:lxslt="http://xsl.lotus.com/"
result-ns="">

   <xsl:template match="/">
      <HTML>
	 <head>
	    <SCRIPT LANGUAGE="JavaScript">
	       var list="";
	       var quizname="<xsl:value-of select="course/quiz/quizname"/>";
	       //alert(quizname);
	       var upsrc="<xsl:value-of select="course/global/images"/>"+"/up.gif";
	       // alert(upsrc);

	       <![CDATA[
		  function flag(qid){
		      eval("top.menu.document.images['f"+qid+"'].src='"+upsrc+"'");
		      var ind=list.indexOf(qid);

		      if (ind >= 0){
		      list=list.substring(0,ind)+list.substring(ind+qid.length+1);
		      }
		      //alert(list);
		  }
		  function checkFlag(){}
		  function gradeChanged(qid) { 
		  top.info.location=top.info.location;
		  }

	    ]]>   </SCRIPT>
	 </head>
	 <BODY bgcolor="yellow"> 
	    <center>
	       <xsl:apply-templates select="course/layouts"/>
	       <xsl:apply-templates select="course/function"/>
	       <xsl:variable name="page" expr="course/function"/>
	       <xsl:call-template name="header"/>
	       <xsl:if test="$page='listQuestions'"><font color="red"><i><b>Please see the  bottom of the page to see your remaining time.</b></i></font></xsl:if>
	       
	       <TABLE WIDTH="100%" ALIGN="center" BORDER="1">
		  <TR>
		     <TH colspan="3" bgcolor="LemonChiffon"><font color="brown"> 
			<xsl:value-of select="course/coursename"/> 
			<s/><font color="blue"><xsl:value-of select="course/quiz/quizname"/></font> 
			<br/>
			Question List </font> 
		     </TH> 
		  </TR>
		  <xsl:choose>
		     <xsl:when test="$page='listQuestions'">
			<xsl:apply-templates select="course/quiz/question" mode="list" >
			   <xsl:sort select="qid" data-type="number"/></xsl:apply-templates>
		     </xsl:when>
		     <xsl:when test="$page='listGradedQuestions'">
      <tr><form>
	 <td  bgcolor="blue" >T</td>
	 <td bgcolor="LemonChiffon"><A href="JavaScript:top.info.go('')" target="info">Score</A></td>
	 <td  bgcolor="blue" align="center"><b><font face="Helvetica" color="white"><input type="button" value=" reload" onClick="top.info.document.location.reload()"/></font></b></td></form>
      </tr>

			<xsl:apply-templates select="course/quiz/question" mode="listGraded">
			   <xsl:sort select="qid" data-type="number"/></xsl:apply-templates>
		     </xsl:when>
		     <xsl:otherwise>
			<xsl:apply-templates select="course/quiz/question" mode="default">
			   <xsl:sort select="qid" data-type="number"/></xsl:apply-templates>
		     </xsl:otherwise>
		  </xsl:choose>
	       </TABLE>
	       <xsl:if test="$page='listQuestions'">
		  <xsl:call-template name="submission"/>
	       </xsl:if>
	    </center>
	 </BODY>
      </HTML>
   </xsl:template>
   
   
<!-- ============================================================ -->
      <xsl:variable name="down"><xsl:value-of select="/course/global/images"/>/down.gif</xsl:variable>
<!-- ============================================================ -->
   <xsl:template match="question" mode="list">
      <SCRIPT> list+="<xsl:value-of select="qid"/>,"; </SCRIPT>
      <tr>
	 <td align="center"><b><xsl:value-of select="qid"/>.</b></td>
	 <td bgcolor="LemonChiffon"><A href="JavaScript:top.info.go('{qid}')" target="info"><xsl:value-of select="qtitle"/></A></td>
	 <td align="center"><A href="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuestions/?quizname={/course/quiz/quizname}&amp;course={/course/coursename}&amp;comm=QUESTION&amp;unum={/course/user/unum}&amp;qid={qid}"  target="info"></A> <img border="0" name="f{qid}" src="{$down}"/></td>
      </tr>
   </xsl:template>
   
<!-- ============================================================ -->
   <xsl:template match="question" mode="listGraded">
      <tr>
	 <td align="center"><xsl:value-of select="qid"/>.</td>
	 <td bgcolor="LemonChiffon"><A href="JavaScript:top.info.go('{qid}')" target="info"><xsl:value-of select="qtitle"/></A></td>
	 <td align="center"><font color="red"><xsl:value-of select="std-score"/></font>/<xsl:value-of select="points"/></td>
      </tr>
   </xsl:template>
<!-- ============================================================ -->
   <xsl:template match="question" mode="default">
      <tr>
	 <td align="center"><xsl:value-of select="qid"/>.</td>
	 <td bgcolor="LemonChiffon"><xsl:value-of select="qtitle"/></td>
	 <td align="center" bgcolor="red"><font color="white" size="-1" face="helvetica">No Grade</font></td>
      </tr>
   </xsl:template>
   

<!-- *============================================================ -->
   <xsl:template match="course/layouts" >
      
      <table width="100%">
	 <tr>
	    <th bgcolor="#ccffff">
	       <xsl:value-of select="current/questionLIST/@xname"/>
	       <br>
	       </br> 
	       <xsl:apply-templates select="questionLIST">
		  <xsl:sort select="@xname" />
	       </xsl:apply-templates>
	    </th>
	 </tr>
      </table>
      
   </xsl:template>

<!-- *============================================================ -->   
   <xsl:template match="questionLIST" >
      
      [<A href="http://{./@xfile}"> <xsl:value-of select="./@xname"/>  </A>]
      
   </xsl:template>
   
<!-- *============================================================ -->   
 
<!-- *===============top.info.history.go(-1);============================================= -->   
   <xsl:template name="header" >
      
      <table width="100%">
	 <tr><td  bgcolor="blue" align="center"><font face="helvetica" size="+1" color="white"> <b>Questions </b></font></td></tr>
	 <tr>
	    <td align="center">
	       <a href="JavaScript:self.history.go(-1);" >
		  <img src="{/course/global/images}/backT.gif" border="0" align="ABSCENTER"/>
	       </a>
	       <a href="{/course/global/help}/question.html" target="help">
		  <img src="{/course/global/images}/mansT.gif" border="0" align="ABSCENTER"/>
	       </a> 
	    </td>
	
	 </tr>
      </table>
   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template match="course/function" >
      <xsl:variable name="page"><xsl:value-of select="course/function"/></xsl:variable>
   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template name="submission" >
       <xsl:variable name="images"><xsl:value-of select="/course/global/images"/></xsl:variable>
      <form>
	 <font color="black" size="+1" FACE="Arial,Helvetica" ><b>
	    <input type="button" name="acomm" value=" SUBMIT EXAM " onClick="top.info.submitExam(list)"/>
	 </b></font>
      </form>


      <TABLE BORDER="1"  bgcolor="white">
	 <TR>
	    <TD bgcolor="white">
	       <font color="red" face="helvetica"><B> X </B>
	       <IMG NAME="m1" SRC="{$images}/clock/0.gif" HEIGHT="10" WIDTH="7" />
	       <IMG NAME="m2" SRC="{$images}/clock/0.gif" HEIGHT="10" WIDTH="7"/>
	       <IMG SRC="{$images}/clock/c.gif" HEIGHT="10" WIDTH="4"/>
	       <IMG NAME="s1" SRC="{$images}/clock/0.gif" HEIGHT="10" WIDTH="7" />
	       <IMG NAME="s2" SRC="{$images}/clock/0.gif" HEIGHT="10" WIDTH="7" /><font size="-2">  is your remaining time.</font> </font>
      <SCRIPT LANGUAGE="JavaScript">
	 var images="<xsl:value-of select="$images"/>";
	 var duration=top.info.duration; 
	    <![CDATA[
	       var first=true;
		var sec=0;
	       var min=duration;
		var ind="0123456789";
		var digits=new Array();
		for (var i=0;i<10;i++){
		  digits[i]=new Image();
		  digits[i].src=images+"/clock/"+i+".gif";
		}
		function backCounter(){
		  if (sec==0) {
  		    min -=1; sec=59;
	            if (first) {if (min <2) {first=false; document.examtime.src=images+"/examover.gif";}}
		    if (min<0) {
	                  alert("Time is out, your work will be submitted to the server.");
	       		  top.info.document.exam.submit();
	               return;
		    }
		  }
		  counter=""+((min<10)?"0":"")+min;
		  counter+=((sec<10)?"0":"")+sec;
		  for (var i=0;i<counter.length;i++){
		    ind=counter.substring(i,i+1);
		    if (i==0)	{   document.m1.src=digits[ind].src;  }
		    else if (i==1){   document.m2.src=digits[ind].src;  }
		    else if (i==2){   document.s1.src=digits[ind].src;  }
		    else if (i==3){   document.s2.src=digits[ind].src;  }
		  }
		  sec-=1;
		  setTimeout("backCounter()",1000);
		}
	]]> </SCRIPT>	
	 <img border="0" name="examtime" src="{/course/global/images}/examtime.gif" width="180"/>
	    </TD>
	 </TR>
      </TABLE>
	 <SCRIPT LANGUAGE="JavaScript">
	    backCounter(); //setTimeout("backCounter()",1000);
	 </SCRIPT>
      
   </xsl:template>
   
<!-- *============================================================ -->   
  
 
</xsl:stylesheet>

