<?xml version="1.0"?> 

<!--xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
   xmlns="http://www.w3.org/TR/REC-html40" 
   xmlns:lxslt="http://xsl.lotus.com/"
result-ns="">


   
   
   <xsl:template match="/">
      <HTML>
	 <head>
	    
	    <SCRIPT LANGUAGE="JavaScript"><![CDATA[

	       function confirmation(){
	       if (confirm("\n\nYour confirmation is required. \nDeleting question will lost all the stored information related with the question.\n\nDo you really want to delete the question '"+this.document.quiz.qid.value+"' ?") ) {
	       if (confirm("\n\nAre you sure to remove all the records of "+this.document.quiz.qid.value+"?") ) {
	       
	       this.document.quiz.dcomm.value="DELETE";
	       this.document.quiz.submit();
	       return;
	       }
}  alert("not deleting");
	       
	       }

	    ]]></SCRIPT>

		
	 </head>
	 <BODY bgcolor="white">


<form name="quiz" action="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuestionBank"
   method="GET">
   <input type="hidden" name="unum"  value="{/course/user/unum}">
   </input>
   <input type="hidden" name="course" value="{/course/coursename}">
   </input>
   <input type="hidden" name="quizname" value="{/course/quiz/quizname}">
   </input>   
   <input type="hidden" name="qid" value="{/course/quiz/question/qid}">
   </input>   
   <b>
      <font color="black" size="+1" FACE="Arial,Helvetica" >
	 <input type="submit" name="comm" value="NEW" >
	 </input>
	 <font color="red" >
	    <input type="button" name="delete" value="DELETE" onClick="confirmation()"></input>
	    <input type="hidden" name="dcomm" value="no"></input> 
	 </font>
	 <input type="submit" name="comm" value="EDIT" >
	 </input>  
	 <input type="button" name="comm" value="SKIP" onClick="history.go(-1);" >
	 </input>
      </font>
   </b>
</form>



	    <xsl:apply-templates select="course/layouts"/>

	    <xsl:apply-templates select="course/quiz/question"/>

 	    <xsl:apply-templates select="course/function"/>
   
	    <a href="JavaScript:current()">click</a>

	 </BODY>
      </HTML>
   </xsl:template>


   
<!-- ============================================================ -->
   <xsl:template match="question" >
      <xsl:sort select="qid"/>
      --------------------------    
      <table bgcolor="brown" ><th>
	 <table bgcolor="yellow" cellpadding="6" border="5" >
	    <tr>
	       <TH colspan="2" bgcolor="LemonChiffon" >
		  <xsl:value-of select="/course/coursename"/> 
		  <xsl:value-of select="/course/quiz/quizname"/> 
		  Question
 Information</TH>
	    </tr>
	    <tr><td width="200"><b>Question ID </b></td><td><xsl:value-of select="qid"/> </td></tr>
	    <tr><td width="200"><b>Question Title  </b></td><td><xsl:value-of select="qtitle"/> </td></tr>
	    <tr><td><b>  category   </b></td><td> <xsl:value-of select="category"/>  </td></tr>
	    <tr><td><b>  format   </b></td><td> <xsl:value-of select="format"/>  </td></tr>
	    <tr><td><b>   image  </b></td><td> <xsl:value-of select="image"/>  </td></tr>
	    <tr><td><b>   feedback  </b></td><td> <xsl:value-of select="feedback"/>  </td></tr>
	    <tr><td><b>    feedbackformat </b></td><td> <xsl:value-of select="feedbackformat"/>  </td></tr>
	    <tr><td><b>   type  </b></td><td> <xsl:value-of select="type"/>  </td></tr>

	    <tr><td><b>    points            </b></td><td> <xsl:value-of select="points"/>  </td></tr>

	    <tr><td><b>     Layout             </b></td><td> <xsl:value-of select="xslfile"/>  </td></tr>
<xsl:apply-templates select="settings/option"/>
<xsl:apply-templates select="additional"/>


</table>
</th>
</table>
--------------------------
   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template match="settings/option" >
      <tr><td><b><xsl:value-of select="name"/></b></td>
      <td> <xsl:value-of select="value"/></td></tr>
   </xsl:template>
   

<!-- *============================================================ -->
   <xsl:template match="course/layouts" >
      
      <table>
	 <tr>
	    <th bgcolor="#ccffff">
	       <xsl:value-of select="current/question/@xname"/>
	       <br>
	       </br> 
	       <xsl:call-template  name="xsllayout"/> 
		
	    </th>
	 </tr>
      </table>

   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template name="xsllayout" >

     <xsl:for-each select="question">
	<xsl:sort select="@xname" />
      [<A href="http://{@xfile}"> <xsl:value-of select="@xname"/> </A>]
     </xsl:for-each>

   </xsl:template>

<!-- *============================================================ -->   
   <xsl:template match="additional" >

   <tr><td><b>     Points   additional          </b></td><td> additional                                 </td></tr>
   </xsl:template>

<!-- *============================================================ -->   
   <xsl:template match="course/function" >

      <SCRIPT LANGUAGE="JavaScript">
	 var func='<xsl:value-of select="/course/function"/>';
	 if ('addQuestion'==func || 'updateQuestion'==func )
	      top.menu.document.location.reload();
      </SCRIPT>



   </xsl:template>

   
</xsl:stylesheet>


<!-- java com.lotus.xsl.xml4j.ProcessXSL -xsl /npac/home/msen7/xml/XSL/quiz.xsl -in abc.xsl
-->
   <!-- java com.lotus.xsl.xml4j.ProcessXSL -xsl /npac/home/msen7/xml/XSL/quizshow.xsl -in /npac/home/msen7/t.xml
-->
<!--  <xsl:if test="name='color'">
      <H1><xsl:value-of select="value"/></H1>
    </xsl:if>

-->











