<?xml version="1.0"?> 
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
   xmlns="http://www.w3.org/TR/REC-html40" 
   xmlns:lxslt="http://xsl.lotus.com/"
result-ns="">
   
<!-- ============================================================ -->
   <xsl:template match="/">
<!-- ============================================================ -->
   <xsl:variable name="quizzes" expr="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuizzes/?unum={/course/user/unum}&amp;course={/course/coursename}&amp;quizname="/>
   <xsl:variable name="questions" expr="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuestions/?unum={/course/user/unum}&amp;course={/course/coursename}&amp;quizname="/>
   <xsl:variable name="grader" expr="{/course/global/host}/{/course/global/servlet}/gs.admin.xQGrader/?unum={/course/user/unum}&amp;course={/course/coursename}&amp;quizname="/>

      <HTML>
	 <head>
	    <SCRIPT LANGUAGE="JavaScript"><![CDATA[
	       function switchQuestions(){
	       //alert("reload");
	       }
	       ]]>
	    </SCRIPT>
	 </head>
	 <BODY bgcolor="GreenYellow">
	    <center>
	       <xsl:apply-templates select="course/layouts"/>
	       <xsl:call-template name="header"/>
	       <TABLE WIDTH="100%" ALIGN="center" BORDER="1">
		  <TR>
		     <TH colspan="2" bgcolor="LemonChiffon"> 
			<xsl:value-of select="course/coursename"/>
			Quizzes 
		     </TH> 
		  </TR>
		  <xsl:apply-templates select="course/quiz">
		     <xsl:sort select="quizname"/>
		  </xsl:apply-templates>
	       </TABLE>
	       <i>Click on the name of the quiz to proceed.</i>
	    </center>
	 </BODY>
      </HTML>
   </xsl:template>
   

   
<!-- ============================================================ -->
   <xsl:template match="quiz" >
      <tr>
	 <td align="center">
	    <!--xsl:number level="single" count="quiz" format="1. "/-->
	    <A href="{$quizzes}{quizname}&amp;comm=SHOWQUIZ" target="info"><xsl:value-of select="quizname"/></A>
	 </td>
	 <td align="center" bgcolor="green">
	    <A href="{$questions}{quizname}&amp;comm=LISTQUESTIONS"     ><font face="helvetica" color="yellow" size="-2">Questions</font></A>
	    <A href="{$grader}{quizname}&amp;comm=LISTQUESTIONSCORES-I" ><font face="helvetica" color="white"  size="-2">Results</font></A>
	 </td>
      </tr>
   </xsl:template>
   

<!-- *============================================================ -->
   <xsl:template match="course/layouts" >
      
      <table width="100%">
	 <tr>
	    <th bgcolor="#ccffff">
	       <xsl:value-of select="current/quizLIST/@xname"/>
	       <br>
	       </br> 
	       <xsl:apply-templates select="quizLIST">
		  <xsl:sort select="@xname" />
	       </xsl:apply-templates>
	    </th>
	 </tr>
      </table>

   </xsl:template>
<!-- *============================================================ -->   
   <xsl:template match="quizLIST" >

      [<A href="http://{./@xfile}"> <xsl:value-of select="./@xname"/>  </A>]

   </xsl:template>
   
<!-- *============================================================ -->   
   <xsl:template name="header" >
      <table width="100%">
	 <tr>
	    <td bgcolor="blue" align="center">
	       <font face="helvetica" size="+1" color="white"> 
		  <b>Quizzes </b>
	       </font>
	    </td>
	 </tr>
	 <tr><td bgcolor="white" align="center">
	    <form><font color="blue">
	       <b>
		  <samp><input type="button" value="ADD" onClick="add()"/>
		  <a href="{/course/global/help}/quiz.html" target="help">
		     <img src="{/course/global/images}/mans.gif" border="0" align="ABSCENTER"/>
		  </a>
		  <input type="button" value="BACK" onClick="top.history.back()"/></samp> 
	       </b></font>
	    </form>
	 </td></tr>
      </table>
      
   </xsl:template>
   
</xsl:stylesheet>





