<?xml version="1.0"?> 

<!--xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl"-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0"
   xmlns="http://www.w3.org/TR/REC-html40" 
   xmlns:lxslt="http://xsl.lotus.com/"
result-ns="">
  
   <xsl:template match="/">
      <HTML>
	 <head>
	    <SCRIPT LANGUAGE="JavaScript"> 
	       var first=true;
	       var host="<xsl:value-of select="course/global/host"/>/<xsl:value-of select="course/global/servlet"/>";
	       var quizname="<xsl:value-of select="course/quiz/quizname"/>";
	       var coursename="<xsl:value-of select="course/coursename"/>";
	       var user="<xsl:value-of select="course/user/unum"/>";
	       <![CDATA[
		  function flag(qid){
		  if (first)
		  if( confirm("Do you really want to submit the exam?"))
		  document.location=host+"/gs.admin.xTakeExam?comm=LISTQUESTIONS&unum="+user+"&course="+coursename+"&quizname="+quizname;
		  first=false;
		  }
		  
		  function switchQuestionBank(){}
		  function prepareExam(){}
		  function getFromDB(){
		  document.location=host+"/gs.admin.xQuestionBank?comm=QUESTIONBANKLIST&unum="+user+"&course="+coursename+"&quizname="+quizname;
		  top.info.document.location=host+"/gs.admin.xQuestionBank/HtdocsGrdSys/qb/info.xsl?comm=RETURN&unum="+user+"&course="+coursename+"&quizname="+quizname;
		  }
		  function init() { 
		    top.info.document.location=host+"/gs.admin.xQGrader?comm=QUIZRESULTS&unum="+user+"&course="+coursename+"&quizname="+quizname;
		  }
		  
		  ]]>
	       </SCRIPT>
         </head>
	 <BODY bgcolor="yellow" onLoad="init()">  
	    <xsl:apply-templates select="course/layouts"/>
	    <xsl:call-template name="header"/>
	    <nobr>
	    <TABLE WIDTH="100%" ALIGN="center" BORDER="1">
	       <TR>
		  <TH colspan="3" bgcolor="LemonChiffon"> <xsl:value-of select="course/coursename"/> <s/><font color="blue">
		     <xsl:value-of select="course/quiz/quizname"/></font> 
		     Results 
		  </TH> 
	       </TR>
	       <form name="exam" 
		  action="{/course/global/host}/{/course/global/servlet}/gs.admin.xQGrader"
		  method="POST"
		  >
		  <TR>
		  <input type="hidden" name="unum"  value="{/course/user/unum}"/>
		  <input type="hidden" name="course" value="{/course/coursename}"/>
		  <input type="hidden" name="quizname" value="{/course/quiz/quizname}"/>
		  <input type="hidden" name="comm" value="LISTSTUDENTS"/>
		  
		     <TH colspan="3" bgcolor="red"><nobr><font face="Helvetica" color="white"><b><input type="button" value=" quiz grades " onClick=" init() " /><input type="button" name="x" value=" students" onClick="this.form.submit()"/></b></font></nobr></TH>
		  </TR>
		  <xsl:apply-templates select="course/quiz/question" >
		     <xsl:sort select="qid" data-type="number"/>
		  </xsl:apply-templates>
		  <TR>
		     <TH colspan="3" bgcolor="red"><nobr><font face="Helvetica" color="white"><b><input type="button" value=" quiz grades " onClick=" init() " /><input type="button" name="y" value=" students" onClick="this.form.submit()"/></b></font></nobr></TH>
		  </TR>	       
	       </form>
	    </TABLE>
	 </nobr>
	 </BODY>
      </HTML>
   </xsl:template>

   <xsl:variable name="gurl" ><xsl:value-of select="/course/global/host"/>/<xsl:value-of select="/course/global/servlet"/>/gs.admin.xQGrader?unum=<xsl:value-of select="/course/user/unum"/>&amp;course=<xsl:value-of select="/course/coursename"/>&amp;quizname=<xsl:value-of select="/course/quiz/quizname"/>&amp;comm=QUESTIONRESULTS&amp;qid=</xsl:variable>

   <xsl:variable name="qurl" ><xsl:value-of select="/course/global/host"/>/<xsl:value-of select="/course/global/servlet"/>/gs.admin.xQuestions?unum=<xsl:value-of select="/course/user/unum"/>&amp;course=<xsl:value-of select="/course/coursename"/>&amp;quizname=<xsl:value-of select="/course/quiz/quizname"/>&amp;comm=JUSTQUESTION&amp;qid=</xsl:variable>

   <xsl:variable name="image" ><xsl:value-of select="/course/global/images"/>/</xsl:variable>
<!-- ===========================================<font size="+1" color="red"><b>?</b></font>================= -->
   <xsl:template match="question" >
      <tr>
	 <td align="center"><font color="red" size="-1"><xsl:value-of select="category"/></font></td>
	 <td bgcolor="LemonChiffon"><font color="red" size="-1"><xsl:value-of select="qid"/>.  <A href="{$gurl}{qid}" target="info"><xsl:value-of select="qtitle"/></A></font></td>
	 <td align="center" bgcolor="brown"><A href="{$qurl}{qid}"  target="info" ><img src="{$image}question.gif" border="0" align="ABSCENTER" width="28" height="28" alt="See Question"/></A></td>
      </tr>
   </xsl:template>
   
<!-- <A href="{/course/global/host}/{/course/global/servlet}/gs.admin.xQuestions/?quizname={/course/quiz/quizname}&amp;course={/course/coursename}&amp;comm=JUSTQUESTION&amp;unum={/course/user/unum}&amp;qid={qid}"  target="info"><font size="+1" color="yellow"><b><img src="{/course/global/images}/q.gif" width="10" height="10" border="0"/></b></font></A> -->
<!-- *============================================================ -->
   <xsl:template match="course/layouts" >
      
      <table width="100%">
	 <tr>
	    <th bgcolor="#ccffff">
	       <xsl:value-of select="current/questionLIST/@xname"/>
	       <br>
	       </br> 
	       <xsl:apply-templates select="questionLIST">
		  <xsl:sort select="@xname" />
	       </xsl:apply-templates>
	    </th>
	 </tr>
      </table>

   </xsl:template>

<!-- *============================================================ -->   
   <xsl:template match="questionLIST" >

      [<A href="http://{./@xfile}"> <xsl:value-of select="./@xname"/>  </A>]

   </xsl:template>

<!-- *============================================================ -->   

<!-- *============================================================ -->   
   <xsl:template name="header" >
      <table width="100%">
	 <tr><td bgcolor="blue" align="center"><font face="helvetica" size="+1" color="white"> <b>Questions </b></font></td></tr>
	 <tr><form><td bgcolor="white" align="center">
	    <table>
	       <tr>
		  <td><a href="{/course/global/help}/question.html" target="help">
		     <img src="{/course/global/images}/mans.gif" border="0" align="ABSCENTER"/>
		  </a></td>
		     <td><samp><b><font color="blue">
			<input type="button" value="BACK" onClick=" self.history.go(-1); "/>
			<input type="button" value="RELOAD" onClick=" document.location.reload(); "/>
		     </font></b></samp></td>
	       </tr>
	    </table>
	 </td></form></tr>
      </table>
   </xsl:template>

<!-- *============================================================ -->   


   
</xsl:stylesheet>

