package com.lotus.xsl;

/**
 * This class holds information about the namespace info
 * of a node.
 */
class NSInfo
{
  public NSInfo(boolean hasProcessedNS, boolean hasXMLNSAttrs)
  {
    m_hasProcessedNS = hasProcessedNS;
    m_hasXMLNSAttrs = hasXMLNSAttrs;
    m_namespace = null;
    m_ancestorHasXMLNSAttrs = ANCESTORXMLNSUNPROCESSED;
  }

  // Unused at the moment
  public NSInfo(boolean hasProcessedNS, boolean hasXMLNSAttrs, int ancestorHasXMLNSAttrs)
  {
    m_hasProcessedNS = hasProcessedNS;
    m_hasXMLNSAttrs = hasXMLNSAttrs;
    m_ancestorHasXMLNSAttrs = ancestorHasXMLNSAttrs;
    m_namespace = null;
  }

  public NSInfo(String namespace, boolean hasXMLNSAttrs)
  {
    m_hasProcessedNS = true;
    m_hasXMLNSAttrs = hasXMLNSAttrs;
    m_namespace = namespace;
    m_ancestorHasXMLNSAttrs = ANCESTORXMLNSUNPROCESSED;
  }

  String m_namespace;
  boolean m_hasXMLNSAttrs;
  boolean m_hasProcessedNS;
  int m_ancestorHasXMLNSAttrs;
  
  static final int ANCESTORXMLNSUNPROCESSED = 0;
  static final int ANCESTORHASXMLNS = 1;
  static final int ANCESTORNOXMLNS = 2;
}
