/**
 * $Id: XMLSourceInfo.java,v 1.2 1998/12/10 03:11:51 sboag Exp $
 * 
 * Copyright (c) 1998-1999 Lotus Corporation, Inc. All Rights Reserved.
 *				This software is provided without a warranty of any kind.
 * 
 * $State: Exp $
 * 
 * @author Scott Boag (scott_boag@lotus.com)
 */
package com.lotus.xsl;

//XMLSourceInfo.java

/**
 * This interface may be implemented by XSL output classes 
 * that are DOM node derivatives, to point back to the originating 
 * source XML elements.  
 * Mainly for use with authoring applications.
 * @deprecated
 */
public interface XMLSourceInfo
{
  /**
   * Set the originating source element reference.
   */
  public void setXMLSourceNode(org.w3c.dom.Node el);
  
  /**
   * Get the originating source element reference.  This may 
   * easily return NULL!  Not all output elements will be 
   * sourced from the XML, but may instead be a sole fabrication
   * of the XSL sheet.
   */
  public org.w3c.dom.Node getXMLSourceNode();
}

/**
 * $Log: XMLSourceInfo.java,v $
 * Revision 1.2  1998/12/10 03:11:51  sboag
 * LotusXSL Version 13a
 *
 */
