<?xml version="1.0"?> 

<!-- stylesheet for testing basic selection -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">
  <!-- xsl:include href="html_output_default.xsl"/ -->

  <!-- Root template - start processing here -->
  <xsl:template match="/">
    <HTML>
      <HEAD>
        <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
        <META http-equiv="Expires" content="0"/>
      </HEAD>
      <BODY>
		    <xsl:apply-templates/>
      </BODY>
    </HTML>
  </xsl:template>

  <xsl:template match="doc">
    <H1>Test of basic selection and query returned in document order</H1>
    <HR/>
		<P>This should come out doremefasolatido:</P>
		<P><xsl:apply-templates select="me | do | fa | blah/re[@test='true']"/></P>
    <HR/>
		<P>This should come out do-do-re-re1--re2--re3-me-me1--me2--me3-fasolatido-fa--so-:</P>
		<P><xsl:apply-templates select="re/@re2 | me | do | fa/so/@so | fa | blah/re[@test='true'] | re/@re1 | me/@* | re/@re3 | fa/@fa | do/@do"/></P>
    <HR/>
		<P>This should come out renot-re:</P>
		<P><xsl:apply-templates select=".//re[@test]"/></P>
    <HR/>
		<P>This should come out abcde:</P>
		<P><xsl:apply-templates select="*//d | c | *//e | x/y/z/b | a"/></P>
    <HR/>
		<P>This should come out abcde:</P>
		<P><xsl:apply-templates select="a | x/y/z/b | c | *//d | *//e"/></P>
    <HR/>
		<P>This should come out abcde:</P>
		<P><xsl:apply-templates select="*//e | *//d | c | x/y/z/b | a"/></P>
    <HR/>
  </xsl:template>

  <xsl:template match="d | c | e | b | a">
 		<xsl:apply-templates select="t"/>
  </xsl:template>

  <xsl:template match="t">
 		<xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="@*">
 		<xsl:value-of select="."/>
  </xsl:template>
  
</xsl:stylesheet>