<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="doc" priority="10">
      <H1>Test for conflict Resolution - nodetest override of default priority. </H1>
      <P>Also, node selected is attribute instead of element.</P>
      <P>No conflict warnings should be seen.</P>
      <HR/>
      <P>Should say "Match of node type":</P>
      <P><xsl:apply-templates select="foo/@test"/></P>
  </xsl:template>
  
  <xsl:template match="foo">
    Match of qualified name.
  </xsl:template>

  <xsl:template match="*">
    Match of wildcard.
  </xsl:template>

  <xsl:template match="node()" priority="1">
    Match of node type.
  </xsl:template>

</xsl:stylesheet>
