@echo **********************************************************
@echo   Testing position() function expressions 
@echo **********************************************************
@echo Test for conflict Resolution - simple qualified names.
@echo Should see no conflict resolution warnings.
call test cnfr cnfr01
@echo ----------------------------------------------------------
@echo Test for conflict Resolution - wildcard names. 
@echo Should see 1 conflict resolution warning.
call test cnfr cnfr02
@echo ----------------------------------------------------------
@echo Test for conflict Resolution - nodetype. 
@echo Should see 1 conflict resolution warning.
call test cnfr cnfr03
@echo ----------------------------------------------------------
@echo Test for conflict Resolution - nodetest override of default priority.
@echo Should see no conflict resolution warnings.
call test cnfr cnfr04
@echo ----------------------------------------------------------
@echo Test for conflict Resolution - non-simple ('/').
@echo Should see no conflict resolution warnings.
call test cnfr cnfr05
@echo ----------------------------------------------------------
@echo Test for conflict Resolution - non-simple (predicate).
@echo Should see no conflict resolution warnings.
call test cnfr cnfr06
@echo ----------------------------------------------------------
@echo Test for conflict Resolution - 2 non-simples (predicate and '/').
@echo Should see 1 conflict resolution warning.
call test cnfr cnfr07
@echo ----------------------------------------------------------
@echo Test for conflict Resolution - 2 non-simples ('/' and predicate).
@echo Should see 1 conflict resolution warning.
call test cnfr cnfr08
@echo **********************************************************
