package testSuite.EXT;

import org.w3c.dom.*;

public class EntityRef
{
  static public DocumentFragment entityRef(DocumentFragment factory, String name)
  {
    DocumentFragment returnVal;
    if(null != factory)
    {
      Document doc = factory.getOwnerDocument();
      returnVal = doc.createDocumentFragment();
      returnVal.appendChild(doc.createEntityReference(name));
    }
    else
    {
      returnVal = null;
    }
    return returnVal;
  }
  
  static public DocumentFragment entityRef(DocumentFragment frag)
  {
    DocumentFragment returnVal;
    if(null != frag)
    {
      NodeList fragChildren = frag.getChildNodes();
      if((null != fragChildren) && fragChildren.getLength() > 0)
      {
        Document factory = frag.getOwnerDocument();
        returnVal = factory.createDocumentFragment();
        Text t = (Text)fragChildren.item(0);
        returnVal.appendChild(factory.createEntityReference(t.getData()));
      }
      else
      {
        returnVal = null;
      }
    }
    else
    {
      returnVal = null;
    }
    return returnVal;
  }
}
