<?xml version="1.0"?> 

<!-- Test for macros and macro args -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">
  
  <xsl:template match="catalog.entry">
    <H1>Test for doc() function selection and pattern matching.</H1>
    <P>Distributer should be "CompUSA Inc.", with address displayed, the street number in italics. </P>
    <P><B>Catalogue ID: </B> <xsl:apply-templates select="catalog.entry.id"/></P>
    <B>Distributer: </B> <xsl:apply-templates 
      select="doc(catalog.operator.pointer/url.reference/@url.string)/market.participant/business.identity.group/business.name"/>
      <BR dummy="" />
    <xsl:apply-templates select="doc('..\IDKY\compu.xml')/market.participant/address.set/*"/>
  </xsl:template>
  
  <xsl:template match="doc('..\IDKY\compu.xml')//location.in.street" priority="2">
    <I><xsl:apply-templates/></I>
  </xsl:template>

  <xsl:template match="location.in.street">
    **<xsl:apply-templates/>**
  </xsl:template>

  <xsl:template match="street">
    <xsl:apply-templates/><BR dummy="" />
  </xsl:template>

  <xsl:template match="city">
    <xsl:apply-templates/><xsl:text>, </xsl:text>
  </xsl:template>

  <xsl:template match="country.subentity">
    <xsl:apply-templates/><xsl:text> </xsl:text>
  </xsl:template>

  <xsl:template match="postcode">
    <xsl:apply-templates/><BR dummy="" />
  </xsl:template>

  <xsl:template match="telephone.number">
    Voice: <xsl:apply-templates/>
  </xsl:template>
       
</xsl:stylesheet>