<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template name="ntmp1">
    <xsl:param-variable name="pvar1">Default text in pvar1</xsl:param-variable>
    <xsl:param-variable name="pvar2">Default text in pvar2</xsl:param-variable>
    <xsl:value-of select="$pvar1"/>, 
    <xsl:value-of select="$pvar2"/>
  </xsl:template>
  
  <xsl:template match="doc">
    <HTML>
      <H1>General test for xsl:call-template.</H1>
      <HR/>
      <xsl:variable name="ResultTreeFragTest">
        <B>Data from doc/a: <xsl:value-of select="a"/></B>
      </xsl:variable>
      <P>Should say "<B>Data from doc/a: test</B>, Default text in pvar2":</P>
      <P>
      <xsl:call-template name="ntmp1">
        <xsl:param name="pvar1" expr="$ResultTreeFragTest"/>
      </xsl:call-template>
      </P>
    </HTML>
  </xsl:template>
 
</xsl:stylesheet>
