<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template name="ntmp1" match="doc/doc">
    <xsl:param-variable name="pvar1">Default text in pvar1</xsl:param-variable>
    <xsl:param-variable name="pvar2">Default text in pvar2</xsl:param-variable>
    <xsl:value-of select="$pvar1"/>, 
    <xsl:value-of select="$pvar2"/>,
    <xsl:value-of select="a"/>
  </xsl:template>
  
  <xsl:template match="doc">
    <HTML>
      <H1>Test for xsl:call-template with both match and name</H1>
      <HR/>
      <xsl:variable name="ResultTreeFragTest">
        <B>Data from doc/a: <xsl:value-of select="a"/></B>
      </xsl:variable>
      <P>Should say "<B>Data from doc/a: top-level-a</B>, Called with xsl:call-template, top-level-a":</P>
      <P>
      <xsl:call-template name="ntmp1">
        <xsl:param name="pvar1" expr="$ResultTreeFragTest"/>
        <xsl:param name="pvar2" expr="'Called with xsl:call-template'"/>
      </xsl:call-template>
      </P>
      <HR/>
      <P>Should say "<B>Data from doc/a: top-level-a</B>, Called with xsl:apply-templates, sub-level-a":</P>
      <P>
      <xsl:apply-templates select="doc">
        <xsl:param name="pvar1" expr="$ResultTreeFragTest"/>
        <xsl:param name="pvar2" expr="'Called with xsl:apply-templates'"/>
      </xsl:apply-templates>
      </P>
    </HTML>
  </xsl:template>
 
</xsl:stylesheet>