<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:key name="k" match="a" use="@test"/>
  <xsl:key name="k2" match="a" use="num"/>

  <xsl:template match="doc">
      <H1>Test for select last().</H1>
      <HR/>
      <P>(last() test with *) Should say "h":</P>
      <P><xsl:value-of select="*[last()=position()]"/></P>
      <HR/>
      <P>(last() test with *) Should say "h":</P>
      <P><xsl:value-of select="*[last()]"/></P>
      <HR/>
      <P>(last() test with key()) Should say "g":</P>
      <P><xsl:value-of select="key('k', 'true')[last()=position()]"/></P>
      <HR/>
      <P>(last() test with key()) Should say "g":</P>
      <P><xsl:value-of select="key('k', 'true')[last()]"/></P>
      <HR/>
      <P>(last() test with separate predicate test) Should say "e":</P>
      <P><xsl:value-of select="*[not(@test)][last()=position()]"/></P>
      <HR/>
      <P>(last() test with separate predicate test) Should say "e":</P>
      <P><xsl:value-of select="*[not(@test)][last()]"/></P>
  </xsl:template>
  
</xsl:stylesheet>
