<?xml version="1.0"?> 

<xsl:stylesheet xmlns:xsl="http://www.w3.org/XSL/Transform/1.0">

  <xsl:template match="/">
    <HTML>
      <H1>Test for string().</H1>
      <P>Warning about not-a-reference variable is normal.</P>
      <HR/>
      <P>Should say "Test" (node-set to string): <xsl:value-of select="string(doc)"/></P>
      <P>Should say "" (empty node-set to string): <xsl:value-of select="string(foo)"/></P>
      <P>Should say "0" (number to string): <xsl:value-of select="string(0)"/></P>
      <P>Should say "2" (zero to string): <xsl:value-of select="string(2)"/></P>
      <P>Should say "test"  (string to string): <xsl:value-of select="string('test')"/></P>
      <P>Should say "" (empty string to string): <xsl:value-of select="string('')"/></P>
      <xsl:variable name="ResultTreeFragTest">
        <xsl:value-of select="doc"/>
      </xsl:variable>
      <xsl:variable name="emptyResultTreeFragTest">
        <xsl:value-of select="foo"/>
      </xsl:variable>
      <P>Should say "Test" (result-tree-fragment to string): 
        <xsl:value-of select="string($ResultTreeFragTest)"/></P>
      <P>Should say "" (empty result-tree-fragment to string): 
        <xsl:value-of select="string($emptyResultTreeFragTest)"/></P>
      <P>Should say "" (non-existent variable to string): 
        <xsl:value-of select="string($not-a-reference)"/></P>
    </HTML>
  </xsl:template>
 
</xsl:stylesheet>
