@ECHO OFF
REM Revision: %M% %I% %W% %Q%

SET SAXFILES=org\xml\sax
SET FRAMEWORKFILES=com\ibm\xml\framework
SET DOMFILES=org\w3c\dom
SET DOMIMPLFILES=com\ibm\xml\dom %DOMFILES%
SET TXFILES=com\ibm\xml\parser com\ibm\xml\xpointer %DOMFILES%
SET VALIDATIONFILE=com\ibm\xml\internal\DefaultValidationHandler.class

SET INTERNALFILES=com\ibm\xml\internal\CMBinOp.class com\ibm\xml\internal\CMException.class com\ibm\xml\internal\CMLeaf.class com\ibm\xml\internal\CMNode.class com\ibm\xml\internal\CMStateSet.class com\ibm\xml\internal\CMUniOp.class com\ibm\xml\internal\CharReader$CharDataChunk.class com\ibm\xml\internal\CharReader.class com\ibm\xml\internal\DFAContentModel.class com\ibm\xml\internal\DefaultAttrPool.class com\ibm\xml\internal\DefaultCatalog.class com\ibm\xml\internal\DefaultElementDeclPool.class com\ibm\xml\internal\DefaultEntityHandler.class com\ibm\xml\internal\DefaultEntityPool.class com\ibm\xml\internal\DefaultScanner$StopException.class com\ibm\xml\internal\DefaultScanner.class com\ibm\xml\internal\DefaultStringPool.class com\ibm\xml\internal\EBCDICRecognizer.class com\ibm\xml\internal\ErrorCode.class com\ibm\xml\internal\InvalidEncodingException.class com\ibm\xml\internal\MIME2Java.class com\ibm\xml\internal\MixedContentModel.class com\ibm\xml\internal\SimpleContentModel.class com\ibm\xml\internal\StringHasher.class com\ibm\xml\internal\StringReader.class  com\ibm\xml\internal\UCSReader.class com\ibm\xml\internal\UCSRecognizer.class com\ibm\xml\internal\UTF8CharReader$UTF8CharDataChunk.class com\ibm\xml\internal\UTF8CharReader.class com\ibm\xml\internal\UTF8Reader$UTF8DataChunk.class com\ibm\xml\internal\UTF8Reader.class com\ibm\xml\internal\UTF8Recognizer.class com\ibm\xml\internal\XMLDeclReader.class com\ibm\xml\internal\msg\Message.class 

SET BASEFILES=%SAXFILES% %FRAMEWORKFILES% %INTERNALFILES%

SET NVSAXFILES=%BASEFILES% com\ibm\xml\parsers\SAXParser.class

SET VSAXFILES=%NVSAXFILES% %VALIDATIONFILE% com\ibm\xml\parsers\ValidatingSAXParser.class

SET NVDOMFILES=%BASEFILES% %DOMIMPLFILES% com\ibm\xml\parsers\NonValidatingDOMParser.class

SET VDOMFILES=%NVDOMFILES% %VALIDATIONFILE% com\ibm\xml\parsers\DOMParser.class

SET NVTXDOMFILES=%BASEFILES% %TXFILES% com\ibm\xml\parsers\NonValidatingTXDOMParser.class

SET VTXDOMFILES=%NVTXDOMFILES% %VALIDATIONFILE% com\ibm\xml\parsers\TXDOMParser.class

if .%1 == .SAX SET FILES=%NVSAXFILES%
if .%1 == .VSAX SET FILES=%VSAXFILES%
if .%1 == .DOM SET FILES=%VDOMFILES%
if .%1 == .NVDOM SET FILES=%NVDOMFILES%
if .%1 == .TXDOM SET FILES=%VTXDOMFILES%
if .%1 == .NVTXDOM SET FILES=%NVTXDOMFILES%

if .%2 == .TXCATALOG SET FILES=%FILES% com\ibm\xml\internal\TXCatalog.class
if .%2 == .XCATALOG SET FILES=%FILES% com\ibm\xml\internal\XCatalog$Parser$Resolver.class com\ibm\xml\internal\XCatalog$Parser.class com\ibm\xml\internal\XCatalog.class

jar cvf custom.jar %FILES%
