/*
 * (C) Copyright IBM Corp. 1998,1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */
package ui;

/*
 *
 * command line invocation wrapper for TreeViewer
 *
 * @version Revision: 94 1.10 samples/ui/TreeViewer.java, samples, xml4j2
 */

public class TreeViewer {

	public TreeViewer() {
		System.out.println("TreeViewer is no longer an instantiable class.  Please use XMLTreeView instead.");
		throw new RuntimeException();
	}

	public TreeViewer(String title, String filename) {
		System.out.println("TreeViewer is no longer an instantiable class.  Please use XMLTreeView instead.");
		throw new RuntimeException();
	}

    public static void main(String[] argv) {
        try {
			Class.forName("javax.swing.JFrame");
        } catch (ClassNotFoundException cnfe) {
			System.out.println("Couldn't load class javax.swing.JFrame.");
			System.out.println("This sample now uses Swing version 1.1.  Couldn't find the Swing 1.1 classes, please check your CLASSPATH settings.");
			System.exit(1);
		}

		TreeView.main(argv);
    }

}

