/*
 * (C) Copyright IBM Corp. 1998,1999  All rights reserved.
 *
 * US Government Users Restricted Rights Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * The program is provided "as is" without any warranty express or
 * implied, including the warranty of non-infringement and the implied
 * warranties of merchantibility and fitness for a particular purpose.
 * IBM will not be liable for any damages suffered by you as a result
 * of using the Program. In no event will IBM be liable for any
 * special, indirect or consequential damages or lost profits even if
 * IBM has been advised of the possibility of their occurrence. IBM
 * will not be liable for any third party claims against you.
 */

package com.ibm.xml.framework;

/**
 * Parameter object for the AttrPool.addAttr() method.
 *
 * @version Revision: 62 1.4 src/com/ibm/xml/framework/Attr.java, parser, xml4j2, xml4j2_0_13 
 */
public class Attr {
    //
    // Public instance variables - fill these in for each call to addAttr.
    //
    public int attName;        // Attribute name
    public int attType;        // Attribute type (see AttDef)
    public int attValue;       // Attribute value
    public boolean specified;  // <code>true</code> if this attribute appeared in the element;
                               // <code>false</code> if it was defaulted from an AttDef.
};
